       subroutine compute_virt(pin, m2i0, m2i, qcdcorr)
          use recola
          use quarklabels
          implicit none
#include "mcinput.h"
          real(kind (23d0)), intent(in) :: pin(5,0:3)
          logical, intent(in) :: qcdcorr  ! compute qcd correction if
                                          ! true, else ew corrections
          real(kind (23d0)) :: p(0:3,5), k(0:3,5)
          real(kind (23d0)), intent(inout) :: m2i0(-5:5,-5:5)
          real(kind (23d0)), intent(inout) :: m2i(-5:5,-5:5)
          real(kind (23d0)) :: matrix2(2),sth,cth
          logical           :: CKM_nondiagonal

          m2i0 = 0d0
          m2i = 0d0
          if (sinthetacin .ne. 0d0) then
            CKM_nondiagonal = .true.
            sth = sinthetacin
            cth = cos(asin(sinthetacin))
          else
            CKM_nondiagonal = .false.
          end if

          p(:,1) = pin(1,:)
          p(:,2) = pin(2,:)
          p(:,3) = pin(3,:)
          p(:,4) = pin(4,:)
          p(:,5) = pin(5,:)

          if (qcdcorr) then
#ifdef RECOLA2
            call switch_global_cache_rcl(1)
#endif
            call compute_process_rcl(37, p, "NLO", matrix2)
          else
#ifdef RECOLA2
            call switch_global_cache_rcl(2)
#endif
            call compute_process_rcl(35, p, "NLO", matrix2)
          end if
          m2i0(in11,in12) = 36d0*matrix2(1)
          m2i(in11,in12) = 36d0*matrix2(2)
          
          if (qcdcorr) then
            call compute_process_rcl(38, p, "NLO", matrix2)
          else
            call compute_process_rcl(36, p, "NLO", matrix2)
          end if
          m2i0(in21,in22) = 36d0*matrix2(1)
          m2i(in21,in22) = 36d0*(matrix2(2))

          if (CKM_nondiagonal .and. n_in_states .ne. 4) then
            m2i0(in21,in12) = m2i0(in11,in12)*sth**2
            m2i0(in11,in22) = m2i0(in21,in22)*sth**2
            m2i(in21,in12) = m2i(in11,in12)*sth**2
            m2i(in11,in22) = m2i(in21,in22)*sth**2

            m2i0(in11,in12) = m2i0(in11,in12)*cth**2
            m2i0(in21,in22) = m2i0(in21,in22)*cth**2
            m2i(in11,in12) = m2i(in11,in12)*cth**2
            m2i(in21,in22) = m2i(in21,in22)*cth**2
          end if

          if (n_in_states .eq. 4) then
            if (qcdcorr) then
              call compute_process_rcl(77, p, "NLO", matrix2)
            else
              call compute_process_rcl(75, p, "NLO", matrix2)
            end if
            m2i0(in31,in32) = 36d0*matrix2(1)
            m2i(in31,in32) = 36d0*(matrix2(2))
            
            if (qcdcorr) then
              call compute_process_rcl(78, p, "NLO", matrix2)
            else
              call compute_process_rcl(76, p, "NLO", matrix2)
            end if
            m2i0(in41,in42) = 36d0*matrix2(1)
            m2i(in41,in42) = 36d0*(matrix2(2))
          end if

          ! interchange incoming quarks
          k(:,1) = p(:,2)
          k(:,2) = p(:,1)
          k(:,3:) = p(:,3:)
          if (qcdcorr) then
            call compute_process_rcl(37, k, "NLO", matrix2)
          else
            call compute_process_rcl(35, k, "NLO", matrix2)
          end if
          m2i0(in12,in11) = 36d0*matrix2(1)
          m2i(in12,in11) = 36d0*(matrix2(2))

          if (qcdcorr) then
            call compute_process_rcl(38, k, "NLO", matrix2)
          else
            call compute_process_rcl(36, k, "NLO", matrix2)
          end if
          m2i0(in22,in21) = 36d0*matrix2(1)
          m2i(in22,in21) = 36d0*(matrix2(2))

          if (CKM_nondiagonal .and. n_in_states .ne. 4) then
            m2i0(in12,in21) = m2i0(in12,in11)*sth**2
            m2i0(in22,in11) = m2i0(in22,in21)*sth**2
            m2i(in12,in21) = m2i(in12,in11)*sth**2
            m2i(in22,in11) = m2i(in22,in21)*sth**2

            m2i0(in12,in11) = m2i0(in12,in11)*cth**2
            m2i0(in22,in21) = m2i0(in22,in21)*cth**2
            m2i(in12,in11) = m2i(in12,in11)*cth**2
            m2i(in22,in21) = m2i(in22,in21)*cth**2
          end if

          if (n_in_states .eq. 4) then
            if (qcdcorr) then
              call compute_process_rcl(77, k, "NLO", matrix2)
            else
              call compute_process_rcl(75, k, "NLO", matrix2)
            end if
            m2i0(in32,in31) = 36d0*matrix2(1)
            m2i(in32,in31) = 36d0*(matrix2(2))

            if (qcdcorr) then
              call compute_process_rcl(78, k, "NLO", matrix2)
            else
              call compute_process_rcl(76, k, "NLO", matrix2)
            end if
            m2i0(in42,in41) = 36d0*matrix2(1)
            m2i(in42,in41) = 36d0*(matrix2(2))
          end if
        end subroutine compute_virt
