      subroutine init_recola_param
        use recola
        implicit none
 
#include "mcinput.h"

        real(kind (23d0))  :: aEW
        character(len=100) :: modelname
        real(kind (23d0)), parameter :: pi = 3.141592653589793238462643d0

        call get_modelname_rcl(modelname)

        call set_print_level_parameters_rcl(2)
        call set_alphas_rcl(alphasin,mumsin,5)
        ! Gf = aEW*pi/(MW**2*sw**2*sqrt(2))
        ! -> aEW = Gf/pi*MW**2*sw**2*sqrt(2)
        aEW = GFin/pi*mwin**2d0*(1d0-mwin**2d0/mzin**2d0)*
     &       sqrt(2d0)
        call use_gfermi_scheme_rcl(a=aEW)

        call set_cache_mode_rcl(2)
        call set_global_cache_rcl(2)

        call set_pole_mass_z_rcl(mzin,gzin)
        call set_pole_mass_w_rcl(mwin,gwin)
        if (modelname .eq. 'SM') then
          call set_pole_mass_h_rcl(mhin,0d0)
        end if 

        call set_pole_mass_electron_rcl(mein)
        call set_pole_mass_muon_rcl(mmuin,0d0)
        call set_pole_mass_tau_rcl(mtauin,0d0)
        call set_pole_mass_up_rcl(muin)
        ! charm mass == up mass
        call set_pole_mass_charm_rcl(muin,0d0)
        call set_pole_mass_top_rcl(mtin,0d0)
        call set_pole_mass_down_rcl(mdin)
        ! strange mass == down mass
        call set_pole_mass_strange_rcl(mdin)
        call set_pole_mass_bottom_rcl(mbin,0d0)
        call set_light_fermions_rcl(3d0)

        call set_mu_uv_rcl(mwin)
        call set_mu_ir_rcl(lambdain)
        call set_mu_ms_rcl(mumsin)
        call set_delta_uv_rcl(0d0)
        call set_delta_ir_rcl(0d0,0d0)

C       HS parameters
        if (modelname .eq. 'HS') then
          call set_parameter_rcl("muMS_BSM", mumsbsmin*dcmplx(1d0,0d0))
          call set_sa_rcl(sain)
          call set_parameter_rcl("l3", l3in*dcmplx(1d0,0d0))
          call set_pole_mass_hl_hh_rcl(mhin,0d0,mhhin,0d0)
          select case (trim(mixrsin))
          case ('FJ')
            call use_mixing_alpha_msbar_scheme_rcl('FJ')
          case ('PR')
            call use_mixing_alpha_msbar_scheme_rcl('PR')
          case ('OS')
            call use_mixing_alpha_onshell_scheme_rcl('OS')
          case ('BFM')
            call use_mixing_alpha_onshell_scheme_rcl('BFM')
          case default
            write(*,'(/(a))') ' Error message: HAWK Stops here!'
            write(*,*) "Unknown mixing angle renormalization scheme:"
            write(*,*) mixrsin
            stop
          end select
        end if

C       2HDM parameters
        if (modelname .eq. 'THDM') then
          call set_parameter_rcl("muMS_BSM", mumsbsmin*dcmplx(1d0,0d0))
          call set_Z2_thdm_yukawa_type_rcl(ytypein)
          call set_pole_mass_hl_hh_rcl(mhin,0d0,mhhin,0d0)
          call set_pole_mass_ha_rcl(mhain,ghain)
          call set_pole_mass_hc_rcl(mhcin,ghcin)
          call set_l5_rcl(l5in)
          call set_tb_cab_rcl(tbin,cabin)
          select case (trim(mixrsin))
          case ('FJ')
            call use_mixing_alpha_msbar_scheme_rcl('FJ')
            call use_mixing_beta_msbar_scheme_rcl('FJ')
          case ('PR')
            call use_mixing_alpha_msbar_scheme_rcl('PR')
            call use_mixing_beta_msbar_scheme_rcl('PR')
          case ('OS1')
            call use_mixing_alpha_onshell_scheme_rcl('OS1')
            call use_mixing_beta_onshell_scheme_rcl('OS1')
          case ('OS2')
            call use_mixing_alpha_onshell_scheme_rcl('OS2')
            call use_mixing_beta_onshell_scheme_rcl('OS2')
          case ('OS12')
            ! In OS12 we use the OS2 rs for alpha
            call use_mixing_alpha_onshell_scheme_rcl('OS2')
            call use_mixing_beta_onshell_scheme_rcl('OS12')
          case ('BFM')
            call use_mixing_alpha_onshell_scheme_rcl('BFM')
            call use_mixing_beta_onshell_scheme_rcl('BFM')
          case default
            write(*,'(/(a))') ' Error message: HAWK Stops here!'
            write(*,*) "Unknown mixing angle renormalization scheme:"
            write(*,*) mixrsin
            stop
          end select 
          
        end if

      end subroutine init_recola_param
