module smparam
  implicit none
  contains
  subroutine init_param_sm()
    use class_particles, only: aEW,MB,MC,MD,ME,MW,MZ,WW,WZ,MS,MT,MTA,MHL,MM,MU,pi,WT, &
                              init_parameters_mdl
    use modelfile, only: set_parameter_mdl
    complex(kind=kind(23d0)) :: Gf,MWos,MZos,WWos,WZos
    complex(kind=kind(23d0)) :: cone=1d0, cnul=0d0
    
    MT = 173.34d0
    MZos = 91.1876d0
    MWos = 80.385d0
    WZos = 2.4952d0
    WWos = 2.0850d0
    Gf =  0.116637d-4

    MW = MWos/sqrt(1d0+(WWos/MWos)**2)
    WW = WWos/sqrt(1d0+(WWos/MWos)**2)

    MZ = MZos/sqrt(1d0+(WZos/MZos)**2)
    WZ = WZos/sqrt(1d0+(WZos/MZos)**2)

    aEW = Gf/pi*MW**2d0*(1d0-MW**2d0/MZ**2d0)* &
          sqrt(2d0)*cone

    MHL = 125d0
    ME = 0d0
    MM = 0d0
    MTA = 0d0
    MU = 0d0
    MD = 0d0
    MS = 0d0
    MC = 0d0
    MB = 0d0

    call set_parameter_mdl("aEW",aEW)
    call set_parameter_mdl("aS",0.1*cone)

    call set_parameter_mdl("MHL",MHL*cone)
    call set_parameter_mdl("WHL",cnul)
    call set_parameter_mdl("MHH",400d0*cone)
    call set_parameter_mdl("WHH",cnul)

    call set_parameter_mdl("MTA",MTA*cone)
    call set_parameter_mdl("WTA",cnul)
    call set_parameter_mdl("MM",MM*cone)
    call set_parameter_mdl("WM",cnul)
    call set_parameter_mdl("ME",ME*cone)

    call set_parameter_mdl("MT",MT*cone)
    call set_parameter_mdl("WT",cnul)
    call set_parameter_mdl("MB",MB*cone)
    call set_parameter_mdl("WB",cnul)
    call set_parameter_mdl("MC",MC*cone)
    call set_parameter_mdl("WC",cnul)
    call set_parameter_mdl("MS",MS*cone)
    call set_parameter_mdl("MU",MU*cone)
    call set_parameter_mdl("MD",MD*cone)
    
  end subroutine init_param_sm
  
end module smparam
