module collier_interface
  use scalar_functions
  implicit none

  contains

  subroutine init_collier()
    use scalar_functions

    complex(dp), allocatable :: m2(:)
    integer :: nn,i
    deltaUV = 0d0
    deltaIR = 0d0
    deltaIR2 = 0d0
    masscut = 0d0
    call init_cmasses_mdl()

    call Init_cll(2,noreset=.true.)
    call SetMode_cll(1)
    call SetDeltaUV_cll (deltaUV)
    call SetDeltaIR_cll (deltaIR,deltaIR2)
    call SetMuIR2_cll(muIR**2)
    call SetMuUV2_cll(muUV**2)
    nn = 0
    do i = 1,n_particles
    if (get_particle_mass_reg_mdl(i) .eq. 2 .and. is_particle_mdl(i)) nn = nn + 1
    end do
    allocate (m2(nn))
    nn = 0
    do i = 1,n_particles
    if (get_particle_mass_reg_mdl(i) .eq. 2 .and. is_particle_mdl(i)) then
    nn = nn + 1
    m2(nn) = get_particle_cmass2_reg_mdl(i)
    endif
    enddo
    call setminf2_cll (nn,m2)
    deallocate (m2)
  end subroutine init_collier
  
end module collier_interface
