module thdm_ct
  use class_particles
  use scalar_functions
  complex(dp) :: GC_184, GC_MI, GC_52, GC_51, GC_50, GC_57, GC_56, GC_59,      &
                 GC_331, GC_88, GC_89, GC_168, GC_169, GC_162, GC_163, GC_160, &
                 GC_161, GC_166, GC_167, GC_164, GC_165, GC_80, GC_48, GC_49,  &
                 GC_81, GC_44, GC_45, GC_46, GC_47, GC_40, GC_41, GC_42, GC_43 &
                 , GC_179, GC_178, GC_171, GC_170, GC_173, GC_172, GC_175,     &
                 GC_174, GC_177, GC_176, GC_39, GC_38, GC_31, GC_30, GC_33,    &
                 GC_32, GC_35, GC_34, GC_36, GC_144, GC_145, GC_146, GC_147,   &
                 GC_140, GC_142, GC_143, GC_148, GC_149, GC_186, GC_67, GC_99, &
                 GC_28, GC_29, GC_MHA, GC_MHC, GC_MHL, GC_23, GC_26, GC_27,    &
                 GC_24, GC_25, GC_153, GC_152, GC_151, GC_150, GC_157, GC_156, &
                 GC_155, GC_154, GC_139, GC_159, GC_158, GC_64, GC_92, GC_61,  &
                 GC_197, GC_62, GC_192, GC_17, GC_15, GC_13, GC_12, GC_11,     &
                 GC_10, GC_MZ, GC_MW, GC_851, GC_MHH, GC_126, GC_127, GC_124,  &
                 GC_125, GC_122, GC_123, GC_120, GC_121, GC_198, GC_128, GC_129&
                 , GC_1759, GC_329, GC_325, GC_327, GC_323, GC_135, GC_134,    &
                 GC_137, GC_136, GC_131, GC_130, GC_133, GC_132, GC_97, GC_96, &
                 GC_95, GC_94, GC_93, GC_138, GC_91, GC_90, GC_141, GC_71,     &
                 GC_72, GC_I, GC_79, GC_78, GC_188, GC_189, GC_339, GC_180,    &
                 GC_181, GC_182, GC_183, GC_337, GC_185, GC_335, GC_187, GC_100&
                 , GC_101, GC_102, GC_103, GC_104, GC_105, GC_106, GC_107,     &
                 GC_108, GC_109, GC_82, GC_83, GC_84, GC_85, GC_86, GC_87,     &
                 GC_66, GC_196, GC_195, GC_194, GC_193, GC_63, GC_191, GC_190, &
                 GC_22, GC_1505, GC_68, GC_69, GC_3, GC_2, GC_1, GC_4, GC_9,   &
                 GC_1055, GC_333, GC_119, GC_118, GC_117, GC_116, GC_115,      &
                 GC_114, GC_113, GC_112, GC_111, GC_110, GC_3685, GC_803,      &
                 GC_1321, GC_1073, GC_1625, GC_951, GC_1305, GC_955, GC_1921,  &
                 GC_1399, GC_1553, GC_1779, GC_2429, GC_3893
  complex(dp) :: T8, T9, T6, T7, T4, T5, T2, T3, T0, T1, T14, T10, T11, T12, T13
  complex(dp) :: dZHh_MS, dZA_MS, dtHh_MS, dZHMinus_MS, dtHl_MS, dtHh, dZHl_MS &
                 , dZHaG0_MS, dZZA_MS, dZG0Ha_MS, db_MS, dtHl, dMZ2_MS, dMW2_MS&
                 , dtHhHl_PRTS_fin, dZee_MS, dMHH2_MS, dMHC2_MS, dMHL2_MS,     &
                 dMHA2_MS, dZHlHh_MS, dZHhHl_MS, dZGMinusHMinus_MS, da_MS,     &
                 dl5_MS
  complex(dp) :: da_FJTS, da_PRTS
  complex(dp) :: db_FJTS, db_PRTS
  complex(dp) :: dl5_FJTS
contains
subroutine initct(DeltaUV)
  real(dp), intent(in) :: DeltaUV
  GC_184 = -sqrt(2d0)*cima*ca*ytau2/2d0 + sqrt(2d0)*cima*sa*ytau1/2d0
  GC_MI = -cima
  GC_52 = -3d0*cima*cb**4d0*l2 - 6d0*cima*cb**2d0*l3*sb**2d0 - 6d0*cima*cb**2d0&
          *l4*sb**2d0 - 6d0*cima*cb**2d0*l5*sb**2d0 - 3d0*cima*l1*sb**4d0
  GC_51 = -2d0*cima*cb**4d0*l2 - 4d0*cima*cb**2d0*l3*sb**2d0 - 4d0*cima*cb**2d0&
          *l4*sb**2d0 - 4d0*cima*cb**2d0*l5*sb**2d0 - 2d0*cima*l1*sb**4d0
  GC_50 = -cima*cb**4d0*l2 - 2d0*cima*cb**2d0*l3*sb**2d0 - 2d0*cima*cb**2d0*l4*&
          sb**2d0 - 2d0*cima*cb**2d0*l5*sb**2d0 - cima*l1*sb**4d0
  GC_57 = -cima*cb**4d0*l3 - cima*cb**4d0*l4 - 2d0*cima*cb**2d0*l1*sb**2d0 -   &
          2d0*cima*cb**2d0*l2*sb**2d0 + 2d0*cima*cb**2d0*l3*sb**2d0 + 2d0*cima*&
          cb**2d0*l4*sb**2d0 + 4d0*cima*cb**2d0*l5*sb**2d0 - cima*l3*sb**4d0 - &
          cima*l4*sb**4d0
  GC_56 = -cima*cb**4d0*l3 - cima*cb**2d0*l1*sb**2d0 - cima*cb**2d0*l2*sb**2d0 &
           + 2d0*cima*cb**2d0*l4*sb**2d0 + 2d0*cima*cb**2d0*l5*sb**2d0 - cima* &
          l3*sb**4d0
  GC_59 = -cima*cb**4d0*l3 - cima*cb**4d0*l4 - cima*cb**4d0*l5 - 3d0*cima*cb** &
          2d0*l1*sb**2d0 - 3d0*cima*cb**2d0*l2*sb**2d0 + 4d0*cima*cb**2d0*l3*sb&
          **2d0 + 4d0*cima*cb**2d0*l4*sb**2d0 + 4d0*cima*cb**2d0*l5*sb**2d0 -  &
          cima*l3*sb**4d0 - cima*l4*sb**4d0 - cima*l5*sb**4d0
  GC_331 = cima*cb*sb*(ca*vev2 + sa*vev1)
  GC_88 = cima*cw*ee/(2d0*sw) - cima*ee*sw/(6d0*cw)
  GC_89 = -cima*cw*ee/(2d0*sw) + cima*ee*sw/(2d0*cw)
  GC_168 = sqrt(2d0)*cb*ym1/2d0 + sqrt(2d0)*sb*ym2/2d0
  GC_169 = -sqrt(2d0)*cima*ca*ys2/2d0 + sqrt(2d0)*cima*sa*yd12x2/2d0
  GC_162 = -cima*cb*ym2 + cima*sb*ym1
  GC_163 = -sqrt(2d0)*cb*ym2/2d0 + sqrt(2d0)*sb*ym1/2d0
  GC_160 = sqrt(2d0)*cb*ye1/2d0 + sqrt(2d0)*sb*ye2/2d0
  GC_161 = -sqrt(2d0)*cima*ca*ym2/2d0 + sqrt(2d0)*cima*sa*ym1/2d0
  GC_166 = -cima*cb*ym1 - cima*sb*ym2
  GC_167 = -sqrt(2d0)*cb*ym1/2d0 - sqrt(2d0)*sb*ym2/2d0
  GC_164 = sqrt(2d0)*cb*ym2/2d0 - sqrt(2d0)*sb*ym1/2d0
  GC_165 = -sqrt(2d0)*cima*ca*ym1/2d0 - sqrt(2d0)*cima*sa*ym2/2d0
  GC_80 = sqrt(2d0)*cima*ee/(2d0*sw)
  GC_48 = ca*cb**3d0*l4/2d0 - ca*cb**3d0*l5/2d0 + ca*cb*l4*sb**2d0/2d0 - ca*cb*&
          l5*sb**2d0/2d0 + cb**2d0*l4*sa*sb/2d0 - cb**2d0*l5*sa*sb/2d0 + l4*sa*&
          sb**3d0/2d0 - l5*sa*sb**3d0/2d0
  GC_49 = -ca*cb**3d0*l4/2d0 + ca*cb**3d0*l5/2d0 - ca*cb*l4*sb**2d0/2d0 + ca*cb&
          *l5*sb**2d0/2d0 - cb**2d0*l4*sa*sb/2d0 + cb**2d0*l5*sa*sb/2d0 - l4*sa&
          *sb**3d0/2d0 + l5*sa*sb**3d0/2d0
  GC_81 = -cima*cw*ee/sw
  GC_44 = -2d0*cima*cb**3d0*l2*sb + 2d0*cima*cb**3d0*l3*sb + 2d0*cima*cb**3d0* &
          l4*sb + 2d0*cima*cb**3d0*l5*sb + 2d0*cima*cb*l1*sb**3d0 - 2d0*cima*cb&
          *l3*sb**3d0 - 2d0*cima*cb*l4*sb**3d0 - 2d0*cima*cb*l5*sb**3d0
  GC_45 = 2d0*cima*cb**3d0*l1*sb - 2d0*cima*cb**3d0*l3*sb - 2d0*cima*cb**3d0*l4&
          *sb - 2d0*cima*cb**3d0*l5*sb - 2d0*cima*cb*l2*sb**3d0 + 2d0*cima*cb* &
          l3*sb**3d0 + 2d0*cima*cb*l4*sb**3d0 + 2d0*cima*cb*l5*sb**3d0
  GC_46 = -3d0*cima*cb**3d0*l2*sb + 3d0*cima*cb**3d0*l3*sb + 3d0*cima*cb**3d0* &
          l4*sb + 3d0*cima*cb**3d0*l5*sb + 3d0*cima*cb*l1*sb**3d0 - 3d0*cima*cb&
          *l3*sb**3d0 - 3d0*cima*cb*l4*sb**3d0 - 3d0*cima*cb*l5*sb**3d0
  GC_47 = 3d0*cima*cb**3d0*l1*sb - 3d0*cima*cb**3d0*l3*sb - 3d0*cima*cb**3d0*l4&
          *sb - 3d0*cima*cb**3d0*l5*sb - 3d0*cima*cb*l2*sb**3d0 + 3d0*cima*cb* &
          l3*sb**3d0 + 3d0*cima*cb*l4*sb**3d0 + 3d0*cima*cb*l5*sb**3d0
  GC_40 = ca*cb**2d0*l4*sb/2d0 - ca*cb**2d0*l5*sb/2d0 + ca*l4*sb**3d0/2d0 - ca*&
          l5*sb**3d0/2d0 - cb**3d0*l4*sa/2d0 + cb**3d0*l5*sa/2d0 - cb*l4*sa*sb &
          **2d0/2d0 + cb*l5*sa*sb**2d0/2d0
  GC_41 = -ca*cb**2d0*l4*sb/2d0 + ca*cb**2d0*l5*sb/2d0 - ca*l4*sb**3d0/2d0 + ca&
          *l5*sb**3d0/2d0 + cb**3d0*l4*sa/2d0 - cb**3d0*l5*sa/2d0 + cb*l4*sa*sb&
          **2d0/2d0 - cb*l5*sa*sb**2d0/2d0
  GC_42 = -cima*cb**3d0*l2*sb + cima*cb**3d0*l3*sb + cima*cb**3d0*l4*sb + cima*&
          cb**3d0*l5*sb + cima*cb*l1*sb**3d0 - cima*cb*l3*sb**3d0 - cima*cb*l4*&
          sb**3d0 - cima*cb*l5*sb**3d0
  GC_43 = cima*cb**3d0*l1*sb - cima*cb**3d0*l3*sb - cima*cb**3d0*l4*sb - cima* &
          cb**3d0*l5*sb - cima*cb*l2*sb**3d0 + cima*cb*l3*sb**3d0 + cima*cb*l4*&
          sb**3d0 + cima*cb*l5*sb**3d0
  GC_179 = sqrt(2d0)*cb*yt2/2d0 - sqrt(2d0)*sb*yt1/2d0
  GC_178 = cima*cb*yt2 - cima*sb*yt1
  GC_171 = -sqrt(2d0)*cb*ys2/2d0 + sqrt(2d0)*sb*yd12x2/2d0
  GC_170 = -cima*cb*ys2 + cima*sb*yd12x2
  GC_173 = -sqrt(2d0)*cima*ca*yd12x2/2d0 - sqrt(2d0)*cima*sa*ys2/2d0
  GC_172 = sqrt(2d0)*cb*ys2/2d0 - sqrt(2d0)*sb*yd12x2/2d0
  GC_175 = -sqrt(2d0)*cb*yd12x2/2d0 - sqrt(2d0)*sb*ys2/2d0
  GC_174 = -cima*cb*yd12x2 - cima*sb*ys2
  GC_177 = -sqrt(2d0)*cima*ca*yt2/2d0 + sqrt(2d0)*cima*sa*yt1/2d0
  GC_176 = sqrt(2d0)*cb*yd12x2/2d0 + sqrt(2d0)*sb*ys2/2d0
  GC_39 = -cima*ca**2d0*cb**2d0*l3 - cima*ca**2d0*cb**2d0*l4 + cima*ca**2d0*cb &
          **2d0*l5 - cima*ca**2d0*l2*sb**2d0 + 4d0*cima*ca*cb*l5*sa*sb - cima* &
          cb**2d0*l1*sa**2d0 - cima*l3*sa**2d0*sb**2d0 - cima*l4*sa**2d0*sb**  &
          2d0 + cima*l5*sa**2d0*sb**2d0
  GC_38 = -cima*ca**2d0*cb**2d0*l3 - cima*ca**2d0*cb**2d0*l4 + cima*ca**2d0*cb &
          **2d0*l5 - cima*ca**2d0*l1*sb**2d0 + 4d0*cima*ca*cb*l5*sa*sb - cima* &
          cb**2d0*l2*sa**2d0 - cima*l3*sa**2d0*sb**2d0 - cima*l4*sa**2d0*sb**  &
          2d0 + cima*l5*sa**2d0*sb**2d0
  GC_31 = -cima*ca**2d0*cb**2d0*l2 - cima*ca**2d0*l3*sb**2d0 - cima*ca**2d0*l4*&
          sb**2d0 + cima*ca**2d0*l5*sb**2d0 - 4d0*cima*ca*cb*l5*sa*sb - cima*cb&
          **2d0*l3*sa**2d0 - cima*cb**2d0*l4*sa**2d0 + cima*cb**2d0*l5*sa**2d0 &
           - cima*l1*sa**2d0*sb**2d0
  GC_30 = -cima*ca**2d0*cb**2d0*l2 - cima*ca**2d0*l3*sb**2d0 - 2d0*cima*ca*cb* &
          l4*sa*sb - 2d0*cima*ca*cb*l5*sa*sb - cima*cb**2d0*l3*sa**2d0 - cima* &
          l1*sa**2d0*sb**2d0
  GC_33 = -cima*ca**2d0*cb**2d0*l1 - cima*ca**2d0*l3*sb**2d0 - cima*ca**2d0*l4*&
          sb**2d0 + cima*ca**2d0*l5*sb**2d0 - 4d0*cima*ca*cb*l5*sa*sb - cima*cb&
          **2d0*l3*sa**2d0 - cima*cb**2d0*l4*sa**2d0 + cima*cb**2d0*l5*sa**2d0 &
           - cima*l2*sa**2d0*sb**2d0
  GC_32 = -cima*ca**2d0*cb**2d0*l1 - cima*ca**2d0*l3*sb**2d0 - 2d0*cima*ca*cb* &
          l4*sa*sb - 2d0*cima*ca*cb*l5*sa*sb - cima*cb**2d0*l3*sa**2d0 - cima* &
          l2*sa**2d0*sb**2d0
  GC_35 = -cima*ca**2d0*cb**2d0*l3 - cima*ca**2d0*l2*sb**2d0 + 2d0*cima*ca*cb* &
          l4*sa*sb + 2d0*cima*ca*cb*l5*sa*sb - cima*cb**2d0*l1*sa**2d0 - cima* &
          l3*sa**2d0*sb**2d0
  GC_34 = -cima*ca**2d0*cb**2d0*l3 - cima*ca**2d0*l1*sb**2d0 + 2d0*cima*ca*cb* &
          l4*sa*sb + 2d0*cima*ca*cb*l5*sa*sb - cima*cb**2d0*l2*sa**2d0 - cima* &
          l3*sa**2d0*sb**2d0
  GC_36 = -cima*ca**2d0*cb**2d0*l4/2d0 - cima*ca**2d0*cb**2d0*l5/2d0 + cima*ca &
          **2d0*l4*sb**2d0/2d0 + cima*ca**2d0*l5*sb**2d0/2d0 - cima*ca*cb*l1*sa&
          *sb - cima*ca*cb*l2*sa*sb + 2d0*cima*ca*cb*l3*sa*sb + cima*cb**2d0*l4&
          *sa**2d0/2d0 + cima*cb**2d0*l5*sa**2d0/2d0 - cima*l4*sa**2d0*sb**2d0/&
          2d0 - cima*l5*sa**2d0*sb**2d0/2d0
  GC_144 = -sqrt(2d0)*cb*yb2/2d0 + sqrt(2d0)*sb*yd13x3/2d0
  GC_145 = -sqrt(2d0)*cima*ca*ydo2/2d0 + sqrt(2d0)*cima*sa*ydo1/2d0
  GC_146 = -cima*cb*ydo2 + cima*sb*ydo1
  GC_147 = -sqrt(2d0)*cb*ydo2/2d0 + sqrt(2d0)*sb*ydo1/2d0
  GC_140 = sqrt(2d0)*cb*yd13x3/2d0 + sqrt(2d0)*sb*yb2/2d0
  GC_142 = -cima*cb*yb2 + cima*sb*yd13x3
  GC_143 = sqrt(2d0)*cb*yb2/2d0 - sqrt(2d0)*sb*yd13x3/2d0
  GC_148 = sqrt(2d0)*cb*ydo2/2d0 - sqrt(2d0)*sb*ydo1/2d0
  GC_149 = -sqrt(2d0)*cima*ca*ydo1/2d0 - sqrt(2d0)*cima*sa*ydo2/2d0
  GC_186 = -sqrt(2d0)*cb*ytau2/2d0 + sqrt(2d0)*sb*ytau1/2d0
  GC_67 = -cima*cMW*ca*ee*sb/(2d0*sw) + cima*cMW*cb*ee*sa/(2d0*sw)
  GC_99 = cima*ca**2d0*cw**2d0*ee**2d0/(2d0*sw**2d0) + cima*ca**2d0*ee**2d0 +  &
          cima*ca**2d0*ee**2d0*sw**2d0/(2d0*cw**2d0) + cima*cw**2d0*ee**2d0*sa &
          **2d0/(2d0*sw**2d0) + cima*ee**2d0*sa**2d0 + cima*ee**2d0*sa**2d0*sw &
          **2d0/(2d0*cw**2d0)
  GC_28 = -cima*ca**2d0*cb*l2*sb + cima*ca**2d0*cb*l3*sb + cima*ca**2d0*cb*l4* &
          sb - cima*ca**2d0*cb*l5*sb + 2d0*cima*ca*cb**2d0*l5*sa - 2d0*cima*ca*&
          l5*sa*sb**2d0 + cima*cb*l1*sa**2d0*sb - cima*cb*l3*sa**2d0*sb - cima*&
          cb*l4*sa**2d0*sb + cima*cb*l5*sa**2d0*sb
  GC_29 = cima*ca**2d0*cb*l1*sb - cima*ca**2d0*cb*l3*sb - cima*ca**2d0*cb*l4*sb&
           + cima*ca**2d0*cb*l5*sb - 2d0*cima*ca*cb**2d0*l5*sa + 2d0*cima*ca*l5&
          *sa*sb**2d0 - cima*cb*l2*sa**2d0*sb + cima*cb*l3*sa**2d0*sb + cima*cb&
          *l4*sa**2d0*sb - cima*cb*l5*sa**2d0*sb
  GC_MHA = -cima*cMHA**2d0
  GC_MHC = -cima*cMHC**2d0
  GC_MHL = -cima*cMHL**2d0
  GC_23 = -cima*ca**2d0*cb*l4*sb - cima*ca**2d0*cb*l5*sb + cima*ca*cb**2d0*l1* &
          sa - cima*ca*cb**2d0*l3*sa - cima*ca*l2*sa*sb**2d0 + cima*ca*l3*sa*sb&
          **2d0 + cima*cb*l4*sa**2d0*sb + cima*cb*l5*sa**2d0*sb
  GC_26 = 2d0*cima*ca**2d0*cb*l5*sb - cima*ca*cb**2d0*l2*sa + cima*ca*cb**2d0* &
          l3*sa + cima*ca*cb**2d0*l4*sa - cima*ca*cb**2d0*l5*sa + cima*ca*l1*sa&
          *sb**2d0 - cima*ca*l3*sa*sb**2d0 - cima*ca*l4*sa*sb**2d0 + cima*ca*l5&
          *sa*sb**2d0 - 2d0*cima*cb*l5*sa**2d0*sb
  GC_27 = cima*ca**2d0*cb*l1*sb - cima*ca**2d0*cb*l3*sb - cima*ca*cb**2d0*l4*sa&
           - cima*ca*cb**2d0*l5*sa + cima*ca*l4*sa*sb**2d0 + cima*ca*l5*sa*sb**&
          2d0 - cima*cb*l2*sa**2d0*sb + cima*cb*l3*sa**2d0*sb
  GC_24 = -cima*ca**2d0*cb*l2*sb + cima*ca**2d0*cb*l3*sb + cima*ca*cb**2d0*l4* &
          sa + cima*ca*cb**2d0*l5*sa - cima*ca*l4*sa*sb**2d0 - cima*ca*l5*sa*sb&
          **2d0 + cima*cb*l1*sa**2d0*sb - cima*cb*l3*sa**2d0*sb
  GC_25 = -2d0*cima*ca**2d0*cb*l5*sb + cima*ca*cb**2d0*l1*sa - cima*ca*cb**2d0*&
          l3*sa - cima*ca*cb**2d0*l4*sa + cima*ca*cb**2d0*l5*sa - cima*ca*l2*sa&
          *sb**2d0 + cima*ca*l3*sa*sb**2d0 + cima*ca*l4*sa*sb**2d0 - cima*ca*l5&
          *sa*sb**2d0 + 2d0*cima*cb*l5*sa**2d0*sb
  GC_153 = -sqrt(2d0)*cima*ca*ye2/2d0 + sqrt(2d0)*cima*sa*ye1/2d0
  GC_152 = sqrt(2d0)*cb*ydo1/2d0 + sqrt(2d0)*sb*ydo2/2d0
  GC_151 = -sqrt(2d0)*cb*ydo1/2d0 - sqrt(2d0)*sb*ydo2/2d0
  GC_150 = -cima*cb*ydo1 - cima*sb*ydo2
  GC_157 = -sqrt(2d0)*cima*ca*ye1/2d0 - sqrt(2d0)*cima*sa*ye2/2d0
  GC_156 = sqrt(2d0)*cb*ye2/2d0 - sqrt(2d0)*sb*ye1/2d0
  GC_155 = -sqrt(2d0)*cb*ye2/2d0 + sqrt(2d0)*sb*ye1/2d0
  GC_154 = -cima*cb*ye2 + cima*sb*ye1
  GC_139 = -sqrt(2d0)*cb*yd13x3/2d0 - sqrt(2d0)*sb*yb2/2d0
  GC_159 = -sqrt(2d0)*cb*ye1/2d0 - sqrt(2d0)*sb*ye2/2d0
  GC_158 = -cima*cb*ye1 - cima*sb*ye2
  GC_64 = cima*ca*ee*sb/(2d0*sw) - cima*cb*ee*sa/(2d0*sw)
  GC_92 = ca*cw*ee*sb/(2d0*sw) + ca*ee*sb*sw/(2d0*cw) - cb*cw*ee*sa/(2d0*sw) - &
          cb*ee*sa*sw/(2d0*cw)
  GC_61 = cima*ca**2d0*ee**2d0/(2d0*sw**2d0) + cima*ee**2d0*sa**2d0/(2d0*sw**  &
          2d0)
  GC_197 = -sqrt(2d0)*cb*yup1/2d0 - sqrt(2d0)*sb*yup2/2d0
  GC_62 = cima*cb**2d0*ee**2d0/(2d0*sw**2d0) + cima*ee**2d0*sb**2d0/(2d0*sw**  &
          2d0)
  GC_192 = -sqrt(2d0)*cima*ca*yup2/2d0 + sqrt(2d0)*cima*sa*yup1/2d0
  GC_17 = cima*cb**2d0*ee + cima*ee*sb**2d0
  GC_15 = cima*ca*ee**2d0*sb/(2d0*cw) - cima*cb*ee**2d0*sa/(2d0*cw)
  GC_13 = -cima*ca**4d0*l3 - cima*ca**4d0*l4 - cima*ca**4d0*l5 - 3d0*cima*ca** &
          2d0*l1*sa**2d0 - 3d0*cima*ca**2d0*l2*sa**2d0 + 4d0*cima*ca**2d0*l3*sa&
          **2d0 + 4d0*cima*ca**2d0*l4*sa**2d0 + 4d0*cima*ca**2d0*l5*sa**2d0 -  &
          cima*l3*sa**4d0 - cima*l4*sa**4d0 - cima*l5*sa**4d0
  GC_12 = -3d0*cima*ca**4d0*l1 - 6d0*cima*ca**2d0*l3*sa**2d0 - 6d0*cima*ca**2d0&
          *l4*sa**2d0 - 6d0*cima*ca**2d0*l5*sa**2d0 - 3d0*cima*l2*sa**4d0
  GC_11 = -3d0*cima*ca**4d0*l2 - 6d0*cima*ca**2d0*l3*sa**2d0 - 6d0*cima*ca**2d0&
          *l4*sa**2d0 - 6d0*cima*ca**2d0*l5*sa**2d0 - 3d0*cima*l1*sa**4d0
  GC_10 = 3d0*cima*ca**3d0*l1*sa - 3d0*cima*ca**3d0*l3*sa - 3d0*cima*ca**3d0*l4&
          *sa - 3d0*cima*ca**3d0*l5*sa - 3d0*cima*ca*l2*sa**3d0 + 3d0*cima*ca* &
          l3*sa**3d0 + 3d0*cima*ca*l4*sa**3d0 + 3d0*cima*ca*l5*sa**3d0
  GC_MZ = cima*cMZ**2d0
  GC_MW = cima*cMW**2d0
  GC_851 = -GC_64
  GC_MHH = -cima*cMHH**2d0
  GC_126 = -cima*cb*ee**2d0*vev2/(2d0*sw) + cima*ee**2d0*sb*vev1/(2d0*sw)
  GC_127 = -cima*cb*ee**2d0*vev1/(2d0*sw) - cima*ee**2d0*sb*vev2/(2d0*sw)
  GC_124 = cima*ca*ee**2d0*vev2/(2d0*sw**2d0) - cima*ee**2d0*sa*vev1/(2d0*sw** &
           2d0)
  GC_125 = cima*ca*ee**2d0*vev1/(2d0*sw**2d0) + cima*ee**2d0*sa*vev2/(2d0*sw** &
           2d0)
  GC_122 = cb**3d0*l4*vev1/2d0 - cb**3d0*l5*vev1/2d0 + cb**2d0*l4*sb*vev2/2d0  &
            - cb**2d0*l5*sb*vev2/2d0 + cb*l4*sb**2d0*vev1/2d0 - cb*l5*sb**2d0* &
           vev1/2d0 + l4*sb**3d0*vev2/2d0 - l5*sb**3d0*vev2/2d0
  GC_123 = -cb**3d0*l4*vev1/2d0 + cb**3d0*l5*vev1/2d0 - cb**2d0*l4*sb*vev2/2d0 &
            + cb**2d0*l5*sb*vev2/2d0 - cb*l4*sb**2d0*vev1/2d0 + cb*l5*sb**2d0* &
           vev1/2d0 - l4*sb**3d0*vev2/2d0 + l5*sb**3d0*vev2/2d0
  GC_120 = -cima*ca*cb**2d0*l5*vev1 - cima*ca*cb*l2*sb*vev2 + cima*ca*cb*l3*sb*&
           vev2 + cima*ca*cb*l4*sb*vev2 - cima*ca*cb*l5*sb*vev2 + cima*ca*l5*sb&
           **2d0*vev1 + cima*cb**2d0*l5*sa*vev2 - cima*cb*l1*sa*sb*vev1 + cima*&
           cb*l3*sa*sb*vev1 + cima*cb*l4*sa*sb*vev1 - cima*cb*l5*sa*sb*vev1 -  &
           cima*l5*sa*sb**2d0*vev2
  GC_121 = -cima*ca*cb**2d0*l3*vev1 - cima*ca*cb**2d0*l4*vev1 + cima*ca*cb**2d0&
           *l5*vev1 + 2d0*cima*ca*cb*l5*sb*vev2 - cima*ca*l1*sb**2d0*vev1 -    &
           cima*cb**2d0*l2*sa*vev2 + 2d0*cima*cb*l5*sa*sb*vev1 - cima*l3*sa*sb &
           **2d0*vev2 - cima*l4*sa*sb**2d0*vev2 + cima*l5*sa*sb**2d0*vev2
  GC_198 = sqrt(2d0)*cb*yup1/2d0 + sqrt(2d0)*sb*yup2/2d0
  GC_128 = cima*ca*cw**2d0*ee**2d0*vev2/(2d0*sw**2d0) + cima*ca*ee**2d0*vev2 + &
           cima*ca*ee**2d0*sw**2d0*vev2/(2d0*cw**2d0) - cima*cw**2d0*ee**2d0*sa&
           *vev1/(2d0*sw**2d0) - cima*ee**2d0*sa*vev1 - cima*ee**2d0*sa*sw**2d0&
           *vev1/(2d0*cw**2d0)
  GC_129 = cima*ca*cw**2d0*ee**2d0*vev1/(2d0*sw**2d0) + cima*ca*ee**2d0*vev1 + &
           cima*ca*ee**2d0*sw**2d0*vev1/(2d0*cw**2d0) + cima*cw**2d0*ee**2d0*sa&
           *vev2/(2d0*sw**2d0) + cima*ee**2d0*sa*vev2 + cima*ee**2d0*sa*sw**2d0&
           *vev2/(2d0*cw**2d0)
  GC_1759 = -GC_179
  GC_329 = cima*cb*sb*(ca*vev2 + sa*vev1)
  GC_325 = -cima*cb**2d0*sa*vev2
  GC_327 = -cima*(ca*cb**2d0*vev1 + sa*sb**2d0*vev2)
  GC_323 = -cima*(-ca*cb**2d0*l4*vev2 - ca*cb**2d0*l5*vev2 + 2d0*ca*cb*l1*sb*  &
           vev1 - 2d0*ca*cb*l3*sb*vev1 + ca*l4*sb**2d0*vev2 + ca*l5*sb**2d0*   &
           vev2 - cb**2d0*l4*sa*vev1 - cb**2d0*l5*sa*vev1 - 2d0*cb*l2*sa*sb*   &
           vev2 + 2d0*cb*l3*sa*sb*vev2 + l4*sa*sb**2d0*vev1 + l5*sa*sb**2d0*   &
           vev1)
  GC_135 = -sqrt(2d0)*cb*yc1/2d0 - sqrt(2d0)*sb*yc2/2d0
  GC_134 = cima*cb*yc1 + cima*sb*yc2
  GC_137 = -sqrt(2d0)*cima*ca*yd13x3/2d0 - sqrt(2d0)*cima*sa*yb2/2d0
  GC_136 = sqrt(2d0)*cb*yc1/2d0 + sqrt(2d0)*sb*yc2/2d0
  GC_131 = cima*cb*yc2 - cima*sb*yc1
  GC_130 = -sqrt(2d0)*cima*ca*yc2/2d0 + sqrt(2d0)*cima*sa*yc1/2d0
  GC_133 = -sqrt(2d0)*cima*ca*yc1/2d0 - sqrt(2d0)*cima*sa*yc2/2d0
  GC_132 = sqrt(2d0)*cb*yc2/2d0 - sqrt(2d0)*sb*yc1/2d0
  GC_97 = -cima*cb**2d0*cw*ee**2d0/sw + cima*cb**2d0*ee**2d0*sw/cw - cima*cw*ee&
          **2d0*sb**2d0/sw + cima*ee**2d0*sb**2d0*sw/cw
  GC_96 = -cima*cb**2d0*cw*ee/(2d0*sw) + cima*cb**2d0*ee*sw/(2d0*cw) - cima*cw*&
          ee*sb**2d0/(2d0*sw) + cima*ee*sb**2d0*sw/(2d0*cw)
  GC_95 = -cima*cMZ*ca*cb*cw*ee/(2d0*sw) - cima*cMZ*ca*cb*ee*sw/(2d0*cw) - cima&
          *cMZ*cw*ee*sa*sb/(2d0*sw) - cima*cMZ*ee*sa*sb*sw/(2d0*cw)
  GC_94 = -ca*cb*cw*ee/(2d0*sw) - ca*cb*ee*sw/(2d0*cw) - cw*ee*sa*sb/(2d0*sw   &
          ) - ee*sa*sb*sw/(2d0*cw)
  GC_93 = -cima*cMZ*ca*cw*ee*sb/(2d0*sw) - cima*cMZ*ca*ee*sb*sw/(2d0*cw) + cima&
          *cMZ*cb*cw*ee*sa/(2d0*sw) + cima*cMZ*cb*ee*sa*sw/(2d0*cw)
  GC_138 = -cima*cb*yd13x3 - cima*sb*yb2
  GC_91 = -ca*cw*ee*sb/(2d0*sw) - ca*ee*sb*sw/(2d0*cw) + cb*cw*ee*sa/(2d0*sw   &
          ) + cb*ee*sa*sw/(2d0*cw)
  GC_90 = cima*cw*ee/(2d0*sw) + cima*ee*sw/(2d0*cw)
  GC_141 = -sqrt(2d0)*cima*ca*yb2/2d0 + sqrt(2d0)*cima*sa*yd13x3/2d0
  GC_71 = -cima*cMW*ca*cb*ee/(2d0*sw) - cima*cMW*ee*sa*sb/(2d0*sw)
  GC_72 = cb**2d0*ee/(2d0*sw) + ee*sb**2d0/(2d0*sw)
  GC_I = cima
  GC_79 = cima*cw**2d0*ee**2d0/sw**2d0
  GC_78 = -cima*ee**2d0/sw**2d0
  GC_188 = -sqrt(2d0)*cima*ca*ytau1/2d0 - sqrt(2d0)*cima*sa*ytau2/2d0
  GC_189 = -cima*cb*ytau1 - cima*sb*ytau2
  GC_339 = cima*(-ca*cb**2d0*l2*vev2 + ca*cb*l4*sb*vev1 + ca*cb*l5*sb*vev1 - ca&
           *l3*sb**2d0*vev2 + cb**2d0*l3*sa*vev1 - cb*l4*sa*sb*vev2 - cb*l5*sa*&
           sb*vev2 + l1*sa*sb**2d0*vev1)
  GC_180 = -sqrt(2d0)*cima*ca*yt1/2d0 - sqrt(2d0)*cima*sa*yt2/2d0
  GC_181 = cima*cb*yt1 + cima*sb*yt2
  GC_182 = -sqrt(2d0)*cb*yt1/2d0 - sqrt(2d0)*sb*yt2/2d0
  GC_183 = sqrt(2d0)*cb*yt1/2d0 + sqrt(2d0)*sb*yt2/2d0
  GC_337 = -cima*(-ca*cb*l4*sb - ca*cb*l5*sb + cb**2d0*l2*sa + l3*sa*sb**2d0)
  GC_185 = -cima*cb*ytau2 + cima*sb*ytau1
  GC_335 = -cima*(ca*cb**2d0*l3 + ca*l1*sb**2d0 - cb*l4*sa*sb - cb*l5*sa*sb)
  GC_187 = sqrt(2d0)*cb*ytau2/2d0 - sqrt(2d0)*sb*ytau1/2d0
  GC_100 = cima*cb**2d0*cw**2d0*ee**2d0/(2d0*sw**2d0) - cima*cb**2d0*ee**2d0 + &
           cima*cb**2d0*ee**2d0*sw**2d0/(2d0*cw**2d0) + cima*cw**2d0*ee**2d0*sb&
           **2d0/(2d0*sw**2d0) - cima*ee**2d0*sb**2d0 + cima*ee**2d0*sb**2d0*sw&
           **2d0/(2d0*cw**2d0)
  GC_101 = cima*cb**2d0*cw**2d0*ee**2d0/(2d0*sw**2d0) + cima*cb**2d0*ee**2d0 + &
           cima*cb**2d0*ee**2d0*sw**2d0/(2d0*cw**2d0) + cima*cw**2d0*ee**2d0*sb&
           **2d0/(2d0*sw**2d0) + cima*ee**2d0*sb**2d0 + cima*ee**2d0*sb**2d0*sw&
           **2d0/(2d0*cw**2d0)
  GC_102 = -cima*cb*ee**2d0*vev2/(2d0*cw) + cima*ee**2d0*sb*vev1/(2d0*cw)
  GC_103 = -cima*ca**3d0*l3*vev2 - cima*ca**3d0*l4*vev2 - cima*ca**3d0*l5*vev2 &
            + 3d0*cima*ca**2d0*l1*sa*vev1 - 2d0*cima*ca**2d0*l3*sa*vev1 - 2d0* &
           cima*ca**2d0*l4*sa*vev1 - 2d0*cima*ca**2d0*l5*sa*vev1 - 3d0*cima*ca*&
           l2*sa**2d0*vev2 + 2d0*cima*ca*l3*sa**2d0*vev2 + 2d0*cima*ca*l4*sa** &
           2d0*vev2 + 2d0*cima*ca*l5*sa**2d0*vev2 + cima*l3*sa**3d0*vev1 + cima&
           *l4*sa**3d0*vev1 + cima*l5*sa**3d0*vev1
  GC_104 = -3d0*cima*ca**3d0*l2*vev2 + 3d0*cima*ca**2d0*l3*sa*vev1 + 3d0*cima* &
           ca**2d0*l4*sa*vev1 + 3d0*cima*ca**2d0*l5*sa*vev1 - 3d0*cima*ca*l3*sa&
           **2d0*vev2 - 3d0*cima*ca*l4*sa**2d0*vev2 - 3d0*cima*ca*l5*sa**2d0*  &
           vev2 + 3d0*cima*l1*sa**3d0*vev1
  GC_105 = -3d0*cima*ca**3d0*l1*vev1 - 3d0*cima*ca**2d0*l3*sa*vev2 - 3d0*cima* &
           ca**2d0*l4*sa*vev2 - 3d0*cima*ca**2d0*l5*sa*vev2 - 3d0*cima*ca*l3*sa&
           **2d0*vev1 - 3d0*cima*ca*l4*sa**2d0*vev1 - 3d0*cima*ca*l5*sa**2d0*  &
           vev1 - 3d0*cima*l2*sa**3d0*vev2
  GC_106 = -cima*ca**3d0*l3*vev1 - cima*ca**3d0*l4*vev1 - cima*ca**3d0*l5*vev1 &
            - 3d0*cima*ca**2d0*l2*sa*vev2 + 2d0*cima*ca**2d0*l3*sa*vev2 + 2d0* &
           cima*ca**2d0*l4*sa*vev2 + 2d0*cima*ca**2d0*l5*sa*vev2 - 3d0*cima*ca*&
           l1*sa**2d0*vev1 + 2d0*cima*ca*l3*sa**2d0*vev1 + 2d0*cima*ca*l4*sa** &
           2d0*vev1 + 2d0*cima*ca*l5*sa**2d0*vev1 - cima*l3*sa**3d0*vev2 - cima&
           *l4*sa**3d0*vev2 - cima*l5*sa**3d0*vev2
  GC_107 = -cima*cb*ee**2d0*vev1/(2d0*cw) - cima*ee**2d0*sb*vev2/(2d0*cw)
  GC_108 = -cima*ca*cb**2d0*l3*vev2 - cima*ca*cb*l4*sb*vev1 - cima*ca*cb*l5*sb*&
           vev1 - cima*ca*l2*sb**2d0*vev2 + cima*cb**2d0*l1*sa*vev1 + cima*cb* &
           l4*sa*sb*vev2 + cima*cb*l5*sa*sb*vev2 + cima*l3*sa*sb**2d0*vev1
  GC_109 = -cima*ca*cb**2d0*l3*vev2 - cima*ca*cb**2d0*l4*vev2 + cima*ca*cb**2d0&
           *l5*vev2 - 2d0*cima*ca*cb*l5*sb*vev1 - cima*ca*l2*sb**2d0*vev2 +    &
           cima*cb**2d0*l1*sa*vev1 + 2d0*cima*cb*l5*sa*sb*vev2 + cima*l3*sa*sb &
           **2d0*vev1 + cima*l4*sa*sb**2d0*vev1 - cima*l5*sa*sb**2d0*vev1
  GC_82 = cima*cw*ee/sw
  GC_83 = 2d0*cima*cw*ee**2d0/sw
  GC_84 = cima*ee*sw/(3d0*cw)
  GC_85 = -2d0*cima*ee*sw/(3d0*cw)
  GC_86 = cima*ee*sw/cw
  GC_87 = -cima*cw*ee/(2d0*sw) - cima*ee*sw/(6d0*cw)
  GC_66 = cima*ca*ee**2d0*sb/(2d0*sw) - cima*cb*ee**2d0*sa/(2d0*sw)
  GC_196 = cima*cb*yup1 + cima*sb*yup2
  GC_195 = -sqrt(2d0)*cima*ca*yup1/2d0 - sqrt(2d0)*cima*sa*yup2/2d0
  GC_194 = sqrt(2d0)*cb*yup2/2d0 - sqrt(2d0)*sb*yup1/2d0
  GC_193 = cima*cb*yup2 - cima*sb*yup1
  GC_63 = -cima*ca*ee*sb/(2d0*sw) + cima*cb*ee*sa/(2d0*sw)
  GC_191 = sqrt(2d0)*cb*ytau1/2d0 + sqrt(2d0)*sb*ytau2/2d0
  GC_190 = -sqrt(2d0)*cb*ytau1/2d0 - sqrt(2d0)*sb*ytau2/2d0
  GC_22 = cima*ca**2d0*cb*l4*sb + cima*ca**2d0*cb*l5*sb - cima*ca*cb**2d0*l2*sa&
           + cima*ca*cb**2d0*l3*sa + cima*ca*l1*sa*sb**2d0 - cima*ca*l3*sa*sb**&
          2d0 - cima*cb*l4*sa**2d0*sb - cima*cb*l5*sa**2d0*sb
  GC_1505 = -GC_63
  GC_68 = -cima*ca*cb*ee/(2d0*sw) - cima*ee*sa*sb/(2d0*sw)
  GC_69 = cima*ca*cb*ee/(2d0*sw) + cima*ee*sa*sb/(2d0*sw)
  GC_3 = -cima*ee
  GC_2 = -2d0*cima*ee/3d0
  GC_1 = cima*ee/3d0
  GC_4 = cima*ee
  GC_9 = -3d0*cima*ca**3d0*l2*sa + 3d0*cima*ca**3d0*l3*sa + 3d0*cima*ca**3d0*l4&
         *sa + 3d0*cima*ca**3d0*l5*sa + 3d0*cima*ca*l1*sa**3d0 - 3d0*cima*ca*l3&
         *sa**3d0 - 3d0*cima*ca*l4*sa**3d0 - 3d0*cima*ca*l5*sa**3d0
  GC_1055 = -GC_68
  GC_333 = -cima*ca*sb**2d0*vev1
  GC_119 = -cima*ca*cb**2d0*l4*vev1/2d0 - cima*ca*cb**2d0*l5*vev1/2d0 - cima*ca&
           *cb*l2*sb*vev2 + cima*ca*cb*l3*sb*vev2 + cima*ca*l4*sb**2d0*vev1/2d0&
            + cima*ca*l5*sb**2d0*vev1/2d0 + cima*cb**2d0*l4*sa*vev2/2d0 + cima*&
           cb**2d0*l5*sa*vev2/2d0 - cima*cb*l1*sa*sb*vev1 + cima*cb*l3*sa*sb*  &
           vev1 - cima*l4*sa*sb**2d0*vev2/2d0 - cima*l5*sa*sb**2d0*vev2/2d0
  GC_118 = -cima*ca*cb**2d0*l3*vev1 + cima*ca*cb*l4*sb*vev2 + cima*ca*cb*l5*sb*&
           vev2 - cima*ca*l1*sb**2d0*vev1 - cima*cb**2d0*l2*sa*vev2 + cima*cb* &
           l4*sa*sb*vev1 + cima*cb*l5*sa*sb*vev1 - cima*l3*sa*sb**2d0*vev2
  GC_117 = -cima*ca*cb**2d0*l1*vev1 - 2d0*cima*ca*cb*l5*sb*vev2 - cima*ca*l3*sb&
           **2d0*vev1 - cima*ca*l4*sb**2d0*vev1 + cima*ca*l5*sb**2d0*vev1 -    &
           cima*cb**2d0*l3*sa*vev2 - cima*cb**2d0*l4*sa*vev2 + cima*cb**2d0*l5*&
           sa*vev2 - 2d0*cima*cb*l5*sa*sb*vev1 - cima*l2*sa*sb**2d0*vev2
  GC_116 = -cima*ca*cb**2d0*l1*vev1 - cima*ca*cb*l4*sb*vev2 - cima*ca*cb*l5*sb*&
           vev2 - cima*ca*l3*sb**2d0*vev1 - cima*cb**2d0*l3*sa*vev2 - cima*cb* &
           l4*sa*sb*vev1 - cima*cb*l5*sa*sb*vev1 - cima*l2*sa*sb**2d0*vev2
  GC_115 = -cb**3d0*l4*vev2/2d0 + cb**3d0*l5*vev2/2d0 + cb**2d0*l4*sb*vev1/2d0 &
            - cb**2d0*l5*sb*vev1/2d0 - cb*l4*sb**2d0*vev2/2d0 + cb*l5*sb**2d0* &
           vev2/2d0 + l4*sb**3d0*vev1/2d0 - l5*sb**3d0*vev1/2d0
  GC_114 = cb**3d0*l4*vev2/2d0 - cb**3d0*l5*vev2/2d0 - cb**2d0*l4*sb*vev1/2d0  &
            + cb**2d0*l5*sb*vev1/2d0 + cb*l4*sb**2d0*vev2/2d0 - cb*l5*sb**2d0* &
           vev2/2d0 - l4*sb**3d0*vev1/2d0 + l5*sb**3d0*vev1/2d0
  GC_113 = -cima*ca*cb**2d0*l2*vev2 + 2d0*cima*ca*cb*l5*sb*vev1 - cima*ca*l3*sb&
           **2d0*vev2 - cima*ca*l4*sb**2d0*vev2 + cima*ca*l5*sb**2d0*vev2 +    &
           cima*cb**2d0*l3*sa*vev1 + cima*cb**2d0*l4*sa*vev1 - cima*cb**2d0*l5*&
           sa*vev1 - 2d0*cima*cb*l5*sa*sb*vev2 + cima*l1*sa*sb**2d0*vev1
  GC_112 = -cima*ca*cb**2d0*l5*vev2 + cima*ca*cb*l1*sb*vev1 - cima*ca*cb*l3*sb*&
           vev1 - cima*ca*cb*l4*sb*vev1 + cima*ca*cb*l5*sb*vev1 + cima*ca*l5*sb&
           **2d0*vev2 - cima*cb**2d0*l5*sa*vev1 - cima*cb*l2*sa*sb*vev2 + cima*&
           cb*l3*sa*sb*vev2 + cima*cb*l4*sa*sb*vev2 - cima*cb*l5*sa*sb*vev2 +  &
           cima*l5*sa*sb**2d0*vev1
  GC_111 = -cima*ca*cb**2d0*l4*vev2/2d0 - cima*ca*cb**2d0*l5*vev2/2d0 + cima*ca&
           *cb*l1*sb*vev1 - cima*ca*cb*l3*sb*vev1 + cima*ca*l4*sb**2d0*vev2/2d0&
            + cima*ca*l5*sb**2d0*vev2/2d0 - cima*cb**2d0*l4*sa*vev1/2d0 - cima*&
           cb**2d0*l5*sa*vev1/2d0 - cima*cb*l2*sa*sb*vev2 + cima*cb*l3*sa*sb*  &
           vev2 + cima*l4*sa*sb**2d0*vev1/2d0 + cima*l5*sa*sb**2d0*vev1/2d0
  GC_110 = -cima*ca*cb**2d0*l2*vev2 + cima*ca*cb*l4*sb*vev1 + cima*ca*cb*l5*sb*&
           vev1 - cima*ca*l3*sb**2d0*vev2 + cima*cb**2d0*l3*sa*vev1 - cima*cb* &
           l4*sa*sb*vev2 - cima*cb*l5*sa*sb*vev2 + cima*l1*sa*sb**2d0*vev1
  GC_3685 = -2d0*GC_78
  GC_803 = -GC_132
  GC_1321 = -GC_69
  GC_1073 = -GC_83/2d0
  GC_1625 = -GC_194
  GC_951 = -GC_72
  GC_1305 = -2d0*GC_79
  GC_955 = -GC_91
  GC_1921 = -GC_3
  GC_1399 = -GC_17
  GC_1553 = -GC_92
  GC_1779 = -GC_96
  GC_2429 = -GC_94
  GC_3893 = -GC_82

  T8 = A0(cMC2_reg)
  T9 = A0(cMT2_reg)
  T6 = A0(cMTA2_reg)
  T7 = A0(cMU2_reg)
  T4 = A0(cME2_reg)
  T5 = A0(cMM2_reg)
  T2 = A0(cMHH2_reg)
  T3 = A0(cMW2_reg)
  T0 = A0(cMHL2_reg)
  T1 = A0(cMZ2_reg)
  T14 = A0(cMHA2_reg)
  T10 = A0(cMD2_reg)
  T11 = A0(cMS2_reg)
  T12 = A0(cMB2_reg)
  T13 = A0(cMHC2_reg)

  dZHh_MS = cima*DeltaUV*(2d0*GC_1055*GC_1321 - GC_1055*GC_69 - GC_1321*GC_68  &
             + 2d0*GC_133**2d0*Nc + 2d0*GC_137**2d0*Nc + 2d0*GC_149**2d0*Nc -  &
            GC_1505*GC_64 + GC_1553**2d0 - 2d0*GC_1553*GC_92 + 2d0*GC_157**2d0 &
             + 2d0*GC_165**2d0 + 2d0*GC_173**2d0*Nc + 2d0*GC_180**2d0*Nc + 2d0*&
            GC_188**2d0 + 2d0*GC_195**2d0*Nc + GC_2429**2d0 - GC_2429*GC_94 +  &
            2d0*GC_63*GC_64 - GC_63*GC_851 + GC_92**2d0 - GC_92*(-GC_1553 +    &
            GC_92))/(16d0*pi**2d0*GC_I)
  dZA_MS = cima*DeltaUV*(-12d0*GC_1**2d0*Nc - 2d0*GC_1399**2d0 - 2d0*GC_1399*  &
           GC_17 - 2d0*GC_17**2d0 + 4d0*GC_1921**2d0 - 12d0*GC_2**2d0*Nc + 5d0*&
           GC_3**2d0 - 11d0*GC_4**2d0)/(48d0*pi**2d0*GC_MI)
  dtHh_MS = cima*DeltaUV*(-GC_105*cMHH**2d0 - GC_106*cMHL**2d0 - 2d0*GC_118*   &
            cMHC**2d0 - GC_121*cMHA**2d0 + 8d0*GC_133*Nc*cMC**3d0 + 8d0*GC_137*&
            Nc*cMB**3d0 + 8d0*GC_149*Nc*cMD**3d0 + 8d0*GC_157*cME**3d0 + 8d0*  &
            GC_165*cMM**3d0 + 8d0*GC_173*Nc*cMS**3d0 + 8d0*GC_180*Nc*cMT**3d0  &
             + 8d0*GC_188*cMTA**3d0 + 8d0*GC_195*Nc*cMU**3d0 + 2d0*cMW**2d0*(- &
            GC_116 + 4d0*GC_125 + 2d0*GC_71) + cMZ**2d0*(-GC_117 + 4d0*GC_129  &
             + 2d0*GC_95))/(32d0*pi**2d0)
  dZHMinus_MS = cima*DeltaUV*(2d0*GC_1055*GC_1321 - GC_1055*GC_69 - GC_1321*   &
                GC_68 - GC_1399**2d0 + 2d0*GC_1399*GC_17 - GC_1505*GC_64 + 2d0*&
                GC_1505*GC_851 + 2d0*GC_154**2d0 + 2d0*GC_162**2d0 - GC_17**2d0&
                 - GC_1779**2d0 + 2d0*GC_1779*GC_96 + 2d0*GC_185**2d0 - GC_63* &
                GC_851 + 2d0*GC_72**2d0 - 4d0*GC_72*GC_951 - 2d0*GC_72*(GC_72  &
                 - GC_951) + 2d0*GC_951**2d0 - GC_96**2d0 - 2d0*Nc*(-GC_131**  &
                2d0 - GC_170**2d0) - 2d0*Nc*(-GC_142**2d0 - GC_178**2d0) - 2d0*&
                Nc*(-GC_146**2d0 - GC_193**2d0))/(32d0*pi**2d0*GC_I)
  dtHl_MS = cima*DeltaUV*(-GC_103*cMHH**2d0 - GC_104*cMHL**2d0 - 2d0*GC_110*   &
            cMHC**2d0 - GC_113*cMHA**2d0 + 8d0*GC_130*Nc*cMC**3d0 + 8d0*GC_141*&
            Nc*cMB**3d0 + 8d0*GC_145*Nc*cMD**3d0 + 8d0*GC_153*cME**3d0 + 8d0*  &
            GC_161*cMM**3d0 + 8d0*GC_169*Nc*cMS**3d0 + 8d0*GC_177*Nc*cMT**3d0  &
             + 8d0*GC_184*cMTA**3d0 + 8d0*GC_192*Nc*cMU**3d0 + 2d0*cMW**2d0*(- &
            GC_108 + 4d0*GC_124 + 2d0*GC_67) + cMZ**2d0*(-GC_109 + 4d0*GC_128  &
             + 2d0*GC_93))/(32d0*pi**2d0)
  dtHh = cima*(-GC_105*T2 - GC_106*T0 - 2d0*GC_116*T3 - GC_117*T1 - 2d0*GC_118*&
         T13 - GC_121*T14 + 4d0*GC_125*(2d0*T3 - cMW**2d0) + 2d0*GC_129*(2d0*T1&
          - cMZ**2d0) + 8d0*GC_133*Nc*T8*cMC + 8d0*GC_137*Nc*T12*cMB + 8d0*    &
         GC_149*Nc*T10*cMD + 8d0*GC_157*T4*cME + 8d0*GC_165*T5*cMM + 8d0*GC_173&
         *Nc*T11*cMS + 8d0*GC_180*Nc*T9*cMT + 8d0*GC_188*T6*cMTA + 8d0*GC_195* &
         Nc*T7*cMU + 4d0*GC_71*T3 + 2d0*GC_95*T1)/(32d0*pi**2d0)
  dZHl_MS = cima*DeltaUV*(-GC_1055*GC_69 + 2d0*GC_130**2d0*Nc - GC_1321*GC_68  &
             + 2d0*GC_141**2d0*Nc + 2d0*GC_145**2d0*Nc - GC_1505*GC_64 + 2d0*  &
            GC_1505*GC_851 + 2d0*GC_153**2d0 + 2d0*GC_161**2d0 + 2d0*GC_169**  &
            2d0*Nc + 2d0*GC_177**2d0*Nc + 2d0*GC_184**2d0 + 2d0*GC_192**2d0*Nc &
             + GC_2429**2d0 - 2d0*GC_2429*GC_94 - GC_63*GC_851 + 2d0*GC_68*    &
            GC_69 - GC_91*GC_955 + GC_94**2d0 - GC_94*(-GC_2429 + GC_94) +     &
            GC_955**2d0)/(16d0*pi**2d0*GC_I)
  dZHaG0_MS = DeltaUV*(2d0*cima*GC_109*GC_120 + 2d0*cima*GC_112*GC_117 + 2d0*  &
              cima*GC_112*GC_121 + 2d0*cima*GC_113*GC_120 + 2d0*cima*GC_1553*  &
              GC_2429*(cMHH**2d0 + cMZ**2d0) + 2d0*cima*GC_2429*GC_955*(cMHL** &
              2d0 + cMZ**2d0) + GC_28*cMHL**2d0 + GC_29*cMHH**2d0 + 2d0*GC_42* &
              cMHC**2d0 + 2d0*GC_43*cMW**2d0 + GC_46*cMHA**2d0 + GC_47*cMZ**2d0&
               + 8d0*cima*Nc*cMB**2d0*(-GC_139*GC_143 - GC_140*GC_144) + 4d0*  &
              cima*Nc*cMB**2d0*(-GC_139*GC_144 - GC_140*GC_143) + 8d0*cima*Nc* &
              cMC**2d0*(-GC_132*GC_135 - GC_136*GC_803) + 4d0*cima*Nc*cMC**2d0 &
              *(-GC_132*GC_136 - GC_135*GC_803) + 4d0*cima*Nc*cMD**2d0*(-GC_147&
              *GC_151 - GC_148*GC_152) + 8d0*cima*Nc*cMD**2d0*(-GC_147*GC_152  &
               - GC_148*GC_151) + 4d0*cima*Nc*cMS**2d0*(-GC_171*GC_175 - GC_172&
              *GC_176) + 8d0*cima*Nc*cMS**2d0*(-GC_171*GC_176 - GC_172*GC_175  &
              ) + 4d0*cima*Nc*cMT**2d0*(-GC_1759*GC_182 - GC_179*GC_183) + 8d0*&
              cima*Nc*cMT**2d0*(-GC_1759*GC_183 - GC_179*GC_182) + 4d0*cima*Nc*&
              cMU**2d0*(-GC_1625*GC_197 - GC_194*GC_198) + 8d0*cima*Nc*cMU**2d0&
              *(-GC_1625*GC_198 - GC_194*GC_197) + 4d0*cima*cME**2d0*(-GC_155* &
              GC_159 - GC_156*GC_160) + 8d0*cima*cME**2d0*(-GC_155*GC_160 -    &
              GC_156*GC_159) + 4d0*cima*cMM**2d0*(-GC_163*GC_167 - GC_164*     &
              GC_168) + 8d0*cima*cMM**2d0*(-GC_163*GC_168 - GC_164*GC_167) +   &
              4d0*cima*cMTA**2d0*(-GC_186*GC_190 - GC_187*GC_191) + 8d0*cima*  &
              cMTA**2d0*(-GC_186*GC_191 - GC_187*GC_190) + 2d0*cima*(GC_114*   &
              GC_122 + GC_115*GC_123))/(16d0*pi**2d0*GC_MHA) + 2d0*GC_112*     &
              dtHh_MS/(GC_MHA*cMHH**2d0) + 2d0*GC_120*dtHl_MS/(GC_MHA*cMHL**2d0&
              )
  dZZA_MS = DeltaUV*(4d0*cima*GC_1*Nc*cMB**2d0*(-GC_84 - GC_87) + 4d0*cima*GC_1&
            *Nc*cMB**2d0*(GC_84 + GC_87) + 4d0*cima*GC_1*Nc*cMD**2d0*(-GC_84 - &
            GC_87) + 4d0*cima*GC_1*Nc*cMD**2d0*(GC_84 + GC_87) + 4d0*cima*GC_1*&
            Nc*cMS**2d0*(-GC_84 - GC_87) + 4d0*cima*GC_1*Nc*cMS**2d0*(GC_84 +  &
            GC_87) - 4d0*cima*GC_102*GC_126 - 4d0*cima*GC_107*GC_127 + 4d0*cima&
            *GC_2*Nc*cMC**2d0*(-GC_85 - GC_88) + 4d0*cima*GC_2*Nc*cMC**2d0*(   &
            GC_85 + GC_88) + 4d0*cima*GC_2*Nc*cMT**2d0*(-GC_85 - GC_88) + 4d0* &
            cima*GC_2*Nc*cMT**2d0*(GC_85 + GC_88) + 4d0*cima*GC_2*Nc*cMU**2d0  &
            *(-GC_85 - GC_88) + 4d0*cima*GC_2*Nc*cMU**2d0*(GC_85 + GC_88) + 4d0&
            *cima*GC_4*cME**2d0*(-GC_86 - GC_89) + 4d0*cima*GC_4*cME**2d0*(    &
            GC_86 + GC_89) + 4d0*cima*GC_4*cMM**2d0*(-GC_86 - GC_89) + 4d0*cima&
            *GC_4*cMM**2d0*(GC_86 + GC_89) + 4d0*cima*GC_4*cMTA**2d0*(-GC_86 - &
            GC_89) + 4d0*cima*GC_4*cMTA**2d0*(GC_86 + GC_89) + 2d0*GC_97*cMHC**&
            2d0 + cima*cMHC**2d0*(GC_1399*GC_1779 - GC_1399*GC_96 - GC_17*     &
            GC_1779 + GC_17*GC_96) + 2d0*cMW**2d0*(-2d0*GC_1073 - 4d0*GC_83 +  &
            GC_97) + cima*cMW**2d0*(GC_1399*GC_1779 - GC_1399*GC_96 - GC_17*   &
            GC_1779 + GC_17*GC_96 + 9d0*GC_1921*GC_3893 + 8d0*GC_3*GC_82 - GC_4&
            *GC_81))/(16d0*pi**2d0*GC_MZ)
  dZG0Ha_MS = DeltaUV*(6d0*cima*GC_109*GC_120*(-GC_I*cMHA**2d0 - GC_MHA) + 6d0*&
              cima*GC_112*GC_117*(-GC_I*cMHA**2d0 - GC_MHA) + 6d0*cima*GC_112* &
              GC_121*GC_MHA + 6d0*cima*GC_112*GC_121*(-GC_I*cMHA**2d0 - GC_MHA &
              ) + 6d0*cima*GC_113*GC_120*GC_MHA + 6d0*cima*GC_113*GC_120*(-GC_I&
              *cMHA**2d0 - GC_MHA) + 2d0*cima*GC_1553*GC_2429*GC_MHA*cMHA**2d0 &
               + 2d0*cima*GC_1553*GC_2429*GC_MHA*(-cMHA**2d0 + 3d0*cMHH**2d0 + &
              3d0*cMZ**2d0) + 6d0*cima*GC_1553*GC_2429*(cMHH**2d0 + cMZ**2d0   &
              )*(-GC_I*cMHA**2d0 - GC_MHA) + 2d0*cima*GC_2429*GC_955*GC_MHA*   &
              cMHA**2d0 + 2d0*cima*GC_2429*GC_955*GC_MHA*(-cMHA**2d0 + 3d0*cMHL&
              **2d0 + 3d0*cMZ**2d0) + 6d0*cima*GC_2429*GC_955*(cMHL**2d0 + cMZ &
              **2d0)*(-GC_I*cMHA**2d0 - GC_MHA) - 3d0*GC_28*GC_I*cMHA**2d0*cMHL&
              **2d0 - 3d0*GC_29*GC_I*cMHA**2d0*cMHH**2d0 - 6d0*GC_42*GC_I*cMHA &
              **2d0*cMHC**2d0 - 6d0*GC_43*GC_I*cMHA**2d0*cMW**2d0 - 3d0*GC_46* &
              GC_I*cMHA**4d0 - 3d0*GC_47*GC_I*cMHA**2d0*cMZ**2d0 + 12d0*cima*  &
              GC_MHA*Nc*cMB**2d0*(-GC_139*GC_144 - GC_140*GC_143) + 12d0*cima* &
              GC_MHA*Nc*cMC**2d0*(-GC_132*GC_136 - GC_135*GC_803) + 12d0*cima* &
              GC_MHA*Nc*cMD**2d0*(-GC_147*GC_151 - GC_148*GC_152) - 2d0*cima*  &
              GC_MHA*Nc*cMHA**2d0*(-GC_132*GC_135 - GC_136*GC_803) - 2d0*cima* &
              GC_MHA*Nc*cMHA**2d0*(-GC_139*GC_143 - GC_140*GC_144) - 2d0*cima* &
              GC_MHA*Nc*cMHA**2d0*(-GC_147*GC_152 - GC_148*GC_151) - 2d0*cima* &
              GC_MHA*Nc*cMHA**2d0*(-GC_1625*GC_198 - GC_194*GC_197) - 2d0*cima*&
              GC_MHA*Nc*cMHA**2d0*(-GC_171*GC_176 - GC_172*GC_175) - 2d0*cima* &
              GC_MHA*Nc*cMHA**2d0*(-GC_1759*GC_183 - GC_179*GC_182) + 12d0*cima&
              *GC_MHA*Nc*cMS**2d0*(-GC_171*GC_175 - GC_172*GC_176) + 12d0*cima*&
              GC_MHA*Nc*cMT**2d0*(-GC_1759*GC_182 - GC_179*GC_183) + 12d0*cima*&
              GC_MHA*Nc*cMU**2d0*(-GC_1625*GC_197 - GC_194*GC_198) + 4d0*cima* &
              GC_MHA*Nc*(6d0*cMB**2d0 - cMHA**2d0)*(-GC_139*GC_143 - GC_140*   &
              GC_144) + 4d0*cima*GC_MHA*Nc*(6d0*cMC**2d0 - cMHA**2d0)*(-GC_132*&
              GC_135 - GC_136*GC_803) + 4d0*cima*GC_MHA*Nc*(6d0*cMD**2d0 - cMHA&
              **2d0)*(-GC_147*GC_152 - GC_148*GC_151) + 4d0*cima*GC_MHA*Nc*(-  &
              cMHA**2d0 + 6d0*cMS**2d0)*(-GC_171*GC_176 - GC_172*GC_175) + 4d0*&
              cima*GC_MHA*Nc*(-cMHA**2d0 + 6d0*cMT**2d0)*(-GC_1759*GC_183 -    &
              GC_179*GC_182) + 4d0*cima*GC_MHA*Nc*(-cMHA**2d0 + 6d0*cMU**2d0   &
              )*(-GC_1625*GC_198 - GC_194*GC_197) + 12d0*cima*GC_MHA*cME**2d0  &
              *(-GC_155*GC_159 - GC_156*GC_160) - 2d0*cima*GC_MHA*cMHA**2d0*(- &
              GC_155*GC_160 - GC_156*GC_159) - 2d0*cima*GC_MHA*cMHA**2d0*(-    &
              GC_163*GC_168 - GC_164*GC_167) - 2d0*cima*GC_MHA*cMHA**2d0*(-    &
              GC_186*GC_191 - GC_187*GC_190) - 3d0*cima*GC_MHA*cMHA**2d0*(2d0* &
              GC_1553*GC_2429 - GC_1553*GC_94 - GC_2429*GC_92) - 3d0*cima*     &
              GC_MHA*cMHA**2d0*(-GC_2429*GC_91 + 2d0*GC_2429*GC_955 - GC_94*   &
              GC_955) + 12d0*cima*GC_MHA*cMM**2d0*(-GC_163*GC_167 - GC_164*    &
              GC_168) + 12d0*cima*GC_MHA*cMTA**2d0*(-GC_186*GC_190 - GC_187*   &
              GC_191) + 4d0*cima*GC_MHA*(6d0*cME**2d0 - cMHA**2d0)*(-GC_155*   &
              GC_160 - GC_156*GC_159) + 4d0*cima*GC_MHA*(-cMHA**2d0 + 6d0*cMM**&
              2d0)*(-GC_163*GC_168 - GC_164*GC_167) + 4d0*cima*GC_MHA*(-cMHA** &
              2d0 + 6d0*cMTA**2d0)*(-GC_186*GC_191 - GC_187*GC_190) + 6d0*cima*&
              GC_MHA*(GC_114*GC_122 + GC_115*GC_123) + 6d0*cima*GC_MHA*(GC_109*&
              GC_120 - GC_2429*GC_91*cMHA**2d0 + GC_2429*GC_955*cMHA**2d0 +    &
              GC_91*GC_94*cMHA**2d0 - GC_94*GC_955*cMHA**2d0) + 6d0*cima*GC_MHA&
              *(GC_112*GC_117 + GC_1553*GC_2429*cMHA**2d0 - GC_1553*GC_94*cMHA &
              **2d0 - GC_2429*GC_92*cMHA**2d0 + GC_92*GC_94*cMHA**2d0) + 24d0* &
              cima*Nc*cMB**2d0*(GC_139*GC_143*GC_I*cMHA**2d0 + GC_139*GC_143*  &
              GC_MHA + GC_140*GC_144*GC_I*cMHA**2d0 + GC_140*GC_144*GC_MHA) +  &
              12d0*cima*Nc*cMB**2d0*(GC_139*GC_144*GC_I*cMHA**2d0 + GC_139*    &
              GC_144*GC_MHA + GC_140*GC_143*GC_I*cMHA**2d0 + GC_140*GC_143*    &
              GC_MHA) + 24d0*cima*Nc*cMC**2d0*(GC_132*GC_135*GC_I*cMHA**2d0 +  &
              GC_132*GC_135*GC_MHA + GC_136*GC_803*GC_I*cMHA**2d0 + GC_136*    &
              GC_803*GC_MHA) + 12d0*cima*Nc*cMC**2d0*(GC_132*GC_136*GC_I*cMHA**&
              2d0 + GC_132*GC_136*GC_MHA + GC_135*GC_803*GC_I*cMHA**2d0 +      &
              GC_135*GC_803*GC_MHA) + 12d0*cima*Nc*cMD**2d0*(GC_147*GC_151*GC_I&
              *cMHA**2d0 + GC_147*GC_151*GC_MHA + GC_148*GC_152*GC_I*cMHA**2d0 &
               + GC_148*GC_152*GC_MHA) + 24d0*cima*Nc*cMD**2d0*(GC_147*GC_152* &
              GC_I*cMHA**2d0 + GC_147*GC_152*GC_MHA + GC_148*GC_151*GC_I*cMHA**&
              2d0 + GC_148*GC_151*GC_MHA) + 12d0*cima*Nc*cMS**2d0*(GC_171*     &
              GC_175*GC_I*cMHA**2d0 + GC_171*GC_175*GC_MHA + GC_172*GC_176*GC_I&
              *cMHA**2d0 + GC_172*GC_176*GC_MHA) + 24d0*cima*Nc*cMS**2d0*(     &
              GC_171*GC_176*GC_I*cMHA**2d0 + GC_171*GC_176*GC_MHA + GC_172*    &
              GC_175*GC_I*cMHA**2d0 + GC_172*GC_175*GC_MHA) + 12d0*cima*Nc*cMT &
              **2d0*(GC_1759*GC_182*GC_I*cMHA**2d0 + GC_1759*GC_182*GC_MHA +   &
              GC_179*GC_183*GC_I*cMHA**2d0 + GC_179*GC_183*GC_MHA) + 24d0*cima*&
              Nc*cMT**2d0*(GC_1759*GC_183*GC_I*cMHA**2d0 + GC_1759*GC_183*     &
              GC_MHA + GC_179*GC_182*GC_I*cMHA**2d0 + GC_179*GC_182*GC_MHA) +  &
              12d0*cima*Nc*cMU**2d0*(GC_1625*GC_197*GC_I*cMHA**2d0 + GC_1625*  &
              GC_197*GC_MHA + GC_194*GC_198*GC_I*cMHA**2d0 + GC_194*GC_198*    &
              GC_MHA) + 24d0*cima*Nc*cMU**2d0*(GC_1625*GC_198*GC_I*cMHA**2d0 + &
              GC_1625*GC_198*GC_MHA + GC_194*GC_197*GC_I*cMHA**2d0 + GC_194*   &
              GC_197*GC_MHA) + 12d0*cima*cME**2d0*(GC_155*GC_159*GC_I*cMHA**2d0&
               + GC_155*GC_159*GC_MHA + GC_156*GC_160*GC_I*cMHA**2d0 + GC_156* &
              GC_160*GC_MHA) + 24d0*cima*cME**2d0*(GC_155*GC_160*GC_I*cMHA**2d0&
               + GC_155*GC_160*GC_MHA + GC_156*GC_159*GC_I*cMHA**2d0 + GC_156* &
              GC_159*GC_MHA) + 12d0*cima*cMM**2d0*(GC_163*GC_167*GC_I*cMHA**2d0&
               + GC_163*GC_167*GC_MHA + GC_164*GC_168*GC_I*cMHA**2d0 + GC_164* &
              GC_168*GC_MHA) + 24d0*cima*cMM**2d0*(GC_163*GC_168*GC_I*cMHA**2d0&
               + GC_163*GC_168*GC_MHA + GC_164*GC_167*GC_I*cMHA**2d0 + GC_164* &
              GC_167*GC_MHA) + 12d0*cima*cMTA**2d0*(GC_186*GC_190*GC_I*cMHA**  &
              2d0 + GC_186*GC_190*GC_MHA + GC_187*GC_191*GC_I*cMHA**2d0 +      &
              GC_187*GC_191*GC_MHA) + 24d0*cima*cMTA**2d0*(GC_186*GC_191*GC_I* &
              cMHA**2d0 + GC_186*GC_191*GC_MHA + GC_187*GC_190*GC_I*cMHA**2d0  &
               + GC_187*GC_190*GC_MHA) + 6d0*cima*(-GC_114*GC_122*GC_I*cMHA**  &
              2d0 - GC_114*GC_122*GC_MHA - GC_115*GC_123*GC_I*cMHA**2d0 -      &
              GC_115*GC_123*GC_MHA))/(48d0*pi**2d0*GC_I*GC_MHA*cMHA**2d0) - 2d0&
              *GC_112*dtHh_MS/(GC_MHA*cMHH**2d0) - 2d0*GC_120*dtHl_MS/(GC_MHA* &
              cMHL**2d0)
  db_MS = dZG0Ha_MS/4d0 - dZHaG0_MS/4d0
  dtHl = cima*(-GC_103*T2 - GC_104*T0 - 2d0*GC_108*T3 - GC_109*T1 - 2d0*GC_110*&
         T13 - GC_113*T14 + 4d0*GC_124*(2d0*T3 - cMW**2d0) + 2d0*GC_128*(2d0*T1&
          - cMZ**2d0) + 8d0*GC_130*Nc*T8*cMC + 8d0*GC_141*Nc*T12*cMB + 8d0*    &
         GC_145*Nc*T10*cMD + 8d0*GC_153*T4*cME + 8d0*GC_161*T5*cMM + 8d0*GC_169&
         *Nc*T11*cMS + 8d0*GC_177*Nc*T9*cMT + 8d0*GC_184*T6*cMTA + 8d0*GC_192* &
         Nc*T7*cMU + 4d0*GC_67*T3 + 2d0*GC_93*T1)/(32d0*pi**2d0)
  dMZ2_MS = DeltaUV*(-12d0*cima*GC_100*GC_MI*cMHC**2d0*rMZ**4d0 - 24d0*GC_102**&
            2d0*GC_MI*rMZ**4d0 - 12d0*GC_128**2d0*GC_MI*rMZ**4d0 - 12d0*GC_129 &
            **2d0*GC_MI*rMZ**4d0 + GC_1553**2d0*GC_MI*cMHA**4d0*rMZ**2d0 - 2d0*&
            GC_1553**2d0*GC_MI*cMHA**2d0*cMHH**2d0*rMZ**2d0 + GC_1553**2d0*    &
            GC_MI*cMHH**4d0*rMZ**2d0 - GC_1553**2d0*GC_MI*rMZ**6d0 + GC_1553** &
            2d0*GC_MZ*cMHA**4d0 - 2d0*GC_1553**2d0*GC_MZ*cMHA**2d0*cMHH**2d0 + &
            GC_1553**2d0*GC_MZ*cMHH**4d0 - GC_1553**2d0*GC_MZ*rMZ**4d0 - 2d0*  &
            GC_1553*GC_92*GC_MI*cMHA**4d0*rMZ**2d0 + 4d0*GC_1553*GC_92*GC_MI*  &
            cMHA**2d0*cMHH**2d0*rMZ**2d0 - 2d0*GC_1553*GC_92*GC_MI*cMHH**4d0*  &
            rMZ**2d0 + 2d0*GC_1553*GC_92*GC_MI*rMZ**6d0 - 2d0*GC_1553*GC_92*   &
            GC_MZ*cMHA**4d0 + 4d0*GC_1553*GC_92*GC_MZ*cMHA**2d0*cMHH**2d0 - 2d0&
            *GC_1553*GC_92*GC_MZ*cMHH**4d0 + 2d0*GC_1553*GC_92*GC_MZ*rMZ**4d0  &
             + GC_2429**2d0*GC_MI*cMHA**4d0*rMZ**2d0 - 2d0*GC_2429**2d0*GC_MI* &
            cMHA**2d0*cMHL**2d0*rMZ**2d0 + GC_2429**2d0*GC_MI*cMHH**4d0*rMZ**  &
            2d0 - 2d0*GC_2429**2d0*GC_MI*cMHH**2d0*cMZ**2d0*rMZ**2d0 + GC_2429 &
            **2d0*GC_MI*cMHL**4d0*rMZ**2d0 + GC_2429**2d0*GC_MI*cMZ**4d0*rMZ** &
            2d0 - 2d0*GC_2429**2d0*GC_MI*rMZ**6d0 + GC_2429**2d0*GC_MZ*cMHA**  &
            4d0 - 2d0*GC_2429**2d0*GC_MZ*cMHA**2d0*cMHL**2d0 + GC_2429**2d0*   &
            GC_MZ*cMHH**4d0 - 2d0*GC_2429**2d0*GC_MZ*cMHH**2d0*cMZ**2d0 +      &
            GC_2429**2d0*GC_MZ*cMHL**4d0 + GC_2429**2d0*GC_MZ*cMZ**4d0 - 2d0*  &
            GC_2429**2d0*GC_MZ*rMZ**4d0 - 2d0*GC_2429*GC_94*GC_MI*cMHA**4d0*rMZ&
            **2d0 + 4d0*GC_2429*GC_94*GC_MI*cMHA**2d0*cMHL**2d0*rMZ**2d0 - 2d0*&
            GC_2429*GC_94*GC_MI*cMHH**4d0*rMZ**2d0 + 4d0*GC_2429*GC_94*GC_MI*  &
            cMHH**2d0*cMZ**2d0*rMZ**2d0 - 2d0*GC_2429*GC_94*GC_MI*cMHL**4d0*rMZ&
            **2d0 - 2d0*GC_2429*GC_94*GC_MI*cMZ**4d0*rMZ**2d0 + 4d0*GC_2429*   &
            GC_94*GC_MI*rMZ**6d0 - 2d0*GC_2429*GC_94*GC_MZ*cMHA**4d0 + 4d0*    &
            GC_2429*GC_94*GC_MZ*cMHA**2d0*cMHL**2d0 - 2d0*GC_2429*GC_94*GC_MZ* &
            cMHH**4d0 + 4d0*GC_2429*GC_94*GC_MZ*cMHH**2d0*cMZ**2d0 - 2d0*      &
            GC_2429*GC_94*GC_MZ*cMHL**4d0 - 2d0*GC_2429*GC_94*GC_MZ*cMZ**4d0 + &
            4d0*GC_2429*GC_94*GC_MZ*rMZ**4d0 - 24d0*GC_90**2d0*GC_MI*rMZ**6d0  &
             + 24d0*GC_90**2d0*rMZ**4d0*(GC_MI*rMZ**2d0 + GC_MZ) + GC_91**2d0* &
            GC_MI*cMHL**4d0*rMZ**2d0 - 2d0*GC_91**2d0*GC_MI*cMHL**2d0*cMZ**2d0*&
            rMZ**2d0 + GC_91**2d0*GC_MI*cMZ**4d0*rMZ**2d0 - GC_91**2d0*GC_MI*  &
            rMZ**6d0 + GC_91**2d0*GC_MZ*cMHL**4d0 - 2d0*GC_91**2d0*GC_MZ*cMHL**&
            2d0*cMZ**2d0 + GC_91**2d0*GC_MZ*cMZ**4d0 - GC_91**2d0*GC_MZ*rMZ**  &
            4d0 - 2d0*GC_91*GC_955*GC_MI*cMHL**4d0*rMZ**2d0 + 4d0*GC_91*GC_955*&
            GC_MI*cMHL**2d0*cMZ**2d0*rMZ**2d0 - 2d0*GC_91*GC_955*GC_MI*cMZ**4d0&
            *rMZ**2d0 + 2d0*GC_91*GC_955*GC_MI*rMZ**6d0 - 2d0*GC_91*GC_955*    &
            GC_MZ*cMHL**4d0 + 4d0*GC_91*GC_955*GC_MZ*cMHL**2d0*cMZ**2d0 - 2d0* &
            GC_91*GC_955*GC_MZ*cMZ**4d0 + 2d0*GC_91*GC_955*GC_MZ*rMZ**4d0 +    &
            GC_92**2d0*GC_MI*cMHA**4d0*rMZ**2d0 - 2d0*GC_92**2d0*GC_MI*cMHA**  &
            2d0*cMHH**2d0*rMZ**2d0 + GC_92**2d0*GC_MI*cMHH**4d0*rMZ**2d0 -     &
            GC_92**2d0*GC_MI*rMZ**6d0 + GC_92**2d0*GC_MZ*cMHA**4d0 - 2d0*GC_92 &
            **2d0*GC_MZ*cMHA**2d0*cMHH**2d0 + GC_92**2d0*GC_MZ*cMHH**4d0 -     &
            GC_92**2d0*GC_MZ*rMZ**4d0 + GC_94**2d0*GC_MI*cMHA**4d0*rMZ**2d0 -  &
            2d0*GC_94**2d0*GC_MI*cMHA**2d0*cMHL**2d0*rMZ**2d0 + GC_94**2d0*    &
            GC_MI*cMHH**4d0*rMZ**2d0 - 2d0*GC_94**2d0*GC_MI*cMHH**2d0*cMZ**2d0*&
            rMZ**2d0 + GC_94**2d0*GC_MI*cMHL**4d0*rMZ**2d0 + GC_94**2d0*GC_MI* &
            cMZ**4d0*rMZ**2d0 - 2d0*GC_94**2d0*GC_MI*rMZ**6d0 + GC_94**2d0*    &
            GC_MZ*cMHA**4d0 - 2d0*GC_94**2d0*GC_MZ*cMHA**2d0*cMHL**2d0 + GC_94 &
            **2d0*GC_MZ*cMHH**4d0 - 2d0*GC_94**2d0*GC_MZ*cMHH**2d0*cMZ**2d0 +  &
            GC_94**2d0*GC_MZ*cMHL**4d0 + GC_94**2d0*GC_MZ*cMZ**4d0 - 2d0*GC_94 &
            **2d0*GC_MZ*rMZ**4d0 + GC_955**2d0*GC_MI*cMHL**4d0*rMZ**2d0 - 2d0* &
            GC_955**2d0*GC_MI*cMHL**2d0*cMZ**2d0*rMZ**2d0 + GC_955**2d0*GC_MI* &
            cMZ**4d0*rMZ**2d0 - GC_955**2d0*GC_MI*rMZ**6d0 + GC_955**2d0*GC_MZ*&
            cMHL**4d0 - 2d0*GC_955**2d0*GC_MZ*cMHL**2d0*cMZ**2d0 + GC_955**2d0*&
            GC_MZ*cMZ**4d0 - GC_955**2d0*GC_MZ*rMZ**4d0 - 12d0*GC_MI*Nc*rMZ**  &
            6d0*(GC_84**2d0 + GC_87**2d0) - 12d0*GC_MI*Nc*rMZ**6d0*(GC_85**2d0 &
             + GC_88**2d0) + 4d0*GC_MI*Nc*rMZ**4d0*(GC_84**2d0 + GC_87**2d0)*( &
            6d0*cMB**2d0 - rMZ**2d0) + 4d0*GC_MI*Nc*rMZ**4d0*(GC_84**2d0 +     &
            GC_87**2d0)*(6d0*cMD**2d0 - rMZ**2d0) + 4d0*GC_MI*Nc*rMZ**4d0*(    &
            GC_84**2d0 + GC_87**2d0)*(6d0*cMS**2d0 - rMZ**2d0) + 4d0*GC_MI*Nc* &
            rMZ**4d0*(GC_85**2d0 + GC_88**2d0)*(6d0*cMC**2d0 - rMZ**2d0) + 4d0*&
            GC_MI*Nc*rMZ**4d0*(GC_85**2d0 + GC_88**2d0)*(6d0*cMT**2d0 - rMZ**  &
            2d0) + 4d0*GC_MI*Nc*rMZ**4d0*(GC_85**2d0 + GC_88**2d0)*(6d0*cMU**  &
            2d0 - rMZ**2d0) + 12d0*cima*GC_MI*cMW**2d0*rMZ**4d0*(-GC_100 + 4d0*&
            GC_1305 + 2d0*GC_79) - 2d0*GC_MI*rMZ**6d0*(GC_3893**2d0 + GC_82**  &
            2d0) - 12d0*GC_MI*rMZ**6d0*(GC_86**2d0 + GC_89**2d0) + 4d0*GC_MI*  &
            rMZ**4d0*(GC_86**2d0 + GC_89**2d0)*(6d0*cME**2d0 - rMZ**2d0) + 4d0*&
            GC_MI*rMZ**4d0*(GC_86**2d0 + GC_89**2d0)*(6d0*cMM**2d0 - rMZ**2d0  &
            ) + 4d0*GC_MI*rMZ**4d0*(GC_86**2d0 + GC_89**2d0)*(6d0*cMTA**2d0 -  &
            rMZ**2d0) + GC_MI*rMZ**4d0*(6d0*cMHC**2d0 - rMZ**2d0)*(GC_1779**2d0&
             - 2d0*GC_1779*GC_96 + GC_96**2d0) + GC_MI*rMZ**4d0*(6d0*cMW**2d0  &
             - rMZ**2d0)*(GC_1779**2d0 - 2d0*GC_1779*GC_96 + 9d0*GC_3893**2d0  &
             - GC_81**2d0 + 8d0*GC_82**2d0 + GC_96**2d0) + GC_MI*rMZ**4d0*(-   &
            GC_1553**2d0 + 2d0*GC_1553*GC_92 - GC_92**2d0)*(3d0*cMHA**2d0 + 3d0&
            *cMHH**2d0 - rMZ**2d0) + GC_MI*rMZ**4d0*(-GC_2429**2d0 + 2d0*      &
            GC_2429*GC_94 - GC_94**2d0)*(3d0*cMHA**2d0 + 3d0*cMHL**2d0 - rMZ** &
            2d0) + GC_MI*rMZ**4d0*(-GC_2429**2d0 + 2d0*GC_2429*GC_94 - GC_94** &
            2d0)*(3d0*cMHH**2d0 + 3d0*cMZ**2d0 - rMZ**2d0) + GC_MI*rMZ**4d0*(- &
            GC_91**2d0 + 2d0*GC_91*GC_955 - GC_955**2d0)*(3d0*cMHL**2d0 + 3d0* &
            cMZ**2d0 - rMZ**2d0) + 8d0*Nc*rMZ**4d0*(GC_84**2d0*GC_MI*rMZ**2d0  &
             + GC_84**2d0*GC_MZ - 6d0*GC_84*GC_87*GC_MI*cMB**2d0 + GC_87**2d0* &
            GC_MI*rMZ**2d0 + GC_87**2d0*GC_MZ) + 8d0*Nc*rMZ**4d0*(GC_84**2d0*  &
            GC_MI*rMZ**2d0 + GC_84**2d0*GC_MZ - 6d0*GC_84*GC_87*GC_MI*cMD**2d0 &
             + GC_87**2d0*GC_MI*rMZ**2d0 + GC_87**2d0*GC_MZ) + 8d0*Nc*rMZ**4d0 &
            *(GC_84**2d0*GC_MI*rMZ**2d0 + GC_84**2d0*GC_MZ - 6d0*GC_84*GC_87*  &
            GC_MI*cMS**2d0 + GC_87**2d0*GC_MI*rMZ**2d0 + GC_87**2d0*GC_MZ) +   &
            8d0*Nc*rMZ**4d0*(GC_85**2d0*GC_MI*rMZ**2d0 + GC_85**2d0*GC_MZ - 6d0&
            *GC_85*GC_88*GC_MI*cMC**2d0 + GC_88**2d0*GC_MI*rMZ**2d0 + GC_88**  &
            2d0*GC_MZ) + 8d0*Nc*rMZ**4d0*(GC_85**2d0*GC_MI*rMZ**2d0 + GC_85**  &
            2d0*GC_MZ - 6d0*GC_85*GC_88*GC_MI*cMT**2d0 + GC_88**2d0*GC_MI*rMZ**&
            2d0 + GC_88**2d0*GC_MZ) + 8d0*Nc*rMZ**4d0*(GC_85**2d0*GC_MI*rMZ**  &
            2d0 + GC_85**2d0*GC_MZ - 6d0*GC_85*GC_88*GC_MI*cMU**2d0 + GC_88**  &
            2d0*GC_MI*rMZ**2d0 + GC_88**2d0*GC_MZ) + cMHA**2d0*(-6d0*cima*     &
            GC_101*GC_MI*rMZ**4d0 - GC_1553**2d0*GC_MI*cMHA**2d0*rMZ**2d0 +    &
            GC_1553**2d0*GC_MI*cMHH**2d0*rMZ**2d0 - GC_1553**2d0*GC_MZ*cMHA**  &
            2d0 + GC_1553**2d0*GC_MZ*cMHH**2d0 + 2d0*GC_1553*GC_92*GC_MI*cMHA**&
            2d0*rMZ**2d0 - 2d0*GC_1553*GC_92*GC_MI*cMHH**2d0*rMZ**2d0 + 2d0*   &
            GC_1553*GC_92*GC_MZ*cMHA**2d0 - 2d0*GC_1553*GC_92*GC_MZ*cMHH**2d0  &
             - GC_2429**2d0*GC_MI*cMHA**2d0*rMZ**2d0 + GC_2429**2d0*GC_MI*cMHL &
            **2d0*rMZ**2d0 - GC_2429**2d0*GC_MZ*cMHA**2d0 + GC_2429**2d0*GC_MZ*&
            cMHL**2d0 + 2d0*GC_2429*GC_94*GC_MI*cMHA**2d0*rMZ**2d0 - 2d0*      &
            GC_2429*GC_94*GC_MI*cMHL**2d0*rMZ**2d0 + 2d0*GC_2429*GC_94*GC_MZ*  &
            cMHA**2d0 - 2d0*GC_2429*GC_94*GC_MZ*cMHL**2d0 - GC_92**2d0*GC_MI*  &
            cMHA**2d0*rMZ**2d0 + GC_92**2d0*GC_MI*cMHH**2d0*rMZ**2d0 - GC_92** &
            2d0*GC_MZ*cMHA**2d0 + GC_92**2d0*GC_MZ*cMHH**2d0 - GC_94**2d0*GC_MI&
            *cMHA**2d0*rMZ**2d0 + GC_94**2d0*GC_MI*cMHL**2d0*rMZ**2d0 - GC_94**&
            2d0*GC_MZ*cMHA**2d0 + GC_94**2d0*GC_MZ*cMHL**2d0) + cMHH**2d0*(    &
            GC_1553**2d0*GC_MI*cMHA**2d0*rMZ**2d0 - GC_1553**2d0*GC_MI*cMHH**  &
            2d0*rMZ**2d0 + GC_1553**2d0*GC_MZ*cMHA**2d0 - GC_1553**2d0*GC_MZ*  &
            cMHH**2d0 - 2d0*GC_1553*GC_92*GC_MI*cMHA**2d0*rMZ**2d0 + 2d0*      &
            GC_1553*GC_92*GC_MI*cMHH**2d0*rMZ**2d0 - 2d0*GC_1553*GC_92*GC_MZ*  &
            cMHA**2d0 + 2d0*GC_1553*GC_92*GC_MZ*cMHH**2d0 - GC_2429**2d0*GC_MI*&
            cMHH**2d0*rMZ**2d0 + GC_2429**2d0*GC_MI*cMZ**2d0*rMZ**2d0 - GC_2429&
            **2d0*GC_MZ*cMHH**2d0 + GC_2429**2d0*GC_MZ*cMZ**2d0 + 2d0*GC_2429* &
            GC_94*GC_MI*cMHH**2d0*rMZ**2d0 - 2d0*GC_2429*GC_94*GC_MI*cMZ**2d0* &
            rMZ**2d0 + 2d0*GC_2429*GC_94*GC_MZ*cMHH**2d0 - 2d0*GC_2429*GC_94*  &
            GC_MZ*cMZ**2d0 + GC_92**2d0*GC_MI*cMHA**2d0*rMZ**2d0 - GC_92**2d0* &
            GC_MI*cMHH**2d0*rMZ**2d0 + GC_92**2d0*GC_MZ*cMHA**2d0 - GC_92**2d0*&
            GC_MZ*cMHH**2d0 - GC_94**2d0*GC_MI*cMHH**2d0*rMZ**2d0 + GC_94**2d0*&
            GC_MI*cMZ**2d0*rMZ**2d0 - GC_94**2d0*GC_MZ*cMHH**2d0 + GC_94**2d0* &
            GC_MZ*cMZ**2d0 - 6d0*cima*GC_99*GC_MI*rMZ**4d0) + cMHL**2d0*(      &
            GC_2429**2d0*GC_MI*cMHA**2d0*rMZ**2d0 - GC_2429**2d0*GC_MI*cMHL**  &
            2d0*rMZ**2d0 + GC_2429**2d0*GC_MZ*cMHA**2d0 - GC_2429**2d0*GC_MZ*  &
            cMHL**2d0 - 2d0*GC_2429*GC_94*GC_MI*cMHA**2d0*rMZ**2d0 + 2d0*      &
            GC_2429*GC_94*GC_MI*cMHL**2d0*rMZ**2d0 - 2d0*GC_2429*GC_94*GC_MZ*  &
            cMHA**2d0 + 2d0*GC_2429*GC_94*GC_MZ*cMHL**2d0 - GC_91**2d0*GC_MI*  &
            cMHL**2d0*rMZ**2d0 + GC_91**2d0*GC_MI*cMZ**2d0*rMZ**2d0 - GC_91**  &
            2d0*GC_MZ*cMHL**2d0 + GC_91**2d0*GC_MZ*cMZ**2d0 + 2d0*GC_91*GC_955*&
            GC_MI*cMHL**2d0*rMZ**2d0 - 2d0*GC_91*GC_955*GC_MI*cMZ**2d0*rMZ**2d0&
             + 2d0*GC_91*GC_955*GC_MZ*cMHL**2d0 - 2d0*GC_91*GC_955*GC_MZ*cMZ** &
            2d0 + GC_94**2d0*GC_MI*cMHA**2d0*rMZ**2d0 - GC_94**2d0*GC_MI*cMHL**&
            2d0*rMZ**2d0 + GC_94**2d0*GC_MZ*cMHA**2d0 - GC_94**2d0*GC_MZ*cMHL**&
            2d0 - GC_955**2d0*GC_MI*cMHL**2d0*rMZ**2d0 + GC_955**2d0*GC_MI*cMZ &
            **2d0*rMZ**2d0 - GC_955**2d0*GC_MZ*cMHL**2d0 + GC_955**2d0*GC_MZ*  &
            cMZ**2d0 - 6d0*cima*GC_99*GC_MI*rMZ**4d0) + cMZ**2d0*(-6d0*cima*   &
            GC_101*GC_MI*rMZ**4d0 + GC_2429**2d0*GC_MI*cMHH**2d0*rMZ**2d0 -    &
            GC_2429**2d0*GC_MI*cMZ**2d0*rMZ**2d0 + GC_2429**2d0*GC_MZ*cMHH**2d0&
             - GC_2429**2d0*GC_MZ*cMZ**2d0 - 2d0*GC_2429*GC_94*GC_MI*cMHH**2d0*&
            rMZ**2d0 + 2d0*GC_2429*GC_94*GC_MI*cMZ**2d0*rMZ**2d0 - 2d0*GC_2429*&
            GC_94*GC_MZ*cMHH**2d0 + 2d0*GC_2429*GC_94*GC_MZ*cMZ**2d0 + GC_91** &
            2d0*GC_MI*cMHL**2d0*rMZ**2d0 - GC_91**2d0*GC_MI*cMZ**2d0*rMZ**2d0  &
             + GC_91**2d0*GC_MZ*cMHL**2d0 - GC_91**2d0*GC_MZ*cMZ**2d0 - 2d0*   &
            GC_91*GC_955*GC_MI*cMHL**2d0*rMZ**2d0 + 2d0*GC_91*GC_955*GC_MI*cMZ &
            **2d0*rMZ**2d0 - 2d0*GC_91*GC_955*GC_MZ*cMHL**2d0 + 2d0*GC_91*     &
            GC_955*GC_MZ*cMZ**2d0 + GC_94**2d0*GC_MI*cMHH**2d0*rMZ**2d0 - GC_94&
            **2d0*GC_MI*cMZ**2d0*rMZ**2d0 + GC_94**2d0*GC_MZ*cMHH**2d0 - GC_94 &
            **2d0*GC_MZ*cMZ**2d0 + GC_955**2d0*GC_MI*cMHL**2d0*rMZ**2d0 -      &
            GC_955**2d0*GC_MI*cMZ**2d0*rMZ**2d0 + GC_955**2d0*GC_MZ*cMHL**2d0  &
             - GC_955**2d0*GC_MZ*cMZ**2d0) + 8d0*rMZ**4d0*(GC_86**2d0*GC_MI*rMZ&
            **2d0 + GC_86**2d0*GC_MZ - 6d0*GC_86*GC_89*GC_MI*cME**2d0 + GC_89**&
            2d0*GC_MI*rMZ**2d0 + GC_89**2d0*GC_MZ) + 8d0*rMZ**4d0*(GC_86**2d0* &
            GC_MI*rMZ**2d0 + GC_86**2d0*GC_MZ - 6d0*GC_86*GC_89*GC_MI*cMM**2d0 &
             + GC_89**2d0*GC_MI*rMZ**2d0 + GC_89**2d0*GC_MZ) + 8d0*rMZ**4d0*(  &
            GC_86**2d0*GC_MI*rMZ**2d0 + GC_86**2d0*GC_MZ - 6d0*GC_86*GC_89*    &
            GC_MI*cMTA**2d0 + GC_89**2d0*GC_MI*rMZ**2d0 + GC_89**2d0*GC_MZ) +  &
            rMZ**4d0*(GC_1779**2d0*GC_MI*rMZ**2d0 + GC_1779**2d0*GC_MZ - 2d0*  &
            GC_1779*GC_96*GC_MI*rMZ**2d0 - 2d0*GC_1779*GC_96*GC_MZ + GC_96**2d0&
            *GC_MI*rMZ**2d0 + GC_96**2d0*GC_MZ) + rMZ**4d0*(-24d0*GC_107**2d0* &
            GC_MI + GC_1779**2d0*GC_MI*rMZ**2d0 + GC_1779**2d0*GC_MZ - 2d0*    &
            GC_1779*GC_96*GC_MI*rMZ**2d0 - 2d0*GC_1779*GC_96*GC_MZ + 11d0*     &
            GC_3893**2d0*GC_MI*rMZ**2d0 - 19d0*GC_3893**2d0*GC_MZ - GC_81**2d0*&
            GC_MI*rMZ**2d0 - GC_81**2d0*GC_MZ + 10d0*GC_82**2d0*GC_MI*rMZ**2d0 &
             - 20d0*GC_82**2d0*GC_MZ + GC_96**2d0*GC_MI*rMZ**2d0 + GC_96**2d0* &
            GC_MZ))/(192d0*pi**2d0*GC_MI*rMZ**4d0) - cima*GC_128*dtHl_MS/cMHL**&
            2d0 - cima*GC_129*dtHh_MS/cMHH**2d0
  dMW2_MS = DeltaUV*(-12d0*GC_102**2d0*GC_MI*rMW**4d0 + GC_1055*GC_1321*GC_MI* &
            cMHC**4d0*rMW**2d0 - 2d0*GC_1055*GC_1321*GC_MI*cMHC**2d0*cMHL**2d0*&
            rMW**2d0 + GC_1055*GC_1321*GC_MI*cMHH**4d0*rMW**2d0 - 2d0*GC_1055* &
            GC_1321*GC_MI*cMHH**2d0*cMW**2d0*rMW**2d0 + GC_1055*GC_1321*GC_MI* &
            cMHL**4d0*rMW**2d0 + GC_1055*GC_1321*GC_MI*cMW**4d0*rMW**2d0 - 2d0*&
            GC_1055*GC_1321*GC_MI*rMW**6d0 + GC_1055*GC_1321*GC_MW*cMHC**4d0 - &
            2d0*GC_1055*GC_1321*GC_MW*cMHC**2d0*cMHL**2d0 + GC_1055*GC_1321*   &
            GC_MW*cMHH**4d0 - 2d0*GC_1055*GC_1321*GC_MW*cMHH**2d0*cMW**2d0 +   &
            GC_1055*GC_1321*GC_MW*cMHL**4d0 + GC_1055*GC_1321*GC_MW*cMW**4d0 - &
            2d0*GC_1055*GC_1321*GC_MW*rMW**4d0 - GC_1055*GC_69*GC_MI*cMHC**4d0*&
            rMW**2d0 + 2d0*GC_1055*GC_69*GC_MI*cMHC**2d0*cMHL**2d0*rMW**2d0 -  &
            GC_1055*GC_69*GC_MI*cMHH**4d0*rMW**2d0 + 2d0*GC_1055*GC_69*GC_MI*  &
            cMHH**2d0*cMW**2d0*rMW**2d0 - GC_1055*GC_69*GC_MI*cMHL**4d0*rMW**  &
            2d0 - GC_1055*GC_69*GC_MI*cMW**4d0*rMW**2d0 + 2d0*GC_1055*GC_69*   &
            GC_MI*rMW**6d0 - GC_1055*GC_69*GC_MW*cMHC**4d0 + 2d0*GC_1055*GC_69*&
            GC_MW*cMHC**2d0*cMHL**2d0 - GC_1055*GC_69*GC_MW*cMHH**4d0 + 2d0*   &
            GC_1055*GC_69*GC_MW*cMHH**2d0*cMW**2d0 - GC_1055*GC_69*GC_MW*cMHL**&
            4d0 - GC_1055*GC_69*GC_MW*cMW**4d0 + 2d0*GC_1055*GC_69*GC_MW*rMW** &
            4d0 - 12d0*GC_107**2d0*GC_MI*rMW**4d0 - 12d0*GC_124**2d0*GC_MI*rMW &
            **4d0 - 12d0*GC_125**2d0*GC_MI*rMW**4d0 - 12d0*GC_126**2d0*GC_MI*  &
            rMW**4d0 - 12d0*GC_127**2d0*GC_MI*rMW**4d0 - GC_1321*GC_68*GC_MI*  &
            cMHC**4d0*rMW**2d0 + 2d0*GC_1321*GC_68*GC_MI*cMHC**2d0*cMHL**2d0*  &
            rMW**2d0 - GC_1321*GC_68*GC_MI*cMHH**4d0*rMW**2d0 + 2d0*GC_1321*   &
            GC_68*GC_MI*cMHH**2d0*cMW**2d0*rMW**2d0 - GC_1321*GC_68*GC_MI*cMHL &
            **4d0*rMW**2d0 - GC_1321*GC_68*GC_MI*cMW**4d0*rMW**2d0 + 2d0*      &
            GC_1321*GC_68*GC_MI*rMW**6d0 - GC_1321*GC_68*GC_MW*cMHC**4d0 + 2d0*&
            GC_1321*GC_68*GC_MW*cMHC**2d0*cMHL**2d0 - GC_1321*GC_68*GC_MW*cMHH &
            **4d0 + 2d0*GC_1321*GC_68*GC_MW*cMHH**2d0*cMW**2d0 - GC_1321*GC_68*&
            GC_MW*cMHL**4d0 - GC_1321*GC_68*GC_MW*cMW**4d0 + 2d0*GC_1321*GC_68*&
            GC_MW*rMW**4d0 - GC_1505*GC_64*GC_MI*cMHC**4d0*rMW**2d0 + 2d0*     &
            GC_1505*GC_64*GC_MI*cMHC**2d0*cMHH**2d0*rMW**2d0 - GC_1505*GC_64*  &
            GC_MI*cMHH**4d0*rMW**2d0 - GC_1505*GC_64*GC_MI*cMHL**4d0*rMW**2d0  &
             + 2d0*GC_1505*GC_64*GC_MI*cMHL**2d0*cMW**2d0*rMW**2d0 - GC_1505*  &
            GC_64*GC_MI*cMW**4d0*rMW**2d0 + 2d0*GC_1505*GC_64*GC_MI*rMW**6d0 - &
            GC_1505*GC_64*GC_MW*cMHC**4d0 + 2d0*GC_1505*GC_64*GC_MW*cMHC**2d0* &
            cMHH**2d0 - GC_1505*GC_64*GC_MW*cMHH**4d0 - GC_1505*GC_64*GC_MW*   &
            cMHL**4d0 + 2d0*GC_1505*GC_64*GC_MW*cMHL**2d0*cMW**2d0 - GC_1505*  &
            GC_64*GC_MW*cMW**4d0 + 2d0*GC_1505*GC_64*GC_MW*rMW**4d0 + GC_1505* &
            GC_851*GC_MI*cMHC**4d0*rMW**2d0 - 2d0*GC_1505*GC_851*GC_MI*cMHC**  &
            2d0*cMHH**2d0*rMW**2d0 + GC_1505*GC_851*GC_MI*cMHH**4d0*rMW**2d0 + &
            GC_1505*GC_851*GC_MI*cMHL**4d0*rMW**2d0 - 2d0*GC_1505*GC_851*GC_MI*&
            cMHL**2d0*cMW**2d0*rMW**2d0 + GC_1505*GC_851*GC_MI*cMW**4d0*rMW**  &
            2d0 - 2d0*GC_1505*GC_851*GC_MI*rMW**6d0 + GC_1505*GC_851*GC_MW*cMHC&
            **4d0 - 2d0*GC_1505*GC_851*GC_MW*cMHC**2d0*cMHH**2d0 + GC_1505*    &
            GC_851*GC_MW*cMHH**4d0 + GC_1505*GC_851*GC_MW*cMHL**4d0 - 2d0*     &
            GC_1505*GC_851*GC_MW*cMHL**2d0*cMW**2d0 + GC_1505*GC_851*GC_MW*cMW &
            **4d0 - 2d0*GC_1505*GC_851*GC_MW*rMW**4d0 - 5d0*GC_1921**2d0*GC_MI*&
            cMW**4d0*rMW**2d0 + 11d0*GC_1921**2d0*GC_MI*rMW**6d0 - 5d0*GC_1921 &
            **2d0*GC_MW*cMW**4d0 - 19d0*GC_1921**2d0*GC_MW*rMW**4d0 - 4d0*GC_3 &
            **2d0*GC_MI*cMW**4d0*rMW**2d0 + 10d0*GC_3**2d0*GC_MI*rMW**6d0 - 4d0&
            *GC_3**2d0*GC_MW*cMW**4d0 - 20d0*GC_3**2d0*GC_MW*rMW**4d0 - 5d0*   &
            GC_3893**2d0*GC_MI*cMW**4d0*rMW**2d0 + 10d0*GC_3893**2d0*GC_MI*cMW &
            **2d0*cMZ**2d0*rMW**2d0 - 5d0*GC_3893**2d0*GC_MI*cMZ**4d0*rMW**2d0 &
             + 11d0*GC_3893**2d0*GC_MI*rMW**6d0 - 5d0*GC_3893**2d0*GC_MW*cMW** &
            4d0 + 10d0*GC_3893**2d0*GC_MW*cMW**2d0*cMZ**2d0 - 5d0*GC_3893**2d0*&
            GC_MW*cMZ**4d0 - 19d0*GC_3893**2d0*GC_MW*rMW**4d0 + GC_4**2d0*GC_MI&
            *cMW**4d0*rMW**2d0 - GC_4**2d0*GC_MI*rMW**6d0 + GC_4**2d0*GC_MW*cMW&
            **4d0 - GC_4**2d0*GC_MW*rMW**4d0 + GC_63*GC_64*GC_MI*cMHC**4d0*rMW &
            **2d0 - 2d0*GC_63*GC_64*GC_MI*cMHC**2d0*cMHH**2d0*rMW**2d0 + GC_63*&
            GC_64*GC_MI*cMHH**4d0*rMW**2d0 + GC_63*GC_64*GC_MI*cMHL**4d0*rMW** &
            2d0 - 2d0*GC_63*GC_64*GC_MI*cMHL**2d0*cMW**2d0*rMW**2d0 + GC_63*   &
            GC_64*GC_MI*cMW**4d0*rMW**2d0 - 2d0*GC_63*GC_64*GC_MI*rMW**6d0 +   &
            GC_63*GC_64*GC_MW*cMHC**4d0 - 2d0*GC_63*GC_64*GC_MW*cMHC**2d0*cMHH &
            **2d0 + GC_63*GC_64*GC_MW*cMHH**4d0 + GC_63*GC_64*GC_MW*cMHL**4d0  &
             - 2d0*GC_63*GC_64*GC_MW*cMHL**2d0*cMW**2d0 + GC_63*GC_64*GC_MW*cMW&
            **4d0 - 2d0*GC_63*GC_64*GC_MW*rMW**4d0 - GC_63*GC_851*GC_MI*cMHC** &
            4d0*rMW**2d0 + 2d0*GC_63*GC_851*GC_MI*cMHC**2d0*cMHH**2d0*rMW**2d0 &
             - GC_63*GC_851*GC_MI*cMHH**4d0*rMW**2d0 - GC_63*GC_851*GC_MI*cMHL &
            **4d0*rMW**2d0 + 2d0*GC_63*GC_851*GC_MI*cMHL**2d0*cMW**2d0*rMW**2d0&
             - GC_63*GC_851*GC_MI*cMW**4d0*rMW**2d0 + 2d0*GC_63*GC_851*GC_MI*  &
            rMW**6d0 - GC_63*GC_851*GC_MW*cMHC**4d0 + 2d0*GC_63*GC_851*GC_MW*  &
            cMHC**2d0*cMHH**2d0 - GC_63*GC_851*GC_MW*cMHH**4d0 - GC_63*GC_851* &
            GC_MW*cMHL**4d0 + 2d0*GC_63*GC_851*GC_MW*cMHL**2d0*cMW**2d0 - GC_63&
            *GC_851*GC_MW*cMW**4d0 + 2d0*GC_63*GC_851*GC_MW*rMW**4d0 + GC_68*  &
            GC_69*GC_MI*cMHC**4d0*rMW**2d0 - 2d0*GC_68*GC_69*GC_MI*cMHC**2d0*  &
            cMHL**2d0*rMW**2d0 + GC_68*GC_69*GC_MI*cMHH**4d0*rMW**2d0 - 2d0*   &
            GC_68*GC_69*GC_MI*cMHH**2d0*cMW**2d0*rMW**2d0 + GC_68*GC_69*GC_MI* &
            cMHL**4d0*rMW**2d0 + GC_68*GC_69*GC_MI*cMW**4d0*rMW**2d0 - 2d0*    &
            GC_68*GC_69*GC_MI*rMW**6d0 + GC_68*GC_69*GC_MW*cMHC**4d0 - 2d0*    &
            GC_68*GC_69*GC_MW*cMHC**2d0*cMHL**2d0 + GC_68*GC_69*GC_MW*cMHH**4d0&
             - 2d0*GC_68*GC_69*GC_MW*cMHH**2d0*cMW**2d0 + GC_68*GC_69*GC_MW*   &
            cMHL**4d0 + GC_68*GC_69*GC_MW*cMW**4d0 - 2d0*GC_68*GC_69*GC_MW*rMW &
            **4d0 + GC_72**2d0*GC_MI*cMHA**4d0*rMW**2d0 - 2d0*GC_72**2d0*GC_MI*&
            cMHA**2d0*cMHC**2d0*rMW**2d0 + GC_72**2d0*GC_MI*cMHC**4d0*rMW**2d0 &
             + GC_72**2d0*GC_MI*cMW**4d0*rMW**2d0 - 2d0*GC_72**2d0*GC_MI*cMW** &
            2d0*cMZ**2d0*rMW**2d0 + GC_72**2d0*GC_MI*cMZ**4d0*rMW**2d0 - 2d0*  &
            GC_72**2d0*GC_MI*rMW**6d0 + GC_72**2d0*GC_MW*cMHA**4d0 - 2d0*GC_72 &
            **2d0*GC_MW*cMHA**2d0*cMHC**2d0 + GC_72**2d0*GC_MW*cMHC**4d0 +     &
            GC_72**2d0*GC_MW*cMW**4d0 - 2d0*GC_72**2d0*GC_MW*cMW**2d0*cMZ**2d0 &
             + GC_72**2d0*GC_MW*cMZ**4d0 - 2d0*GC_72**2d0*GC_MW*rMW**4d0 - 2d0*&
            GC_72*GC_951*GC_MI*cMHA**4d0*rMW**2d0 + 4d0*GC_72*GC_951*GC_MI*cMHA&
            **2d0*cMHC**2d0*rMW**2d0 - 2d0*GC_72*GC_951*GC_MI*cMHC**4d0*rMW**  &
            2d0 - 2d0*GC_72*GC_951*GC_MI*cMW**4d0*rMW**2d0 + 4d0*GC_72*GC_951* &
            GC_MI*cMW**2d0*cMZ**2d0*rMW**2d0 - 2d0*GC_72*GC_951*GC_MI*cMZ**4d0*&
            rMW**2d0 + 4d0*GC_72*GC_951*GC_MI*rMW**6d0 - 2d0*GC_72*GC_951*GC_MW&
            *cMHA**4d0 + 4d0*GC_72*GC_951*GC_MW*cMHA**2d0*cMHC**2d0 - 2d0*GC_72&
            *GC_951*GC_MW*cMHC**4d0 - 2d0*GC_72*GC_951*GC_MW*cMW**4d0 + 4d0*   &
            GC_72*GC_951*GC_MW*cMW**2d0*cMZ**2d0 - 2d0*GC_72*GC_951*GC_MW*cMZ**&
            4d0 + 4d0*GC_72*GC_951*GC_MW*rMW**4d0 - 12d0*GC_80**2d0*GC_MI*Nc*  &
            rMW**6d0 + 4d0*GC_80**2d0*GC_MI*Nc*rMW**4d0*(3d0*cMB**2d0 + 3d0*cMT&
            **2d0 - rMW**2d0) + 4d0*GC_80**2d0*GC_MI*Nc*rMW**4d0*(3d0*cMC**2d0 &
             + 3d0*cMS**2d0 - rMW**2d0) + 4d0*GC_80**2d0*GC_MI*Nc*rMW**4d0*(3d0&
            *cMD**2d0 + 3d0*cMU**2d0 - rMW**2d0) - 12d0*GC_80**2d0*GC_MI*rMW** &
            6d0 + 4d0*GC_80**2d0*GC_MI*rMW**4d0*(3d0*cME**2d0 - rMW**2d0) + 4d0&
            *GC_80**2d0*GC_MI*rMW**4d0*(3d0*cMM**2d0 - rMW**2d0) + 4d0*GC_80** &
            2d0*GC_MI*rMW**4d0*(3d0*cMTA**2d0 - rMW**2d0) + 4d0*GC_80**2d0*Nc* &
            cMB**2d0*(-GC_MI*cMB**2d0*rMW**2d0 + GC_MI*cMT**2d0*rMW**2d0 -     &
            GC_MW*cMB**2d0 + GC_MW*cMT**2d0) + 4d0*GC_80**2d0*Nc*cMC**2d0*(-   &
            GC_MI*cMC**2d0*rMW**2d0 + GC_MI*cMS**2d0*rMW**2d0 - GC_MW*cMC**2d0 &
             + GC_MW*cMS**2d0) + 4d0*GC_80**2d0*Nc*cMD**2d0*(-GC_MI*cMD**2d0*  &
            rMW**2d0 + GC_MI*cMU**2d0*rMW**2d0 - GC_MW*cMD**2d0 + GC_MW*cMU**  &
            2d0) + 4d0*GC_80**2d0*Nc*cMS**2d0*(GC_MI*cMC**2d0*rMW**2d0 - GC_MI*&
            cMS**2d0*rMW**2d0 + GC_MW*cMC**2d0 - GC_MW*cMS**2d0) + 4d0*GC_80** &
            2d0*Nc*cMT**2d0*(GC_MI*cMB**2d0*rMW**2d0 - GC_MI*cMT**2d0*rMW**2d0 &
             + GC_MW*cMB**2d0 - GC_MW*cMT**2d0) + 4d0*GC_80**2d0*Nc*cMU**2d0*( &
            GC_MI*cMD**2d0*rMW**2d0 - GC_MI*cMU**2d0*rMW**2d0 + GC_MW*cMD**2d0 &
             - GC_MW*cMU**2d0) + 4d0*GC_80**2d0*Nc*(GC_MI*cMB**4d0*rMW**2d0 -  &
            2d0*GC_MI*cMB**2d0*cMT**2d0*rMW**2d0 + GC_MI*cMT**4d0*rMW**2d0 +   &
            2d0*GC_MI*rMW**6d0 + GC_MW*cMB**4d0 - 2d0*GC_MW*cMB**2d0*cMT**2d0  &
             + GC_MW*cMT**4d0 + 2d0*GC_MW*rMW**4d0) + 4d0*GC_80**2d0*Nc*(GC_MI*&
            cMC**4d0*rMW**2d0 - 2d0*GC_MI*cMC**2d0*cMS**2d0*rMW**2d0 + GC_MI*  &
            cMS**4d0*rMW**2d0 + 2d0*GC_MI*rMW**6d0 + GC_MW*cMC**4d0 - 2d0*GC_MW&
            *cMC**2d0*cMS**2d0 + GC_MW*cMS**4d0 + 2d0*GC_MW*rMW**4d0) + 4d0*   &
            GC_80**2d0*Nc*(GC_MI*cMD**4d0*rMW**2d0 - 2d0*GC_MI*cMD**2d0*cMU**  &
            2d0*rMW**2d0 + GC_MI*cMU**4d0*rMW**2d0 + 2d0*GC_MI*rMW**6d0 + GC_MW&
            *cMD**4d0 - 2d0*GC_MW*cMD**2d0*cMU**2d0 + GC_MW*cMU**4d0 + 2d0*    &
            GC_MW*rMW**4d0) + 4d0*GC_80**2d0*cME**4d0*(-GC_MI*rMW**2d0 - GC_MW &
            ) + 4d0*GC_80**2d0*cMM**4d0*(-GC_MI*rMW**2d0 - GC_MW) + 4d0*GC_80**&
            2d0*cMTA**4d0*(-GC_MI*rMW**2d0 - GC_MW) + 4d0*GC_80**2d0*(GC_MI*cME&
            **4d0*rMW**2d0 + 2d0*GC_MI*rMW**6d0 + GC_MW*cME**4d0 + 2d0*GC_MW*  &
            rMW**4d0) + 4d0*GC_80**2d0*(GC_MI*cMM**4d0*rMW**2d0 + 2d0*GC_MI*rMW&
            **6d0 + GC_MW*cMM**4d0 + 2d0*GC_MW*rMW**4d0) + 4d0*GC_80**2d0*(    &
            GC_MI*cMTA**4d0*rMW**2d0 + 2d0*GC_MI*rMW**6d0 + GC_MW*cMTA**4d0 +  &
            2d0*GC_MW*rMW**4d0) + GC_81**2d0*GC_MI*cMW**4d0*rMW**2d0 - 2d0*    &
            GC_81**2d0*GC_MI*cMW**2d0*cMZ**2d0*rMW**2d0 + GC_81**2d0*GC_MI*cMZ &
            **4d0*rMW**2d0 - GC_81**2d0*GC_MI*rMW**6d0 + GC_81**2d0*GC_MW*cMW**&
            4d0 - 2d0*GC_81**2d0*GC_MW*cMW**2d0*cMZ**2d0 + GC_81**2d0*GC_MW*cMZ&
            **4d0 - GC_81**2d0*GC_MW*rMW**4d0 - 4d0*GC_82**2d0*GC_MI*cMW**4d0* &
            rMW**2d0 + 8d0*GC_82**2d0*GC_MI*cMW**2d0*cMZ**2d0*rMW**2d0 - 4d0*  &
            GC_82**2d0*GC_MI*cMZ**4d0*rMW**2d0 + 10d0*GC_82**2d0*GC_MI*rMW**6d0&
             - 4d0*GC_82**2d0*GC_MW*cMW**4d0 + 8d0*GC_82**2d0*GC_MW*cMW**2d0*  &
            cMZ**2d0 - 4d0*GC_82**2d0*GC_MW*cMZ**4d0 - 20d0*GC_82**2d0*GC_MW*  &
            rMW**4d0 + GC_951**2d0*GC_MI*cMHA**4d0*rMW**2d0 - 2d0*GC_951**2d0* &
            GC_MI*cMHA**2d0*cMHC**2d0*rMW**2d0 + GC_951**2d0*GC_MI*cMHC**4d0*  &
            rMW**2d0 + GC_951**2d0*GC_MI*cMW**4d0*rMW**2d0 - 2d0*GC_951**2d0*  &
            GC_MI*cMW**2d0*cMZ**2d0*rMW**2d0 + GC_951**2d0*GC_MI*cMZ**4d0*rMW**&
            2d0 - 2d0*GC_951**2d0*GC_MI*rMW**6d0 + GC_951**2d0*GC_MW*cMHA**4d0 &
             - 2d0*GC_951**2d0*GC_MW*cMHA**2d0*cMHC**2d0 + GC_951**2d0*GC_MW*  &
            cMHC**4d0 + GC_951**2d0*GC_MW*cMW**4d0 - 2d0*GC_951**2d0*GC_MW*cMW &
            **2d0*cMZ**2d0 + GC_951**2d0*GC_MW*cMZ**4d0 - 2d0*GC_951**2d0*GC_MW&
            *rMW**4d0 - 2d0*GC_MI*rMW**6d0*(GC_1921**2d0 + GC_3**2d0) - 2d0*   &
            GC_MI*rMW**6d0*(GC_3893**2d0 + GC_82**2d0) + GC_MI*rMW**4d0*(3d0*  &
            cMW**2d0 - rMW**2d0)*(9d0*GC_1921**2d0 + 8d0*GC_3**2d0 - GC_4**2d0 &
            ) + GC_MI*rMW**4d0*(-GC_72**2d0 + 2d0*GC_72*GC_951 - GC_951**2d0)*(&
            3d0*cMHA**2d0 + 3d0*cMHC**2d0 - rMW**2d0) + GC_MI*rMW**4d0*(3d0*   &
            cMHC**2d0 + 3d0*cMHH**2d0 - rMW**2d0)*(GC_1505*GC_64 - GC_1505*    &
            GC_851 - GC_63*GC_64 + GC_63*GC_851) + GC_MI*rMW**4d0*(3d0*cMHC**  &
            2d0 + 3d0*cMHL**2d0 - rMW**2d0)*(-GC_1055*GC_1321 + GC_1055*GC_69  &
             + GC_1321*GC_68 - GC_68*GC_69) + GC_MI*rMW**4d0*(3d0*cMHH**2d0 +  &
            3d0*cMW**2d0 - rMW**2d0)*(-GC_1055*GC_1321 + GC_1055*GC_69 +       &
            GC_1321*GC_68 - GC_68*GC_69) + GC_MI*rMW**4d0*(3d0*cMHL**2d0 + 3d0*&
            cMW**2d0 - rMW**2d0)*(GC_1505*GC_64 - GC_1505*GC_851 - GC_63*GC_64 &
             + GC_63*GC_851) + GC_MI*rMW**4d0*(3d0*cMW**2d0 + 3d0*cMZ**2d0 -   &
            rMW**2d0)*(9d0*GC_3893**2d0 - GC_72**2d0 + 2d0*GC_72*GC_951 - GC_81&
            **2d0 + 8d0*GC_82**2d0 - GC_951**2d0) + cMHA**2d0*(-6d0*cima*GC_62*&
            GC_MI*rMW**4d0 - GC_72**2d0*GC_MI*cMHA**2d0*rMW**2d0 + GC_72**2d0* &
            GC_MI*cMHC**2d0*rMW**2d0 - GC_72**2d0*GC_MW*cMHA**2d0 + GC_72**2d0*&
            GC_MW*cMHC**2d0 + 2d0*GC_72*GC_951*GC_MI*cMHA**2d0*rMW**2d0 - 2d0* &
            GC_72*GC_951*GC_MI*cMHC**2d0*rMW**2d0 + 2d0*GC_72*GC_951*GC_MW*cMHA&
            **2d0 - 2d0*GC_72*GC_951*GC_MW*cMHC**2d0 - GC_951**2d0*GC_MI*cMHA**&
            2d0*rMW**2d0 + GC_951**2d0*GC_MI*cMHC**2d0*rMW**2d0 - GC_951**2d0* &
            GC_MW*cMHA**2d0 + GC_951**2d0*GC_MW*cMHC**2d0) + cMHC**2d0*(-      &
            GC_1055*GC_1321*GC_MI*cMHC**2d0*rMW**2d0 + GC_1055*GC_1321*GC_MI*  &
            cMHL**2d0*rMW**2d0 - GC_1055*GC_1321*GC_MW*cMHC**2d0 + GC_1055*    &
            GC_1321*GC_MW*cMHL**2d0 + GC_1055*GC_69*GC_MI*cMHC**2d0*rMW**2d0 - &
            GC_1055*GC_69*GC_MI*cMHL**2d0*rMW**2d0 + GC_1055*GC_69*GC_MW*cMHC**&
            2d0 - GC_1055*GC_69*GC_MW*cMHL**2d0 + GC_1321*GC_68*GC_MI*cMHC**2d0&
            *rMW**2d0 - GC_1321*GC_68*GC_MI*cMHL**2d0*rMW**2d0 + GC_1321*GC_68*&
            GC_MW*cMHC**2d0 - GC_1321*GC_68*GC_MW*cMHL**2d0 + GC_1505*GC_64*   &
            GC_MI*cMHC**2d0*rMW**2d0 - GC_1505*GC_64*GC_MI*cMHH**2d0*rMW**2d0  &
             + GC_1505*GC_64*GC_MW*cMHC**2d0 - GC_1505*GC_64*GC_MW*cMHH**2d0 - &
            GC_1505*GC_851*GC_MI*cMHC**2d0*rMW**2d0 + GC_1505*GC_851*GC_MI*cMHH&
            **2d0*rMW**2d0 - GC_1505*GC_851*GC_MW*cMHC**2d0 + GC_1505*GC_851*  &
            GC_MW*cMHH**2d0 - 12d0*cima*GC_62*GC_MI*rMW**4d0 - GC_63*GC_64*    &
            GC_MI*cMHC**2d0*rMW**2d0 + GC_63*GC_64*GC_MI*cMHH**2d0*rMW**2d0 -  &
            GC_63*GC_64*GC_MW*cMHC**2d0 + GC_63*GC_64*GC_MW*cMHH**2d0 + GC_63* &
            GC_851*GC_MI*cMHC**2d0*rMW**2d0 - GC_63*GC_851*GC_MI*cMHH**2d0*rMW &
            **2d0 + GC_63*GC_851*GC_MW*cMHC**2d0 - GC_63*GC_851*GC_MW*cMHH**2d0&
             - GC_68*GC_69*GC_MI*cMHC**2d0*rMW**2d0 + GC_68*GC_69*GC_MI*cMHL** &
            2d0*rMW**2d0 - GC_68*GC_69*GC_MW*cMHC**2d0 + GC_68*GC_69*GC_MW*cMHL&
            **2d0 + GC_72**2d0*GC_MI*cMHA**2d0*rMW**2d0 - GC_72**2d0*GC_MI*cMHC&
            **2d0*rMW**2d0 + GC_72**2d0*GC_MW*cMHA**2d0 - GC_72**2d0*GC_MW*cMHC&
            **2d0 - 2d0*GC_72*GC_951*GC_MI*cMHA**2d0*rMW**2d0 + 2d0*GC_72*     &
            GC_951*GC_MI*cMHC**2d0*rMW**2d0 - 2d0*GC_72*GC_951*GC_MW*cMHA**2d0 &
             + 2d0*GC_72*GC_951*GC_MW*cMHC**2d0 + GC_951**2d0*GC_MI*cMHA**2d0* &
            rMW**2d0 - GC_951**2d0*GC_MI*cMHC**2d0*rMW**2d0 + GC_951**2d0*GC_MW&
            *cMHA**2d0 - GC_951**2d0*GC_MW*cMHC**2d0) + cMHH**2d0*(-GC_1055*   &
            GC_1321*GC_MI*cMHH**2d0*rMW**2d0 + GC_1055*GC_1321*GC_MI*cMW**2d0* &
            rMW**2d0 - GC_1055*GC_1321*GC_MW*cMHH**2d0 + GC_1055*GC_1321*GC_MW*&
            cMW**2d0 + GC_1055*GC_69*GC_MI*cMHH**2d0*rMW**2d0 - GC_1055*GC_69* &
            GC_MI*cMW**2d0*rMW**2d0 + GC_1055*GC_69*GC_MW*cMHH**2d0 - GC_1055* &
            GC_69*GC_MW*cMW**2d0 + GC_1321*GC_68*GC_MI*cMHH**2d0*rMW**2d0 -    &
            GC_1321*GC_68*GC_MI*cMW**2d0*rMW**2d0 + GC_1321*GC_68*GC_MW*cMHH** &
            2d0 - GC_1321*GC_68*GC_MW*cMW**2d0 - GC_1505*GC_64*GC_MI*cMHC**2d0*&
            rMW**2d0 + GC_1505*GC_64*GC_MI*cMHH**2d0*rMW**2d0 - GC_1505*GC_64* &
            GC_MW*cMHC**2d0 + GC_1505*GC_64*GC_MW*cMHH**2d0 + GC_1505*GC_851*  &
            GC_MI*cMHC**2d0*rMW**2d0 - GC_1505*GC_851*GC_MI*cMHH**2d0*rMW**2d0 &
             + GC_1505*GC_851*GC_MW*cMHC**2d0 - GC_1505*GC_851*GC_MW*cMHH**2d0 &
             - 6d0*cima*GC_61*GC_MI*rMW**4d0 + GC_63*GC_64*GC_MI*cMHC**2d0*rMW &
            **2d0 - GC_63*GC_64*GC_MI*cMHH**2d0*rMW**2d0 + GC_63*GC_64*GC_MW*  &
            cMHC**2d0 - GC_63*GC_64*GC_MW*cMHH**2d0 - GC_63*GC_851*GC_MI*cMHC**&
            2d0*rMW**2d0 + GC_63*GC_851*GC_MI*cMHH**2d0*rMW**2d0 - GC_63*GC_851&
            *GC_MW*cMHC**2d0 + GC_63*GC_851*GC_MW*cMHH**2d0 - GC_68*GC_69*GC_MI&
            *cMHH**2d0*rMW**2d0 + GC_68*GC_69*GC_MI*cMW**2d0*rMW**2d0 - GC_68* &
            GC_69*GC_MW*cMHH**2d0 + GC_68*GC_69*GC_MW*cMW**2d0) + cMHL**2d0*(  &
            GC_1055*GC_1321*GC_MI*cMHC**2d0*rMW**2d0 - GC_1055*GC_1321*GC_MI*  &
            cMHL**2d0*rMW**2d0 + GC_1055*GC_1321*GC_MW*cMHC**2d0 - GC_1055*    &
            GC_1321*GC_MW*cMHL**2d0 - GC_1055*GC_69*GC_MI*cMHC**2d0*rMW**2d0 + &
            GC_1055*GC_69*GC_MI*cMHL**2d0*rMW**2d0 - GC_1055*GC_69*GC_MW*cMHC**&
            2d0 + GC_1055*GC_69*GC_MW*cMHL**2d0 - GC_1321*GC_68*GC_MI*cMHC**2d0&
            *rMW**2d0 + GC_1321*GC_68*GC_MI*cMHL**2d0*rMW**2d0 - GC_1321*GC_68*&
            GC_MW*cMHC**2d0 + GC_1321*GC_68*GC_MW*cMHL**2d0 + GC_1505*GC_64*   &
            GC_MI*cMHL**2d0*rMW**2d0 - GC_1505*GC_64*GC_MI*cMW**2d0*rMW**2d0 + &
            GC_1505*GC_64*GC_MW*cMHL**2d0 - GC_1505*GC_64*GC_MW*cMW**2d0 -     &
            GC_1505*GC_851*GC_MI*cMHL**2d0*rMW**2d0 + GC_1505*GC_851*GC_MI*cMW &
            **2d0*rMW**2d0 - GC_1505*GC_851*GC_MW*cMHL**2d0 + GC_1505*GC_851*  &
            GC_MW*cMW**2d0 - 6d0*cima*GC_61*GC_MI*rMW**4d0 - GC_63*GC_64*GC_MI*&
            cMHL**2d0*rMW**2d0 + GC_63*GC_64*GC_MI*cMW**2d0*rMW**2d0 - GC_63*  &
            GC_64*GC_MW*cMHL**2d0 + GC_63*GC_64*GC_MW*cMW**2d0 + GC_63*GC_851* &
            GC_MI*cMHL**2d0*rMW**2d0 - GC_63*GC_851*GC_MI*cMW**2d0*rMW**2d0 +  &
            GC_63*GC_851*GC_MW*cMHL**2d0 - GC_63*GC_851*GC_MW*cMW**2d0 + GC_68*&
            GC_69*GC_MI*cMHC**2d0*rMW**2d0 - GC_68*GC_69*GC_MI*cMHL**2d0*rMW** &
            2d0 + GC_68*GC_69*GC_MW*cMHC**2d0 - GC_68*GC_69*GC_MW*cMHL**2d0) + &
            cMW**2d0*(GC_1055*GC_1321*GC_MI*cMHH**2d0*rMW**2d0 - GC_1055*      &
            GC_1321*GC_MI*cMW**2d0*rMW**2d0 + GC_1055*GC_1321*GC_MW*cMHH**2d0  &
             - GC_1055*GC_1321*GC_MW*cMW**2d0 - GC_1055*GC_69*GC_MI*cMHH**2d0* &
            rMW**2d0 + GC_1055*GC_69*GC_MI*cMW**2d0*rMW**2d0 - GC_1055*GC_69*  &
            GC_MW*cMHH**2d0 + GC_1055*GC_69*GC_MW*cMW**2d0 - GC_1321*GC_68*    &
            GC_MI*cMHH**2d0*rMW**2d0 + GC_1321*GC_68*GC_MI*cMW**2d0*rMW**2d0 - &
            GC_1321*GC_68*GC_MW*cMHH**2d0 + GC_1321*GC_68*GC_MW*cMW**2d0 -     &
            GC_1505*GC_64*GC_MI*cMHL**2d0*rMW**2d0 + GC_1505*GC_64*GC_MI*cMW** &
            2d0*rMW**2d0 - GC_1505*GC_64*GC_MW*cMHL**2d0 + GC_1505*GC_64*GC_MW*&
            cMW**2d0 + GC_1505*GC_851*GC_MI*cMHL**2d0*rMW**2d0 - GC_1505*GC_851&
            *GC_MI*cMW**2d0*rMW**2d0 + GC_1505*GC_851*GC_MW*cMHL**2d0 - GC_1505&
            *GC_851*GC_MW*cMW**2d0 + 5d0*GC_1921**2d0*GC_MI*cMW**2d0*rMW**2d0  &
             + 5d0*GC_1921**2d0*GC_MW*cMW**2d0 + 4d0*GC_3**2d0*GC_MI*cMW**2d0* &
            rMW**2d0 + 4d0*GC_3**2d0*GC_MW*cMW**2d0 + 12d0*cima*GC_3685*GC_MI* &
            rMW**4d0 + 5d0*GC_3893**2d0*GC_MI*cMW**2d0*rMW**2d0 - 5d0*GC_3893**&
            2d0*GC_MI*cMZ**2d0*rMW**2d0 + 5d0*GC_3893**2d0*GC_MW*cMW**2d0 - 5d0&
            *GC_3893**2d0*GC_MW*cMZ**2d0 - GC_4**2d0*GC_MI*cMW**2d0*rMW**2d0 - &
            GC_4**2d0*GC_MW*cMW**2d0 - 12d0*cima*GC_62*GC_MI*rMW**4d0 + GC_63* &
            GC_64*GC_MI*cMHL**2d0*rMW**2d0 - GC_63*GC_64*GC_MI*cMW**2d0*rMW**  &
            2d0 + GC_63*GC_64*GC_MW*cMHL**2d0 - GC_63*GC_64*GC_MW*cMW**2d0 -   &
            GC_63*GC_851*GC_MI*cMHL**2d0*rMW**2d0 + GC_63*GC_851*GC_MI*cMW**2d0&
            *rMW**2d0 - GC_63*GC_851*GC_MW*cMHL**2d0 + GC_63*GC_851*GC_MW*cMW**&
            2d0 + GC_68*GC_69*GC_MI*cMHH**2d0*rMW**2d0 - GC_68*GC_69*GC_MI*cMW &
            **2d0*rMW**2d0 + GC_68*GC_69*GC_MW*cMHH**2d0 - GC_68*GC_69*GC_MW*  &
            cMW**2d0 - GC_72**2d0*GC_MI*cMW**2d0*rMW**2d0 + GC_72**2d0*GC_MI*  &
            cMZ**2d0*rMW**2d0 - GC_72**2d0*GC_MW*cMW**2d0 + GC_72**2d0*GC_MW*  &
            cMZ**2d0 + 2d0*GC_72*GC_951*GC_MI*cMW**2d0*rMW**2d0 - 2d0*GC_72*   &
            GC_951*GC_MI*cMZ**2d0*rMW**2d0 + 2d0*GC_72*GC_951*GC_MW*cMW**2d0 - &
            2d0*GC_72*GC_951*GC_MW*cMZ**2d0 + 60d0*cima*GC_78*GC_MI*rMW**4d0 - &
            GC_81**2d0*GC_MI*cMW**2d0*rMW**2d0 + GC_81**2d0*GC_MI*cMZ**2d0*rMW &
            **2d0 - GC_81**2d0*GC_MW*cMW**2d0 + GC_81**2d0*GC_MW*cMZ**2d0 + 4d0&
            *GC_82**2d0*GC_MI*cMW**2d0*rMW**2d0 - 4d0*GC_82**2d0*GC_MI*cMZ**2d0&
            *rMW**2d0 + 4d0*GC_82**2d0*GC_MW*cMW**2d0 - 4d0*GC_82**2d0*GC_MW*  &
            cMZ**2d0 - GC_951**2d0*GC_MI*cMW**2d0*rMW**2d0 + GC_951**2d0*GC_MI*&
            cMZ**2d0*rMW**2d0 - GC_951**2d0*GC_MW*cMW**2d0 + GC_951**2d0*GC_MW*&
            cMZ**2d0) + cMZ**2d0*(24d0*cima*GC_1305*GC_MI*rMW**4d0 - 5d0*      &
            GC_3893**2d0*GC_MI*cMW**2d0*rMW**2d0 + 5d0*GC_3893**2d0*GC_MI*cMZ**&
            2d0*rMW**2d0 - 5d0*GC_3893**2d0*GC_MW*cMW**2d0 + 5d0*GC_3893**2d0* &
            GC_MW*cMZ**2d0 - 6d0*cima*GC_62*GC_MI*rMW**4d0 + GC_72**2d0*GC_MI* &
            cMW**2d0*rMW**2d0 - GC_72**2d0*GC_MI*cMZ**2d0*rMW**2d0 + GC_72**2d0&
            *GC_MW*cMW**2d0 - GC_72**2d0*GC_MW*cMZ**2d0 - 2d0*GC_72*GC_951*    &
            GC_MI*cMW**2d0*rMW**2d0 + 2d0*GC_72*GC_951*GC_MI*cMZ**2d0*rMW**2d0 &
             - 2d0*GC_72*GC_951*GC_MW*cMW**2d0 + 2d0*GC_72*GC_951*GC_MW*cMZ**  &
            2d0 + 12d0*cima*GC_79*GC_MI*rMW**4d0 + GC_81**2d0*GC_MI*cMW**2d0*  &
            rMW**2d0 - GC_81**2d0*GC_MI*cMZ**2d0*rMW**2d0 + GC_81**2d0*GC_MW*  &
            cMW**2d0 - GC_81**2d0*GC_MW*cMZ**2d0 - 4d0*GC_82**2d0*GC_MI*cMW**  &
            2d0*rMW**2d0 + 4d0*GC_82**2d0*GC_MI*cMZ**2d0*rMW**2d0 - 4d0*GC_82**&
            2d0*GC_MW*cMW**2d0 + 4d0*GC_82**2d0*GC_MW*cMZ**2d0 + GC_951**2d0*  &
            GC_MI*cMW**2d0*rMW**2d0 - GC_951**2d0*GC_MI*cMZ**2d0*rMW**2d0 +    &
            GC_951**2d0*GC_MW*cMW**2d0 - GC_951**2d0*GC_MW*cMZ**2d0))/(192d0*pi&
            **2d0*GC_MI*rMW**4d0) - cima*GC_124*dtHl_MS/cMHL**2d0 - cima*GC_125&
            *dtHh_MS/cMHH**2d0
  dtHhHl_PRTS_fin = (cab*(dtHl - dtHl_MS)*((cab - sab*tb)*(MHH**2d0/MHL**2d0 + &
                    2d0)*(cab*tb + sab) + MSB2*(-3d0*cab*sab*(-tb**2d0 + 1d0   &
                    ) + tb*(-2d0*cab**2d0 + 4d0*sab**2d0))/MHL**2d0) + sab*(   &
                    dtHh - dtHh_MS)*((2d0 + MHL**2d0/MHH**2d0)*(cab - sab*tb)*(&
                    cab*tb + sab) - MSB2*(3d0*cab*sab*(-tb**2d0 + 1d0) + tb*(  &
                    4d0*cab**2d0 - 2d0*sab**2d0))/MHH**2d0))/(tb*vev)
  dZee_MS = -dZA_MS/2d0 - dZZA_MS*sw/(2d0*cw)
  dMHH2_MS = DeltaUV*(-6d0*GC_103**2d0*GC_I - 3d0*GC_105**2d0*GC_I + 12d0*     &
             GC_1055*GC_1321*GC_MHH - 6d0*GC_1055*GC_69*GC_MHH - 3d0*GC_106**  &
             2d0*GC_I - 12d0*GC_111**2d0*GC_I - 6d0*GC_112**2d0*GC_I - 6d0*    &
             GC_116**2d0*GC_I - 3d0*GC_117**2d0*GC_I - 6d0*GC_118**2d0*GC_I +  &
             3d0*cima*GC_12*GC_I*cMHH**2d0 - 3d0*GC_121**2d0*GC_I - 24d0*GC_125&
             **2d0*GC_I - 12d0*GC_129**2d0*GC_I + 3d0*cima*GC_13*GC_I*cMHL**2d0&
              - 6d0*GC_1321*GC_68*GC_MHH + 24d0*GC_133**2d0*GC_I*Nc*cMC**2d0 + &
             8d0*GC_133**2d0*GC_I*Nc*(6d0*cMC**2d0 - rMHH**2d0) + 4d0*GC_133** &
             2d0*GC_MHH*Nc - 8d0*GC_133**2d0*Nc*(-GC_I*rMHH**2d0 - GC_MHH) +   &
             24d0*GC_137**2d0*GC_I*Nc*cMB**2d0 + 8d0*GC_137**2d0*GC_I*Nc*(6d0* &
             cMB**2d0 - rMHH**2d0) + 4d0*GC_137**2d0*GC_MHH*Nc - 8d0*GC_137**  &
             2d0*Nc*(-GC_I*rMHH**2d0 - GC_MHH) + 24d0*GC_149**2d0*GC_I*Nc*cMD**&
             2d0 + 8d0*GC_149**2d0*GC_I*Nc*(6d0*cMD**2d0 - rMHH**2d0) + 4d0*   &
             GC_149**2d0*GC_MHH*Nc - 8d0*GC_149**2d0*Nc*(-GC_I*rMHH**2d0 -     &
             GC_MHH) - 12d0*GC_1505*GC_64*GC_MHH - 4d0*GC_1505*GC_851*GC_I*(3d0&
             *cMHC**2d0 + 3d0*cMW**2d0 - rMHH**2d0) + 16d0*GC_1505*GC_851*     &
             GC_MHH - 4d0*GC_1505*GC_851*(GC_I*rMHH**2d0 + GC_MHH) + 6d0*      &
             GC_1553**2d0*GC_MHH - 12d0*GC_1553*GC_92*GC_MHH + 24d0*GC_157**2d0&
             *GC_I*cME**2d0 + 8d0*GC_157**2d0*GC_I*(6d0*cME**2d0 - rMHH**2d0   &
             ) + 4d0*GC_157**2d0*GC_MHH - 8d0*GC_157**2d0*(-GC_I*rMHH**2d0 -   &
             GC_MHH) + 24d0*GC_165**2d0*GC_I*cMM**2d0 + 8d0*GC_165**2d0*GC_I*( &
             6d0*cMM**2d0 - rMHH**2d0) + 4d0*GC_165**2d0*GC_MHH - 8d0*GC_165** &
             2d0*(-GC_I*rMHH**2d0 - GC_MHH) + 24d0*GC_173**2d0*GC_I*Nc*cMS**2d0&
              + 8d0*GC_173**2d0*GC_I*Nc*(6d0*cMS**2d0 - rMHH**2d0) + 4d0*GC_173&
             **2d0*GC_MHH*Nc - 8d0*GC_173**2d0*Nc*(-GC_I*rMHH**2d0 - GC_MHH) + &
             24d0*GC_180**2d0*GC_I*Nc*cMT**2d0 + 8d0*GC_180**2d0*GC_I*Nc*(6d0* &
             cMT**2d0 - rMHH**2d0) + 4d0*GC_180**2d0*GC_MHH*Nc - 8d0*GC_180**  &
             2d0*Nc*(-GC_I*rMHH**2d0 - GC_MHH) + 24d0*GC_188**2d0*GC_I*cMTA**  &
             2d0 + 8d0*GC_188**2d0*GC_I*(6d0*cMTA**2d0 - rMHH**2d0) + 4d0*     &
             GC_188**2d0*GC_MHH - 8d0*GC_188**2d0*(-GC_I*rMHH**2d0 - GC_MHH) + &
             24d0*GC_195**2d0*GC_I*Nc*cMU**2d0 + 8d0*GC_195**2d0*GC_I*Nc*(6d0* &
             cMU**2d0 - rMHH**2d0) + 4d0*GC_195**2d0*GC_MHH*Nc - 8d0*GC_195**  &
             2d0*Nc*(-GC_I*rMHH**2d0 - GC_MHH) + 6d0*GC_2429**2d0*GC_MHH - 6d0*&
             GC_2429*GC_94*GC_MHH + 6d0*cima*GC_34*GC_I*cMHC**2d0 + 3d0*cima*  &
             GC_38*GC_I*cMHA**2d0 + 12d0*GC_63*GC_64*GC_MHH - 12d0*GC_63*GC_851&
             *GC_MHH - 4d0*GC_68*GC_69*GC_I*(6d0*cMW**2d0 - rMHH**2d0) + 4d0*  &
             GC_68*GC_69*GC_MHH - 4d0*GC_68*GC_69*(GC_I*rMHH**2d0 + GC_MHH) +  &
             12d0*GC_71**2d0*GC_I - 2d0*GC_92**2d0*GC_I*(3d0*cMHA**2d0 + 3d0*  &
             cMZ**2d0 - rMHH**2d0) + 8d0*GC_92**2d0*GC_MHH - 2d0*GC_92**2d0*(  &
             GC_I*rMHH**2d0 + GC_MHH) - 6d0*GC_92*GC_MHH*(-GC_1553 + GC_92) -  &
             2d0*GC_94**2d0*GC_I*(6d0*cMZ**2d0 - rMHH**2d0) + 2d0*GC_94**2d0*  &
             GC_MHH - 2d0*GC_94**2d0*(GC_I*rMHH**2d0 + GC_MHH) + 6d0*GC_95**2d0&
             *GC_I + 6d0*cima*GC_I*cMW**2d0*(GC_32 - 4d0*GC_61) + 3d0*cima*GC_I&
             *cMZ**2d0*(GC_33 - 4d0*GC_99) - 6d0*GC_MHH*(-GC_1505*GC_64 + 2d0* &
             GC_1505*GC_851 - GC_63*GC_851))/(96d0*pi**2d0*GC_I) + cima*GC_103*&
             dtHl_MS/cMHL**2d0 + cima*GC_105*dtHh_MS/cMHH**2d0
  dMHC2_MS = DeltaUV*(6d0*GC_1055*GC_1321*GC_MHC - 6d0*GC_1055*GC_69*GC_MHC -  &
             6d0*GC_110**2d0*GC_I - 6d0*GC_111**2d0*GC_I - 6d0*GC_118**2d0*GC_I&
              - 6d0*GC_119**2d0*GC_I - 6d0*GC_122*GC_123*GC_I - 24d0*GC_126**  &
             2d0*GC_I + 24d0*GC_131*GC_170*GC_I*Nc*cMC*cMS - 6d0*GC_1321*GC_68*&
             GC_MHC - 2d0*GC_1399*GC_17*GC_I*(3d0*cMHC**2d0 - rMHC**2d0) + 2d0*&
             GC_1399*GC_17*GC_MHC - 2d0*GC_1399*GC_17*(GC_I*rMHC**2d0 + GC_MHC &
             ) + 24d0*GC_142*GC_178*GC_I*Nc*cMB*cMT + 24d0*GC_146*GC_193*GC_I* &
             Nc*cMD*cMU - 6d0*GC_1505*GC_64*GC_MHC + 6d0*GC_1505*GC_851*GC_MHC &
              + 4d0*GC_154**2d0*GC_I*(3d0*cME**2d0 - rMHC**2d0) + 2d0*GC_154** &
             2d0*GC_MHC - 4d0*GC_154**2d0*(-GC_I*rMHC**2d0 - GC_MHC) + 4d0*    &
             GC_162**2d0*GC_I*(3d0*cMM**2d0 - rMHC**2d0) + 2d0*GC_162**2d0*    &
             GC_MHC - 4d0*GC_162**2d0*(-GC_I*rMHC**2d0 - GC_MHC) - 2d0*GC_1779*&
             GC_96*GC_I*(3d0*cMHC**2d0 + 3d0*cMZ**2d0 - rMHC**2d0) + 2d0*      &
             GC_1779*GC_96*GC_MHC - 2d0*GC_1779*GC_96*(GC_I*rMHC**2d0 + GC_MHC &
             ) + 4d0*GC_185**2d0*GC_I*(3d0*cMTA**2d0 - rMHC**2d0) + 2d0*GC_185 &
             **2d0*GC_MHC - 4d0*GC_185**2d0*(-GC_I*rMHC**2d0 - GC_MHC) + 3d0*  &
             cima*GC_30*GC_I*cMHL**2d0 + 3d0*cima*GC_34*GC_I*cMHH**2d0 + 3d0*  &
             cima*GC_50*GC_I*cMHA**2d0 + 6d0*cima*GC_51*GC_I*cMHC**2d0 - 2d0*  &
             GC_63*GC_64*GC_I*(3d0*cMHH**2d0 + 3d0*cMW**2d0 - rMHC**2d0) + 8d0*&
             GC_63*GC_64*GC_MHC - 2d0*GC_63*GC_64*(GC_I*rMHC**2d0 + GC_MHC) -  &
             6d0*GC_63*GC_851*GC_MHC - 2d0*GC_68*GC_69*GC_I*(3d0*cMHL**2d0 +   &
             3d0*cMW**2d0 - rMHC**2d0) + 8d0*GC_68*GC_69*GC_MHC - 2d0*GC_68*   &
             GC_69*(GC_I*rMHC**2d0 + GC_MHC) - 2d0*GC_72**2d0*GC_I*(3d0*cMHA** &
             2d0 + 3d0*cMW**2d0 - rMHC**2d0) + 8d0*GC_72**2d0*GC_MHC - 2d0*    &
             GC_72**2d0*(GC_I*rMHC**2d0 + GC_MHC) - 12d0*GC_72*GC_951*GC_MHC - &
             6d0*GC_72*GC_MHC*(GC_72 - GC_951) + 6d0*GC_951**2d0*GC_MHC + 4d0* &
             GC_I*Nc*(GC_131**2d0 + GC_170**2d0)*(3d0*cMC**2d0 + 3d0*cMS**2d0  &
              - rMHC**2d0) + 4d0*GC_I*Nc*(GC_142**2d0 + GC_178**2d0)*(3d0*cMB**&
             2d0 + 3d0*cMT**2d0 - rMHC**2d0) + 4d0*GC_I*Nc*(GC_146**2d0 +      &
             GC_193**2d0)*(3d0*cMD**2d0 + 3d0*cMU**2d0 - rMHC**2d0) + 6d0*cima*&
             GC_I*cMW**2d0*(GC_57 - 4d0*GC_62) + 3d0*cima*GC_I*cMZ**2d0*(-4d0* &
             GC_100 + GC_56) + 6d0*GC_I*(-4d0*GC_102**2d0 - GC_114*GC_115) -   &
             2d0*GC_MHC*Nc*(-GC_131**2d0 - GC_170**2d0) - 2d0*GC_MHC*Nc*(-     &
             GC_142**2d0 - GC_178**2d0) - 2d0*GC_MHC*Nc*(-GC_146**2d0 - GC_193 &
             **2d0) + 3d0*GC_MHC*(-GC_1399**2d0 + 2d0*GC_1399*GC_17 - GC_17**  &
             2d0) + 3d0*GC_MHC*(-GC_1779**2d0 + 2d0*GC_1779*GC_96 - GC_96**2d0 &
             ) - 3d0*GC_MHC*(-GC_1055*GC_69 - GC_1321*GC_68 + 2d0*GC_68*GC_69  &
             ) - 3d0*GC_MHC*(-GC_1505*GC_64 + 2d0*GC_63*GC_64 - GC_63*GC_851   &
             ) - 4d0*Nc*(-GC_131**2d0*GC_I*rMHC**2d0 - GC_131**2d0*GC_MHC -    &
             GC_170**2d0*GC_I*rMHC**2d0 - GC_170**2d0*GC_MHC) - 4d0*Nc*(-GC_142&
             **2d0*GC_I*rMHC**2d0 - GC_142**2d0*GC_MHC - GC_178**2d0*GC_I*rMHC &
             **2d0 - GC_178**2d0*GC_MHC) - 4d0*Nc*(-GC_146**2d0*GC_I*rMHC**2d0 &
              - GC_146**2d0*GC_MHC - GC_193**2d0*GC_I*rMHC**2d0 - GC_193**2d0* &
             GC_MHC))/(96d0*pi**2d0*GC_I) + cima*GC_110*dtHl_MS/cMHL**2d0 +    &
             cima*GC_118*dtHh_MS/cMHH**2d0
  dMHL2_MS = DeltaUV*(-3d0*GC_103**2d0*GC_I - 3d0*GC_104**2d0*GC_I - 4d0*      &
             GC_1055*GC_1321*GC_I*(3d0*cMHC**2d0 + 3d0*cMW**2d0 - rMHL**2d0) + &
             16d0*GC_1055*GC_1321*GC_MHL - 4d0*GC_1055*GC_1321*(GC_I*rMHL**2d0 &
              + GC_MHL) - 12d0*GC_1055*GC_69*GC_MHL - 6d0*GC_106**2d0*GC_I -   &
             6d0*GC_108**2d0*GC_I - 3d0*GC_109**2d0*GC_I + 3d0*cima*GC_11*GC_I*&
             cMHL**2d0 - 6d0*GC_110**2d0*GC_I - 3d0*GC_113**2d0*GC_I - 12d0*   &
             GC_119**2d0*GC_I - 6d0*GC_120**2d0*GC_I - 24d0*GC_124**2d0*GC_I - &
             12d0*GC_128**2d0*GC_I + 3d0*cima*GC_13*GC_I*cMHH**2d0 + 24d0*     &
             GC_130**2d0*GC_I*Nc*cMC**2d0 + 8d0*GC_130**2d0*GC_I*Nc*(6d0*cMC** &
             2d0 - rMHL**2d0) + 4d0*GC_130**2d0*GC_MHL*Nc - 8d0*GC_130**2d0*Nc &
             *(-GC_I*rMHL**2d0 - GC_MHL) - 12d0*GC_1321*GC_68*GC_MHL + 24d0*   &
             GC_141**2d0*GC_I*Nc*cMB**2d0 + 8d0*GC_141**2d0*GC_I*Nc*(6d0*cMB** &
             2d0 - rMHL**2d0) + 4d0*GC_141**2d0*GC_MHL*Nc - 8d0*GC_141**2d0*Nc &
             *(-GC_I*rMHL**2d0 - GC_MHL) + 24d0*GC_145**2d0*GC_I*Nc*cMD**2d0 + &
             8d0*GC_145**2d0*GC_I*Nc*(6d0*cMD**2d0 - rMHL**2d0) + 4d0*GC_145** &
             2d0*GC_MHL*Nc - 8d0*GC_145**2d0*Nc*(-GC_I*rMHL**2d0 - GC_MHL) -   &
             6d0*GC_1505*GC_64*GC_MHL + 12d0*GC_1505*GC_851*GC_MHL + 24d0*     &
             GC_153**2d0*GC_I*cME**2d0 + 8d0*GC_153**2d0*GC_I*(6d0*cME**2d0 -  &
             rMHL**2d0) + 4d0*GC_153**2d0*GC_MHL - 8d0*GC_153**2d0*(-GC_I*rMHL &
             **2d0 - GC_MHL) + 24d0*GC_161**2d0*GC_I*cMM**2d0 + 8d0*GC_161**2d0&
             *GC_I*(6d0*cMM**2d0 - rMHL**2d0) + 4d0*GC_161**2d0*GC_MHL - 8d0*  &
             GC_161**2d0*(-GC_I*rMHL**2d0 - GC_MHL) + 24d0*GC_169**2d0*GC_I*Nc*&
             cMS**2d0 + 8d0*GC_169**2d0*GC_I*Nc*(6d0*cMS**2d0 - rMHL**2d0) +   &
             4d0*GC_169**2d0*GC_MHL*Nc - 8d0*GC_169**2d0*Nc*(-GC_I*rMHL**2d0 - &
             GC_MHL) + 24d0*GC_177**2d0*GC_I*Nc*cMT**2d0 + 8d0*GC_177**2d0*GC_I&
             *Nc*(6d0*cMT**2d0 - rMHL**2d0) + 4d0*GC_177**2d0*GC_MHL*Nc - 8d0* &
             GC_177**2d0*Nc*(-GC_I*rMHL**2d0 - GC_MHL) + 24d0*GC_184**2d0*GC_I*&
             cMTA**2d0 + 8d0*GC_184**2d0*GC_I*(6d0*cMTA**2d0 - rMHL**2d0) + 4d0&
             *GC_184**2d0*GC_MHL - 8d0*GC_184**2d0*(-GC_I*rMHL**2d0 - GC_MHL   &
             ) + 24d0*GC_192**2d0*GC_I*Nc*cMU**2d0 + 8d0*GC_192**2d0*GC_I*Nc*( &
             6d0*cMU**2d0 - rMHL**2d0) + 4d0*GC_192**2d0*GC_MHL*Nc - 8d0*GC_192&
             **2d0*Nc*(-GC_I*rMHL**2d0 - GC_MHL) + 6d0*GC_2429**2d0*GC_MHL -   &
             12d0*GC_2429*GC_94*GC_MHL + 6d0*cima*GC_30*GC_I*cMHC**2d0 + 3d0*  &
             cima*GC_31*GC_I*cMHA**2d0 - 4d0*GC_63*GC_64*GC_I*(6d0*cMW**2d0 -  &
             rMHL**2d0) + 4d0*GC_63*GC_64*GC_MHL - 4d0*GC_63*GC_64*(GC_I*rMHL**&
             2d0 + GC_MHL) - 6d0*GC_63*GC_851*GC_MHL + 12d0*GC_67**2d0*GC_I +  &
             12d0*GC_68*GC_69*GC_MHL - 2d0*GC_91**2d0*GC_I*(6d0*cMZ**2d0 - rMHL&
             **2d0) + 2d0*GC_91**2d0*GC_MHL - 2d0*GC_91**2d0*(GC_I*rMHL**2d0 + &
             GC_MHL) - 6d0*GC_91*GC_955*GC_MHL + 6d0*GC_93**2d0*GC_I - 2d0*    &
             GC_94**2d0*GC_I*(3d0*cMHA**2d0 + 3d0*cMZ**2d0 - rMHL**2d0) + 8d0* &
             GC_94**2d0*GC_MHL - 2d0*GC_94**2d0*(GC_I*rMHL**2d0 + GC_MHL) - 6d0&
             *GC_94*GC_MHL*(-GC_2429 + GC_94) + 6d0*GC_955**2d0*GC_MHL + 6d0*  &
             cima*GC_I*cMW**2d0*(GC_35 - 4d0*GC_61) + 3d0*cima*GC_I*cMZ**2d0*( &
             GC_39 - 4d0*GC_99) - 6d0*GC_MHL*(2d0*GC_1055*GC_1321 - GC_1055*   &
             GC_69 - GC_1321*GC_68))/(96d0*pi**2d0*GC_I) + cima*GC_104*dtHl_MS/&
             cMHL**2d0 + cima*GC_106*dtHh_MS/cMHH**2d0
  dMHA2_MS = DeltaUV*(-6d0*GC_112**2d0*GC_I - 6d0*GC_113**2d0*GC_I - 6d0*GC_120&
             **2d0*GC_I - 6d0*GC_121**2d0*GC_I - 12d0*GC_122*GC_123*GC_I + 8d0*&
             GC_132*GC_803*GC_I*Nc*(6d0*cMC**2d0 - rMHA**2d0) + 4d0*GC_132*    &
             GC_803*GC_MHA*Nc - 8d0*GC_132*GC_803*Nc*(-GC_I*rMHA**2d0 - GC_MHA &
             ) + 8d0*GC_143*GC_144*GC_I*Nc*(6d0*cMB**2d0 - rMHA**2d0) + 4d0*   &
             GC_143*GC_144*GC_MHA*Nc - 8d0*GC_143*GC_144*Nc*(-GC_I*rMHA**2d0 - &
             GC_MHA) + 8d0*GC_147*GC_148*GC_I*Nc*(6d0*cMD**2d0 - rMHA**2d0) +  &
             4d0*GC_147*GC_148*GC_MHA*Nc - 8d0*GC_147*GC_148*Nc*(-GC_I*rMHA**  &
             2d0 - GC_MHA) + 8d0*GC_155*GC_156*GC_I*(6d0*cME**2d0 - rMHA**2d0  &
             ) + 4d0*GC_155*GC_156*GC_MHA - 8d0*GC_155*GC_156*(-GC_I*rMHA**2d0 &
              - GC_MHA) - 2d0*GC_1553**2d0*GC_I*(3d0*cMHH**2d0 + 3d0*cMZ**2d0  &
              - rMHA**2d0) + 8d0*GC_1553**2d0*GC_MHA - 2d0*GC_1553**2d0*(GC_I* &
             rMHA**2d0 + GC_MHA) - 12d0*GC_1553*GC_92*GC_MHA - 6d0*GC_1553*    &
             GC_MHA*(GC_1553 - GC_92) + 8d0*GC_1625*GC_194*GC_I*Nc*(6d0*cMU**  &
             2d0 - rMHA**2d0) + 4d0*GC_1625*GC_194*GC_MHA*Nc - 8d0*GC_1625*    &
             GC_194*Nc*(-GC_I*rMHA**2d0 - GC_MHA) + 8d0*GC_163*GC_164*GC_I*(6d0&
             *cMM**2d0 - rMHA**2d0) + 4d0*GC_163*GC_164*GC_MHA - 8d0*GC_163*   &
             GC_164*(-GC_I*rMHA**2d0 - GC_MHA) + 8d0*GC_171*GC_172*GC_I*Nc*(6d0&
             *cMS**2d0 - rMHA**2d0) + 4d0*GC_171*GC_172*GC_MHA*Nc - 8d0*GC_171*&
             GC_172*Nc*(-GC_I*rMHA**2d0 - GC_MHA) + 8d0*GC_1759*GC_179*GC_I*Nc &
             *(6d0*cMT**2d0 - rMHA**2d0) + 4d0*GC_1759*GC_179*GC_MHA*Nc - 8d0* &
             GC_1759*GC_179*Nc*(-GC_I*rMHA**2d0 - GC_MHA) + 8d0*GC_186*GC_187* &
             GC_I*(6d0*cMTA**2d0 - rMHA**2d0) + 4d0*GC_186*GC_187*GC_MHA - 8d0*&
             GC_186*GC_187*(-GC_I*rMHA**2d0 - GC_MHA) - 2d0*GC_2429**2d0*GC_I*(&
             3d0*cMHL**2d0 + 3d0*cMZ**2d0 - rMHA**2d0) + 8d0*GC_2429**2d0*     &
             GC_MHA - 2d0*GC_2429**2d0*(GC_I*rMHA**2d0 + GC_MHA) - 12d0*GC_2429&
             *GC_94*GC_MHA - 6d0*GC_2429*GC_MHA*(GC_2429 - GC_94) + 3d0*cima*  &
             GC_31*GC_I*cMHL**2d0 + 3d0*cima*GC_38*GC_I*cMHH**2d0 + 6d0*cima*  &
             GC_50*GC_I*cMHC**2d0 + 3d0*cima*GC_52*GC_I*cMHA**2d0 + 12d0*GC_72 &
             **2d0*GC_MHA - 24d0*GC_72*GC_951*GC_MHA + 6d0*GC_92**2d0*GC_MHA + &
             6d0*GC_94**2d0*GC_MHA - 4d0*GC_951**2d0*GC_I*(3d0*cMHC**2d0 + 3d0*&
             cMW**2d0 - rMHA**2d0) + 16d0*GC_951**2d0*GC_MHA - 4d0*GC_951**2d0 &
             *(GC_I*rMHA**2d0 + GC_MHA) - 12d0*GC_951*GC_MHA*(-GC_72 + GC_951  &
             ) + 12d0*GC_I*Nc*cMB**2d0*(GC_143**2d0 + GC_144**2d0) + 12d0*GC_I*&
             Nc*cMC**2d0*(GC_132**2d0 + GC_803**2d0) + 12d0*GC_I*Nc*cMD**2d0*( &
             GC_147**2d0 + GC_148**2d0) + 12d0*GC_I*Nc*cMS**2d0*(GC_171**2d0 + &
             GC_172**2d0) + 12d0*GC_I*Nc*cMT**2d0*(GC_1759**2d0 + GC_179**2d0  &
             ) + 12d0*GC_I*Nc*cMU**2d0*(GC_1625**2d0 + GC_194**2d0) + 12d0*GC_I&
             *cME**2d0*(GC_155**2d0 + GC_156**2d0) + 12d0*GC_I*cMM**2d0*(GC_163&
             **2d0 + GC_164**2d0) + 12d0*GC_I*cMTA**2d0*(GC_186**2d0 + GC_187**&
             2d0) + 6d0*cima*GC_I*cMW**2d0*(GC_56 - 4d0*GC_62) + 3d0*cima*GC_I*&
             cMZ**2d0*(-4d0*GC_101 + GC_59))/(96d0*pi**2d0*GC_I) + cima*GC_113*&
             dtHl_MS/cMHL**2d0 + cima*GC_121*dtHh_MS/cMHH**2d0
  dZHlHh_MS = DeltaUV*(3d0*GC_10*GC_I*cMHH**2d0*(rMHH**2d0 - rMHL**2d0) + 3d0* &
              cima*GC_103*GC_105*(GC_I*rMHH**2d0 + GC_MHH) + 3d0*cima*GC_103*  &
              GC_105*(-GC_I*rMHL**2d0 - GC_MHH) + 6d0*cima*GC_103*GC_106*(GC_I*&
              rMHH**2d0 + GC_MHH) + 6d0*cima*GC_103*GC_106*(-GC_I*rMHL**2d0 -  &
              GC_MHH) + 3d0*cima*GC_104*GC_106*(GC_I*rMHH**2d0 + GC_MHH) + 3d0*&
              cima*GC_104*GC_106*(-GC_I*rMHL**2d0 - GC_MHH) + 6d0*cima*GC_110* &
              GC_118*(GC_I*rMHH**2d0 + GC_MHH) + 6d0*cima*GC_110*GC_118*(-GC_I*&
              rMHL**2d0 - GC_MHH) + 3d0*cima*GC_113*GC_121*(GC_I*rMHH**2d0 +   &
              GC_MHH) + 3d0*cima*GC_113*GC_121*(-GC_I*rMHL**2d0 - GC_MHH) +    &
              24d0*cima*GC_130*GC_133*Nc*cMC**2d0*(-GC_I*rMHH**2d0 - GC_MHH) + &
              24d0*cima*GC_130*GC_133*Nc*cMC**2d0*(GC_I*rMHL**2d0 + GC_MHH) -  &
              4d0*cima*GC_130*GC_133*Nc*rMHH**2d0*(GC_I*rMHL**2d0 + GC_MHH) -  &
              4d0*cima*GC_130*GC_133*Nc*rMHL**2d0*(-GC_I*rMHH**2d0 - GC_MHH) + &
              8d0*cima*GC_130*GC_133*Nc*(6d0*cMC**2d0 - rMHH**2d0)*(GC_I*rMHL**&
              2d0 + GC_MHH) + 8d0*cima*GC_130*GC_133*Nc*(6d0*cMC**2d0 - rMHL** &
              2d0)*(-GC_I*rMHH**2d0 - GC_MHH) + 24d0*cima*GC_137*GC_141*Nc*cMB &
              **2d0*(-GC_I*rMHH**2d0 - GC_MHH) + 24d0*cima*GC_137*GC_141*Nc*cMB&
              **2d0*(GC_I*rMHL**2d0 + GC_MHH) - 4d0*cima*GC_137*GC_141*Nc*rMHH &
              **2d0*(GC_I*rMHL**2d0 + GC_MHH) - 4d0*cima*GC_137*GC_141*Nc*rMHL &
              **2d0*(-GC_I*rMHH**2d0 - GC_MHH) + 8d0*cima*GC_137*GC_141*Nc*(6d0&
              *cMB**2d0 - rMHH**2d0)*(GC_I*rMHL**2d0 + GC_MHH) + 8d0*cima*     &
              GC_137*GC_141*Nc*(6d0*cMB**2d0 - rMHL**2d0)*(-GC_I*rMHH**2d0 -   &
              GC_MHH) + 24d0*cima*GC_145*GC_149*Nc*cMD**2d0*(-GC_I*rMHH**2d0 - &
              GC_MHH) + 24d0*cima*GC_145*GC_149*Nc*cMD**2d0*(GC_I*rMHL**2d0 +  &
              GC_MHH) - 4d0*cima*GC_145*GC_149*Nc*rMHH**2d0*(GC_I*rMHL**2d0 +  &
              GC_MHH) - 4d0*cima*GC_145*GC_149*Nc*rMHL**2d0*(-GC_I*rMHH**2d0 - &
              GC_MHH) + 8d0*cima*GC_145*GC_149*Nc*(6d0*cMD**2d0 - rMHH**2d0)*( &
              GC_I*rMHL**2d0 + GC_MHH) + 8d0*cima*GC_145*GC_149*Nc*(6d0*cMD**  &
              2d0 - rMHL**2d0)*(-GC_I*rMHH**2d0 - GC_MHH) + 24d0*cima*GC_153*  &
              GC_157*cME**2d0*(-GC_I*rMHH**2d0 - GC_MHH) + 24d0*cima*GC_153*   &
              GC_157*cME**2d0*(GC_I*rMHL**2d0 + GC_MHH) - 4d0*cima*GC_153*     &
              GC_157*rMHH**2d0*(GC_I*rMHL**2d0 + GC_MHH) - 4d0*cima*GC_153*    &
              GC_157*rMHL**2d0*(-GC_I*rMHH**2d0 - GC_MHH) + 8d0*cima*GC_153*   &
              GC_157*(6d0*cME**2d0 - rMHH**2d0)*(GC_I*rMHL**2d0 + GC_MHH) + 8d0&
              *cima*GC_153*GC_157*(6d0*cME**2d0 - rMHL**2d0)*(-GC_I*rMHH**2d0  &
               - GC_MHH) + 24d0*cima*GC_161*GC_165*cMM**2d0*(-GC_I*rMHH**2d0 - &
              GC_MHH) + 24d0*cima*GC_161*GC_165*cMM**2d0*(GC_I*rMHL**2d0 +     &
              GC_MHH) - 4d0*cima*GC_161*GC_165*rMHH**2d0*(GC_I*rMHL**2d0 +     &
              GC_MHH) - 4d0*cima*GC_161*GC_165*rMHL**2d0*(-GC_I*rMHH**2d0 -    &
              GC_MHH) + 8d0*cima*GC_161*GC_165*(6d0*cMM**2d0 - rMHH**2d0)*(GC_I&
              *rMHL**2d0 + GC_MHH) + 8d0*cima*GC_161*GC_165*(6d0*cMM**2d0 -    &
              rMHL**2d0)*(-GC_I*rMHH**2d0 - GC_MHH) + 24d0*cima*GC_169*GC_173* &
              Nc*cMS**2d0*(-GC_I*rMHH**2d0 - GC_MHH) + 24d0*cima*GC_169*GC_173*&
              Nc*cMS**2d0*(GC_I*rMHL**2d0 + GC_MHH) - 4d0*cima*GC_169*GC_173*Nc&
              *rMHH**2d0*(GC_I*rMHL**2d0 + GC_MHH) - 4d0*cima*GC_169*GC_173*Nc*&
              rMHL**2d0*(-GC_I*rMHH**2d0 - GC_MHH) + 8d0*cima*GC_169*GC_173*Nc &
              *(6d0*cMS**2d0 - rMHH**2d0)*(GC_I*rMHL**2d0 + GC_MHH) + 8d0*cima*&
              GC_169*GC_173*Nc*(6d0*cMS**2d0 - rMHL**2d0)*(-GC_I*rMHH**2d0 -   &
              GC_MHH) + 24d0*cima*GC_177*GC_180*Nc*cMT**2d0*(-GC_I*rMHH**2d0 - &
              GC_MHH) + 24d0*cima*GC_177*GC_180*Nc*cMT**2d0*(GC_I*rMHL**2d0 +  &
              GC_MHH) - 4d0*cima*GC_177*GC_180*Nc*rMHH**2d0*(GC_I*rMHL**2d0 +  &
              GC_MHH) - 4d0*cima*GC_177*GC_180*Nc*rMHL**2d0*(-GC_I*rMHH**2d0 - &
              GC_MHH) + 8d0*cima*GC_177*GC_180*Nc*(6d0*cMT**2d0 - rMHH**2d0)*( &
              GC_I*rMHL**2d0 + GC_MHH) + 8d0*cima*GC_177*GC_180*Nc*(6d0*cMT**  &
              2d0 - rMHL**2d0)*(-GC_I*rMHH**2d0 - GC_MHH) + 24d0*cima*GC_184*  &
              GC_188*cMTA**2d0*(-GC_I*rMHH**2d0 - GC_MHH) + 24d0*cima*GC_184*  &
              GC_188*cMTA**2d0*(GC_I*rMHL**2d0 + GC_MHH) - 4d0*cima*GC_184*    &
              GC_188*rMHH**2d0*(GC_I*rMHL**2d0 + GC_MHH) - 4d0*cima*GC_184*    &
              GC_188*rMHL**2d0*(-GC_I*rMHH**2d0 - GC_MHH) + 8d0*cima*GC_184*   &
              GC_188*(6d0*cMTA**2d0 - rMHH**2d0)*(GC_I*rMHL**2d0 + GC_MHH) +   &
              8d0*cima*GC_184*GC_188*(6d0*cMTA**2d0 - rMHL**2d0)*(-GC_I*rMHH** &
              2d0 - GC_MHH) + 24d0*cima*GC_192*GC_195*Nc*cMU**2d0*(-GC_I*rMHH**&
              2d0 - GC_MHH) + 24d0*cima*GC_192*GC_195*Nc*cMU**2d0*(GC_I*rMHL** &
              2d0 + GC_MHH) - 4d0*cima*GC_192*GC_195*Nc*rMHH**2d0*(GC_I*rMHL** &
              2d0 + GC_MHH) - 4d0*cima*GC_192*GC_195*Nc*rMHL**2d0*(-GC_I*rMHH**&
              2d0 - GC_MHH) + 8d0*cima*GC_192*GC_195*Nc*(6d0*cMU**2d0 - rMHH** &
              2d0)*(GC_I*rMHL**2d0 + GC_MHH) + 8d0*cima*GC_192*GC_195*Nc*(6d0* &
              cMU**2d0 - rMHL**2d0)*(-GC_I*rMHH**2d0 - GC_MHH) + 6d0*GC_22*GC_I&
              *cMHC**2d0*(rMHH**2d0 - rMHL**2d0) + 6d0*GC_23*GC_I*cMW**2d0*(   &
              rMHH**2d0 - rMHL**2d0) + 3d0*GC_25*GC_I*cMZ**2d0*(rMHH**2d0 -    &
              rMHL**2d0) + 3d0*GC_26*GC_I*cMHA**2d0*(rMHH**2d0 - rMHL**2d0) +  &
              3d0*GC_9*GC_I*cMHL**2d0*(rMHH**2d0 - rMHL**2d0) - cima*GC_91*    &
              GC_94*rMHH**2d0*(-GC_I*rMHL**2d0 - GC_MHH) - cima*GC_91*GC_94*   &
              rMHL**2d0*(GC_I*rMHH**2d0 + GC_MHH) + 2d0*cima*GC_91*GC_94*(6d0* &
              cMZ**2d0 - rMHH**2d0)*(-GC_I*rMHL**2d0 - GC_MHH) + 2d0*cima*GC_91&
              *GC_94*(6d0*cMZ**2d0 - rMHL**2d0)*(GC_I*rMHH**2d0 + GC_MHH) + 2d0&
              *cima*GC_92*GC_94*rMHH**2d0*(-GC_I*rMHL**2d0 - GC_MHH) + 2d0*cima&
              *GC_92*GC_94*rMHL**2d0*(GC_I*rMHH**2d0 + GC_MHH) + 2d0*cima*GC_92&
              *GC_94*(GC_I*rMHH**2d0 + GC_MHH)*(3d0*cMHA**2d0 + 3d0*cMZ**2d0 - &
              rMHL**2d0) + 2d0*cima*GC_92*GC_94*(-GC_I*rMHL**2d0 - GC_MHH)*(3d0&
              *cMHA**2d0 + 3d0*cMZ**2d0 - rMHH**2d0) + 2d0*cima*rMHH**2d0*(-   &
              GC_1055*GC_1505*GC_I*rMHL**2d0 - GC_1055*GC_1505*GC_MHH - GC_1321&
              *GC_851*GC_I*rMHL**2d0 - GC_1321*GC_851*GC_MHH) - cima*rMHH**2d0 &
              *(-GC_63*GC_69*GC_I*rMHL**2d0 - GC_63*GC_69*GC_MHH - GC_64*GC_68*&
              GC_I*rMHL**2d0 - GC_64*GC_68*GC_MHH) - 3d0*cima*rMHH**2d0*(      &
              GC_1553*GC_94*GC_I*rMHL**2d0 + GC_1553*GC_94*GC_MHH + GC_2429*   &
              GC_92*GC_I*rMHL**2d0 + GC_2429*GC_92*GC_MHH - 2d0*GC_92*GC_94*   &
              GC_I*rMHL**2d0 - 2d0*GC_92*GC_94*GC_MHH) - 3d0*cima*rMHH**2d0*(- &
              2d0*GC_1055*GC_1505*GC_I*rMHL**2d0 - 2d0*GC_1055*GC_1505*GC_MHH  &
               + GC_1055*GC_63*GC_I*rMHL**2d0 + GC_1055*GC_63*GC_MHH + GC_1321*&
              GC_64*GC_I*rMHL**2d0 + GC_1321*GC_64*GC_MHH - 2d0*GC_1321*GC_851*&
              GC_I*rMHL**2d0 - 2d0*GC_1321*GC_851*GC_MHH + GC_1505*GC_68*GC_I* &
              rMHL**2d0 + GC_1505*GC_68*GC_MHH + GC_69*GC_851*GC_I*rMHL**2d0 + &
              GC_69*GC_851*GC_MHH) + 2d0*cima*rMHL**2d0*(GC_1055*GC_1505*GC_I* &
              rMHH**2d0 + GC_1055*GC_1505*GC_MHH + GC_1321*GC_851*GC_I*rMHH**  &
              2d0 + GC_1321*GC_851*GC_MHH) - cima*rMHL**2d0*(GC_63*GC_69*GC_I* &
              rMHH**2d0 + GC_63*GC_69*GC_MHH + GC_64*GC_68*GC_I*rMHH**2d0 +    &
              GC_64*GC_68*GC_MHH) - 3d0*cima*rMHL**2d0*(-GC_1553*GC_94*GC_I*   &
              rMHH**2d0 - GC_1553*GC_94*GC_MHH - GC_2429*GC_92*GC_I*rMHH**2d0  &
               - GC_2429*GC_92*GC_MHH + 2d0*GC_92*GC_94*GC_I*rMHH**2d0 + 2d0*  &
              GC_92*GC_94*GC_MHH) - 3d0*cima*rMHL**2d0*(2d0*GC_1055*GC_1505*   &
              GC_I*rMHH**2d0 + 2d0*GC_1055*GC_1505*GC_MHH - GC_1055*GC_63*GC_I*&
              rMHH**2d0 - GC_1055*GC_63*GC_MHH - GC_1321*GC_64*GC_I*rMHH**2d0  &
               - GC_1321*GC_64*GC_MHH + 2d0*GC_1321*GC_851*GC_I*rMHH**2d0 + 2d0&
              *GC_1321*GC_851*GC_MHH - GC_1505*GC_68*GC_I*rMHH**2d0 - GC_1505* &
              GC_68*GC_MHH - GC_69*GC_851*GC_I*rMHH**2d0 - GC_69*GC_851*GC_MHH &
              ) + 2d0*cima*(6d0*cMW**2d0 - rMHH**2d0)*(-GC_63*GC_69*GC_I*rMHL**&
              2d0 - GC_63*GC_69*GC_MHH - GC_64*GC_68*GC_I*rMHL**2d0 - GC_64*   &
              GC_68*GC_MHH) + 2d0*cima*(6d0*cMW**2d0 - rMHL**2d0)*(GC_63*GC_69*&
              GC_I*rMHH**2d0 + GC_63*GC_69*GC_MHH + GC_64*GC_68*GC_I*rMHH**2d0 &
               + GC_64*GC_68*GC_MHH) + 2d0*cima*(3d0*cMHC**2d0 + 3d0*cMW**2d0  &
               - rMHH**2d0)*(-GC_1055*GC_1505*GC_I*rMHL**2d0 - GC_1055*GC_1505*&
              GC_MHH - GC_1321*GC_851*GC_I*rMHL**2d0 - GC_1321*GC_851*GC_MHH   &
              ) + 2d0*cima*(3d0*cMHC**2d0 + 3d0*cMW**2d0 - rMHL**2d0)*(GC_1055*&
              GC_1505*GC_I*rMHH**2d0 + GC_1055*GC_1505*GC_MHH + GC_1321*GC_851*&
              GC_I*rMHH**2d0 + GC_1321*GC_851*GC_MHH) + 6d0*cima*(GC_112*GC_120&
              *GC_I*rMHH**2d0 + GC_112*GC_120*GC_MHH + GC_1553*GC_2429*GC_I*   &
              rMHH**2d0*rMHL**2d0 + GC_1553*GC_2429*GC_MHH*rMHL**2d0 - GC_1553*&
              GC_94*GC_I*rMHH**2d0*rMHL**2d0 - GC_1553*GC_94*GC_MHH*rMHL**2d0  &
               - GC_2429*GC_92*GC_I*rMHH**2d0*rMHL**2d0 - GC_2429*GC_92*GC_MHH*&
              rMHL**2d0 + GC_92*GC_94*GC_I*rMHH**2d0*rMHL**2d0 + GC_92*GC_94*  &
              GC_MHH*rMHL**2d0) + 6d0*cima*(-GC_112*GC_120*GC_I*rMHL**2d0 -    &
              GC_112*GC_120*GC_MHH - GC_1553*GC_2429*GC_I*rMHH**2d0*rMHL**2d0  &
               - GC_1553*GC_2429*GC_MHH*rMHH**2d0 + GC_1553*GC_94*GC_I*rMHH**  &
              2d0*rMHL**2d0 + GC_1553*GC_94*GC_MHH*rMHH**2d0 + GC_2429*GC_92*  &
              GC_I*rMHH**2d0*rMHL**2d0 + GC_2429*GC_92*GC_MHH*rMHH**2d0 - GC_92&
              *GC_94*GC_I*rMHH**2d0*rMHL**2d0 - GC_92*GC_94*GC_MHH*rMHH**2d0   &
              ) + 3d0*cima*(GC_109*GC_117*GC_I*rMHH**2d0 + GC_109*GC_117*GC_MHH&
               + 4d0*GC_128*GC_129*GC_I*rMHH**2d0 + 4d0*GC_128*GC_129*GC_MHH - &
              GC_2429*GC_91*GC_I*rMHH**2d0*rMHL**2d0 - GC_2429*GC_91*GC_MHH*   &
              rMHL**2d0 + 2d0*GC_2429*GC_955*GC_I*rMHH**2d0*rMHL**2d0 + 2d0*   &
              GC_2429*GC_955*GC_MHH*rMHL**2d0 + GC_91*GC_94*GC_I*rMHH**2d0*rMHL&
              **2d0 + GC_91*GC_94*GC_MHH*rMHL**2d0 - 2d0*GC_93*GC_95*GC_I*rMHH &
              **2d0 - 2d0*GC_93*GC_95*GC_MHH - GC_94*GC_955*GC_I*rMHH**2d0*rMHL&
              **2d0 - GC_94*GC_955*GC_MHH*rMHL**2d0) + 3d0*cima*(-GC_109*GC_117&
              *GC_I*rMHL**2d0 - GC_109*GC_117*GC_MHH - 4d0*GC_128*GC_129*GC_I* &
              rMHL**2d0 - 4d0*GC_128*GC_129*GC_MHH + GC_2429*GC_91*GC_I*rMHH** &
              2d0*rMHL**2d0 + GC_2429*GC_91*GC_MHH*rMHH**2d0 - 2d0*GC_2429*    &
              GC_955*GC_I*rMHH**2d0*rMHL**2d0 - 2d0*GC_2429*GC_955*GC_MHH*rMHH &
              **2d0 - GC_91*GC_94*GC_I*rMHH**2d0*rMHL**2d0 - GC_91*GC_94*GC_MHH&
              *rMHH**2d0 + 2d0*GC_93*GC_95*GC_I*rMHL**2d0 + 2d0*GC_93*GC_95*   &
              GC_MHH + GC_94*GC_955*GC_I*rMHH**2d0*rMHL**2d0 + GC_94*GC_955*   &
              GC_MHH*rMHH**2d0) + 6d0*cima*(-GC_1055*GC_1505*GC_I*rMHH**2d0*   &
              rMHL**2d0 - GC_1055*GC_1505*GC_MHH*rMHH**2d0 + GC_1055*GC_63*GC_I&
              *rMHH**2d0*rMHL**2d0 + GC_1055*GC_63*GC_MHH*rMHH**2d0 - 2d0*     &
              GC_111*GC_119*GC_I*rMHL**2d0 - 2d0*GC_111*GC_119*GC_MHH + GC_1321&
              *GC_64*GC_I*rMHH**2d0*rMHL**2d0 + GC_1321*GC_64*GC_MHH*rMHH**2d0 &
               - GC_1321*GC_851*GC_I*rMHH**2d0*rMHL**2d0 - GC_1321*GC_851*     &
              GC_MHH*rMHH**2d0 + GC_1505*GC_68*GC_I*rMHH**2d0*rMHL**2d0 +      &
              GC_1505*GC_68*GC_MHH*rMHH**2d0 - GC_63*GC_68*GC_I*rMHH**2d0*rMHL &
              **2d0 - GC_63*GC_68*GC_MHH*rMHH**2d0 - GC_64*GC_69*GC_I*rMHH**2d0&
              *rMHL**2d0 - GC_64*GC_69*GC_MHH*rMHH**2d0 + GC_69*GC_851*GC_I*   &
              rMHH**2d0*rMHL**2d0 + GC_69*GC_851*GC_MHH*rMHH**2d0) + 6d0*cima*(&
              GC_1055*GC_1505*GC_I*rMHH**2d0*rMHL**2d0 + GC_1055*GC_1505*GC_MHH&
              *rMHL**2d0 - GC_1055*GC_63*GC_I*rMHH**2d0*rMHL**2d0 - GC_1055*   &
              GC_63*GC_MHH*rMHL**2d0 + 2d0*GC_111*GC_119*GC_I*rMHH**2d0 + 2d0* &
              GC_111*GC_119*GC_MHH - GC_1321*GC_64*GC_I*rMHH**2d0*rMHL**2d0 -  &
              GC_1321*GC_64*GC_MHH*rMHL**2d0 + GC_1321*GC_851*GC_I*rMHH**2d0*  &
              rMHL**2d0 + GC_1321*GC_851*GC_MHH*rMHL**2d0 - GC_1505*GC_68*GC_I*&
              rMHH**2d0*rMHL**2d0 - GC_1505*GC_68*GC_MHH*rMHL**2d0 + GC_63*    &
              GC_68*GC_I*rMHH**2d0*rMHL**2d0 + GC_63*GC_68*GC_MHH*rMHL**2d0 +  &
              GC_64*GC_69*GC_I*rMHH**2d0*rMHL**2d0 + GC_64*GC_69*GC_MHH*rMHL** &
              2d0 - GC_69*GC_851*GC_I*rMHH**2d0*rMHL**2d0 - GC_69*GC_851*GC_MHH&
              *rMHL**2d0) + 3d0*cima*(-GC_1055*GC_64*GC_I*rMHH**2d0*rMHL**2d0  &
               - GC_1055*GC_64*GC_MHH*rMHL**2d0 + 2d0*GC_1055*GC_851*GC_I*rMHH &
              **2d0*rMHL**2d0 + 2d0*GC_1055*GC_851*GC_MHH*rMHL**2d0 + 2d0*     &
              GC_108*GC_116*GC_I*rMHH**2d0 + 2d0*GC_108*GC_116*GC_MHH + 8d0*   &
              GC_124*GC_125*GC_I*rMHH**2d0 + 8d0*GC_124*GC_125*GC_MHH + 2d0*   &
              GC_1321*GC_1505*GC_I*rMHH**2d0*rMHL**2d0 + 2d0*GC_1321*GC_1505*  &
              GC_MHH*rMHL**2d0 - GC_1321*GC_63*GC_I*rMHH**2d0*rMHL**2d0 -      &
              GC_1321*GC_63*GC_MHH*rMHL**2d0 - GC_1505*GC_69*GC_I*rMHH**2d0*   &
              rMHL**2d0 - GC_1505*GC_69*GC_MHH*rMHL**2d0 + GC_63*GC_69*GC_I*   &
              rMHH**2d0*rMHL**2d0 + GC_63*GC_69*GC_MHH*rMHL**2d0 + GC_64*GC_68*&
              GC_I*rMHH**2d0*rMHL**2d0 + GC_64*GC_68*GC_MHH*rMHL**2d0 - 4d0*   &
              GC_67*GC_71*GC_I*rMHH**2d0 - 4d0*GC_67*GC_71*GC_MHH - GC_68*     &
              GC_851*GC_I*rMHH**2d0*rMHL**2d0 - GC_68*GC_851*GC_MHH*rMHL**2d0  &
              ) + 3d0*cima*(GC_1055*GC_64*GC_I*rMHH**2d0*rMHL**2d0 + GC_1055*  &
              GC_64*GC_MHH*rMHH**2d0 - 2d0*GC_1055*GC_851*GC_I*rMHH**2d0*rMHL**&
              2d0 - 2d0*GC_1055*GC_851*GC_MHH*rMHH**2d0 - 2d0*GC_108*GC_116*   &
              GC_I*rMHL**2d0 - 2d0*GC_108*GC_116*GC_MHH - 8d0*GC_124*GC_125*   &
              GC_I*rMHL**2d0 - 8d0*GC_124*GC_125*GC_MHH - 2d0*GC_1321*GC_1505* &
              GC_I*rMHH**2d0*rMHL**2d0 - 2d0*GC_1321*GC_1505*GC_MHH*rMHH**2d0  &
               + GC_1321*GC_63*GC_I*rMHH**2d0*rMHL**2d0 + GC_1321*GC_63*GC_MHH*&
              rMHH**2d0 + GC_1505*GC_69*GC_I*rMHH**2d0*rMHL**2d0 + GC_1505*    &
              GC_69*GC_MHH*rMHH**2d0 - GC_63*GC_69*GC_I*rMHH**2d0*rMHL**2d0 -  &
              GC_63*GC_69*GC_MHH*rMHH**2d0 - GC_64*GC_68*GC_I*rMHH**2d0*rMHL** &
              2d0 - GC_64*GC_68*GC_MHH*rMHH**2d0 + 4d0*GC_67*GC_71*GC_I*rMHL** &
              2d0 + 4d0*GC_67*GC_71*GC_MHH + GC_68*GC_851*GC_I*rMHH**2d0*rMHL**&
              2d0 + GC_68*GC_851*GC_MHH*rMHH**2d0))/(48d0*pi**2d0*GC_I*(-GC_MHH&
              *rMHH**2d0 + GC_MHH*rMHL**2d0 + GC_MHL*rMHH**2d0 - GC_MHL*rMHL** &
              2d0)) + dtHh_MS*(GC_103*GC_I*rMHH**2d0/(-GC_I*GC_MHH*cMHH**2d0*  &
              rMHH**2d0/2d0 + GC_I*GC_MHH*cMHH**2d0*rMHL**2d0/2d0 + GC_I*GC_MHL&
              *cMHH**2d0*rMHH**2d0/2d0 - GC_I*GC_MHL*cMHH**2d0*rMHL**2d0/2d0   &
              ) - GC_103*GC_I*rMHL**2d0/(-GC_I*GC_MHH*cMHH**2d0*rMHH**2d0/2d0  &
               + GC_I*GC_MHH*cMHH**2d0*rMHL**2d0/2d0 + GC_I*GC_MHL*cMHH**2d0*  &
              rMHH**2d0/2d0 - GC_I*GC_MHL*cMHH**2d0*rMHL**2d0/2d0)) + dtHl_MS*(&
              GC_106*GC_I*rMHH**2d0/(-GC_I*GC_MHH*cMHL**2d0*rMHH**2d0/2d0 +    &
              GC_I*GC_MHH*cMHL**2d0*rMHL**2d0/2d0 + GC_I*GC_MHL*cMHL**2d0*rMHH &
              **2d0/2d0 - GC_I*GC_MHL*cMHL**2d0*rMHL**2d0/2d0) - GC_106*GC_I*  &
              rMHL**2d0/(-GC_I*GC_MHH*cMHL**2d0*rMHH**2d0/2d0 + GC_I*GC_MHH*   &
              cMHL**2d0*rMHL**2d0/2d0 + GC_I*GC_MHL*cMHL**2d0*rMHH**2d0/2d0 -  &
              GC_I*GC_MHL*cMHL**2d0*rMHL**2d0/2d0))
  dZHhHl_MS = DeltaUV*(3d0*GC_10*GC_I*cMHH**2d0*(-rMHH**2d0 + rMHL**2d0) + 3d0*&
              cima*GC_103*GC_105*(-GC_I*rMHH**2d0 - GC_MHL) + 3d0*cima*GC_103* &
              GC_105*(GC_I*rMHL**2d0 + GC_MHL) + 6d0*cima*GC_103*GC_106*(-GC_I*&
              rMHH**2d0 - GC_MHL) + 6d0*cima*GC_103*GC_106*(GC_I*rMHL**2d0 +   &
              GC_MHL) + 3d0*cima*GC_104*GC_106*(-GC_I*rMHH**2d0 - GC_MHL) + 3d0&
              *cima*GC_104*GC_106*(GC_I*rMHL**2d0 + GC_MHL) + 6d0*cima*GC_110* &
              GC_118*(-GC_I*rMHH**2d0 - GC_MHL) + 6d0*cima*GC_110*GC_118*(GC_I*&
              rMHL**2d0 + GC_MHL) + 3d0*cima*GC_113*GC_121*(-GC_I*rMHH**2d0 -  &
              GC_MHL) + 3d0*cima*GC_113*GC_121*(GC_I*rMHL**2d0 + GC_MHL) + 24d0&
              *cima*GC_130*GC_133*Nc*cMC**2d0*(GC_I*rMHH**2d0 + GC_MHL) + 24d0*&
              cima*GC_130*GC_133*Nc*cMC**2d0*(-GC_I*rMHL**2d0 - GC_MHL) - 4d0* &
              cima*GC_130*GC_133*Nc*rMHH**2d0*(-GC_I*rMHL**2d0 - GC_MHL) - 4d0*&
              cima*GC_130*GC_133*Nc*rMHL**2d0*(GC_I*rMHH**2d0 + GC_MHL) + 8d0* &
              cima*GC_130*GC_133*Nc*(6d0*cMC**2d0 - rMHH**2d0)*(-GC_I*rMHL**2d0&
               - GC_MHL) + 8d0*cima*GC_130*GC_133*Nc*(6d0*cMC**2d0 - rMHL**2d0 &
              )*(GC_I*rMHH**2d0 + GC_MHL) + 24d0*cima*GC_137*GC_141*Nc*cMB**2d0&
              *(GC_I*rMHH**2d0 + GC_MHL) + 24d0*cima*GC_137*GC_141*Nc*cMB**2d0 &
              *(-GC_I*rMHL**2d0 - GC_MHL) - 4d0*cima*GC_137*GC_141*Nc*rMHH**2d0&
              *(-GC_I*rMHL**2d0 - GC_MHL) - 4d0*cima*GC_137*GC_141*Nc*rMHL**2d0&
              *(GC_I*rMHH**2d0 + GC_MHL) + 8d0*cima*GC_137*GC_141*Nc*(6d0*cMB**&
              2d0 - rMHH**2d0)*(-GC_I*rMHL**2d0 - GC_MHL) + 8d0*cima*GC_137*   &
              GC_141*Nc*(6d0*cMB**2d0 - rMHL**2d0)*(GC_I*rMHH**2d0 + GC_MHL) + &
              24d0*cima*GC_145*GC_149*Nc*cMD**2d0*(GC_I*rMHH**2d0 + GC_MHL) +  &
              24d0*cima*GC_145*GC_149*Nc*cMD**2d0*(-GC_I*rMHL**2d0 - GC_MHL) - &
              4d0*cima*GC_145*GC_149*Nc*rMHH**2d0*(-GC_I*rMHL**2d0 - GC_MHL) - &
              4d0*cima*GC_145*GC_149*Nc*rMHL**2d0*(GC_I*rMHH**2d0 + GC_MHL) +  &
              8d0*cima*GC_145*GC_149*Nc*(6d0*cMD**2d0 - rMHH**2d0)*(-GC_I*rMHL &
              **2d0 - GC_MHL) + 8d0*cima*GC_145*GC_149*Nc*(6d0*cMD**2d0 - rMHL &
              **2d0)*(GC_I*rMHH**2d0 + GC_MHL) + 24d0*cima*GC_153*GC_157*cME** &
              2d0*(GC_I*rMHH**2d0 + GC_MHL) + 24d0*cima*GC_153*GC_157*cME**2d0 &
              *(-GC_I*rMHL**2d0 - GC_MHL) - 4d0*cima*GC_153*GC_157*rMHH**2d0*(-&
              GC_I*rMHL**2d0 - GC_MHL) - 4d0*cima*GC_153*GC_157*rMHL**2d0*(GC_I&
              *rMHH**2d0 + GC_MHL) + 8d0*cima*GC_153*GC_157*(6d0*cME**2d0 -    &
              rMHH**2d0)*(-GC_I*rMHL**2d0 - GC_MHL) + 8d0*cima*GC_153*GC_157*( &
              6d0*cME**2d0 - rMHL**2d0)*(GC_I*rMHH**2d0 + GC_MHL) + 24d0*cima* &
              GC_161*GC_165*cMM**2d0*(GC_I*rMHH**2d0 + GC_MHL) + 24d0*cima*    &
              GC_161*GC_165*cMM**2d0*(-GC_I*rMHL**2d0 - GC_MHL) - 4d0*cima*    &
              GC_161*GC_165*rMHH**2d0*(-GC_I*rMHL**2d0 - GC_MHL) - 4d0*cima*   &
              GC_161*GC_165*rMHL**2d0*(GC_I*rMHH**2d0 + GC_MHL) + 8d0*cima*    &
              GC_161*GC_165*(6d0*cMM**2d0 - rMHH**2d0)*(-GC_I*rMHL**2d0 -      &
              GC_MHL) + 8d0*cima*GC_161*GC_165*(6d0*cMM**2d0 - rMHL**2d0)*(GC_I&
              *rMHH**2d0 + GC_MHL) + 24d0*cima*GC_169*GC_173*Nc*cMS**2d0*(GC_I*&
              rMHH**2d0 + GC_MHL) + 24d0*cima*GC_169*GC_173*Nc*cMS**2d0*(-GC_I*&
              rMHL**2d0 - GC_MHL) - 4d0*cima*GC_169*GC_173*Nc*rMHH**2d0*(-GC_I*&
              rMHL**2d0 - GC_MHL) - 4d0*cima*GC_169*GC_173*Nc*rMHL**2d0*(GC_I* &
              rMHH**2d0 + GC_MHL) + 8d0*cima*GC_169*GC_173*Nc*(6d0*cMS**2d0 -  &
              rMHH**2d0)*(-GC_I*rMHL**2d0 - GC_MHL) + 8d0*cima*GC_169*GC_173*Nc&
              *(6d0*cMS**2d0 - rMHL**2d0)*(GC_I*rMHH**2d0 + GC_MHL) + 24d0*cima&
              *GC_177*GC_180*Nc*cMT**2d0*(GC_I*rMHH**2d0 + GC_MHL) + 24d0*cima*&
              GC_177*GC_180*Nc*cMT**2d0*(-GC_I*rMHL**2d0 - GC_MHL) - 4d0*cima* &
              GC_177*GC_180*Nc*rMHH**2d0*(-GC_I*rMHL**2d0 - GC_MHL) - 4d0*cima*&
              GC_177*GC_180*Nc*rMHL**2d0*(GC_I*rMHH**2d0 + GC_MHL) + 8d0*cima* &
              GC_177*GC_180*Nc*(6d0*cMT**2d0 - rMHH**2d0)*(-GC_I*rMHL**2d0 -   &
              GC_MHL) + 8d0*cima*GC_177*GC_180*Nc*(6d0*cMT**2d0 - rMHL**2d0)*( &
              GC_I*rMHH**2d0 + GC_MHL) + 24d0*cima*GC_184*GC_188*cMTA**2d0*(   &
              GC_I*rMHH**2d0 + GC_MHL) + 24d0*cima*GC_184*GC_188*cMTA**2d0*(-  &
              GC_I*rMHL**2d0 - GC_MHL) - 4d0*cima*GC_184*GC_188*rMHH**2d0*(-   &
              GC_I*rMHL**2d0 - GC_MHL) - 4d0*cima*GC_184*GC_188*rMHL**2d0*(GC_I&
              *rMHH**2d0 + GC_MHL) + 8d0*cima*GC_184*GC_188*(6d0*cMTA**2d0 -   &
              rMHH**2d0)*(-GC_I*rMHL**2d0 - GC_MHL) + 8d0*cima*GC_184*GC_188*( &
              6d0*cMTA**2d0 - rMHL**2d0)*(GC_I*rMHH**2d0 + GC_MHL) + 24d0*cima*&
              GC_192*GC_195*Nc*cMU**2d0*(GC_I*rMHH**2d0 + GC_MHL) + 24d0*cima* &
              GC_192*GC_195*Nc*cMU**2d0*(-GC_I*rMHL**2d0 - GC_MHL) - 4d0*cima* &
              GC_192*GC_195*Nc*rMHH**2d0*(-GC_I*rMHL**2d0 - GC_MHL) - 4d0*cima*&
              GC_192*GC_195*Nc*rMHL**2d0*(GC_I*rMHH**2d0 + GC_MHL) + 8d0*cima* &
              GC_192*GC_195*Nc*(6d0*cMU**2d0 - rMHH**2d0)*(-GC_I*rMHL**2d0 -   &
              GC_MHL) + 8d0*cima*GC_192*GC_195*Nc*(6d0*cMU**2d0 - rMHL**2d0)*( &
              GC_I*rMHH**2d0 + GC_MHL) + 6d0*GC_22*GC_I*cMHC**2d0*(-rMHH**2d0  &
               + rMHL**2d0) + 6d0*GC_23*GC_I*cMW**2d0*(-rMHH**2d0 + rMHL**2d0  &
              ) + 3d0*GC_25*GC_I*cMZ**2d0*(-rMHH**2d0 + rMHL**2d0) + 3d0*GC_26*&
              GC_I*cMHA**2d0*(-rMHH**2d0 + rMHL**2d0) + 3d0*GC_9*GC_I*cMHL**2d0&
              *(-rMHH**2d0 + rMHL**2d0) - cima*GC_91*GC_94*rMHH**2d0*(GC_I*rMHL&
              **2d0 + GC_MHL) - cima*GC_91*GC_94*rMHL**2d0*(-GC_I*rMHH**2d0 -  &
              GC_MHL) + 2d0*cima*GC_91*GC_94*(6d0*cMZ**2d0 - rMHH**2d0)*(GC_I* &
              rMHL**2d0 + GC_MHL) + 2d0*cima*GC_91*GC_94*(6d0*cMZ**2d0 - rMHL**&
              2d0)*(-GC_I*rMHH**2d0 - GC_MHL) + 2d0*cima*GC_92*GC_94*rMHH**2d0 &
              *(GC_I*rMHL**2d0 + GC_MHL) + 2d0*cima*GC_92*GC_94*rMHL**2d0*(-   &
              GC_I*rMHH**2d0 - GC_MHL) + 2d0*cima*GC_92*GC_94*(-GC_I*rMHH**2d0 &
               - GC_MHL)*(3d0*cMHA**2d0 + 3d0*cMZ**2d0 - rMHL**2d0) + 2d0*cima*&
              GC_92*GC_94*(GC_I*rMHL**2d0 + GC_MHL)*(3d0*cMHA**2d0 + 3d0*cMZ** &
              2d0 - rMHH**2d0) + 2d0*cima*rMHH**2d0*(GC_1055*GC_1505*GC_I*rMHL &
              **2d0 + GC_1055*GC_1505*GC_MHL + GC_1321*GC_851*GC_I*rMHL**2d0 + &
              GC_1321*GC_851*GC_MHL) - cima*rMHH**2d0*(GC_63*GC_69*GC_I*rMHL** &
              2d0 + GC_63*GC_69*GC_MHL + GC_64*GC_68*GC_I*rMHL**2d0 + GC_64*   &
              GC_68*GC_MHL) - 3d0*cima*rMHH**2d0*(-GC_1553*GC_94*GC_I*rMHL**2d0&
               - GC_1553*GC_94*GC_MHL - GC_2429*GC_92*GC_I*rMHL**2d0 - GC_2429*&
              GC_92*GC_MHL + 2d0*GC_92*GC_94*GC_I*rMHL**2d0 + 2d0*GC_92*GC_94* &
              GC_MHL) - 3d0*cima*rMHH**2d0*(2d0*GC_1055*GC_1505*GC_I*rMHL**2d0 &
               + 2d0*GC_1055*GC_1505*GC_MHL - GC_1055*GC_63*GC_I*rMHL**2d0 -   &
              GC_1055*GC_63*GC_MHL - GC_1321*GC_64*GC_I*rMHL**2d0 - GC_1321*   &
              GC_64*GC_MHL + 2d0*GC_1321*GC_851*GC_I*rMHL**2d0 + 2d0*GC_1321*  &
              GC_851*GC_MHL - GC_1505*GC_68*GC_I*rMHL**2d0 - GC_1505*GC_68*    &
              GC_MHL - GC_69*GC_851*GC_I*rMHL**2d0 - GC_69*GC_851*GC_MHL) + 2d0&
              *cima*rMHL**2d0*(-GC_1055*GC_1505*GC_I*rMHH**2d0 - GC_1055*      &
              GC_1505*GC_MHL - GC_1321*GC_851*GC_I*rMHH**2d0 - GC_1321*GC_851* &
              GC_MHL) - cima*rMHL**2d0*(-GC_63*GC_69*GC_I*rMHH**2d0 - GC_63*   &
              GC_69*GC_MHL - GC_64*GC_68*GC_I*rMHH**2d0 - GC_64*GC_68*GC_MHL   &
              ) - 3d0*cima*rMHL**2d0*(GC_1553*GC_94*GC_I*rMHH**2d0 + GC_1553*  &
              GC_94*GC_MHL + GC_2429*GC_92*GC_I*rMHH**2d0 + GC_2429*GC_92*     &
              GC_MHL - 2d0*GC_92*GC_94*GC_I*rMHH**2d0 - 2d0*GC_92*GC_94*GC_MHL &
              ) - 3d0*cima*rMHL**2d0*(-2d0*GC_1055*GC_1505*GC_I*rMHH**2d0 - 2d0&
              *GC_1055*GC_1505*GC_MHL + GC_1055*GC_63*GC_I*rMHH**2d0 + GC_1055*&
              GC_63*GC_MHL + GC_1321*GC_64*GC_I*rMHH**2d0 + GC_1321*GC_64*     &
              GC_MHL - 2d0*GC_1321*GC_851*GC_I*rMHH**2d0 - 2d0*GC_1321*GC_851* &
              GC_MHL + GC_1505*GC_68*GC_I*rMHH**2d0 + GC_1505*GC_68*GC_MHL +   &
              GC_69*GC_851*GC_I*rMHH**2d0 + GC_69*GC_851*GC_MHL) + 2d0*cima*(  &
              6d0*cMW**2d0 - rMHH**2d0)*(GC_63*GC_69*GC_I*rMHL**2d0 + GC_63*   &
              GC_69*GC_MHL + GC_64*GC_68*GC_I*rMHL**2d0 + GC_64*GC_68*GC_MHL   &
              ) + 2d0*cima*(6d0*cMW**2d0 - rMHL**2d0)*(-GC_63*GC_69*GC_I*rMHH**&
              2d0 - GC_63*GC_69*GC_MHL - GC_64*GC_68*GC_I*rMHH**2d0 - GC_64*   &
              GC_68*GC_MHL) + 2d0*cima*(3d0*cMHC**2d0 + 3d0*cMW**2d0 - rMHH**  &
              2d0)*(GC_1055*GC_1505*GC_I*rMHL**2d0 + GC_1055*GC_1505*GC_MHL +  &
              GC_1321*GC_851*GC_I*rMHL**2d0 + GC_1321*GC_851*GC_MHL) + 2d0*cima&
              *(3d0*cMHC**2d0 + 3d0*cMW**2d0 - rMHL**2d0)*(-GC_1055*GC_1505*   &
              GC_I*rMHH**2d0 - GC_1055*GC_1505*GC_MHL - GC_1321*GC_851*GC_I*   &
              rMHH**2d0 - GC_1321*GC_851*GC_MHL) + 6d0*cima*(-GC_112*GC_120*   &
              GC_I*rMHH**2d0 - GC_112*GC_120*GC_MHL - GC_1553*GC_2429*GC_I*rMHH&
              **2d0*rMHL**2d0 - GC_1553*GC_2429*GC_MHL*rMHL**2d0 + GC_1553*    &
              GC_94*GC_I*rMHH**2d0*rMHL**2d0 + GC_1553*GC_94*GC_MHL*rMHL**2d0  &
               + GC_2429*GC_92*GC_I*rMHH**2d0*rMHL**2d0 + GC_2429*GC_92*GC_MHL*&
              rMHL**2d0 - GC_92*GC_94*GC_I*rMHH**2d0*rMHL**2d0 - GC_92*GC_94*  &
              GC_MHL*rMHL**2d0) + 6d0*cima*(GC_112*GC_120*GC_I*rMHL**2d0 +     &
              GC_112*GC_120*GC_MHL + GC_1553*GC_2429*GC_I*rMHH**2d0*rMHL**2d0  &
               + GC_1553*GC_2429*GC_MHL*rMHH**2d0 - GC_1553*GC_94*GC_I*rMHH**  &
              2d0*rMHL**2d0 - GC_1553*GC_94*GC_MHL*rMHH**2d0 - GC_2429*GC_92*  &
              GC_I*rMHH**2d0*rMHL**2d0 - GC_2429*GC_92*GC_MHL*rMHH**2d0 + GC_92&
              *GC_94*GC_I*rMHH**2d0*rMHL**2d0 + GC_92*GC_94*GC_MHL*rMHH**2d0   &
              ) + 3d0*cima*(-GC_109*GC_117*GC_I*rMHH**2d0 - GC_109*GC_117*     &
              GC_MHL - 4d0*GC_128*GC_129*GC_I*rMHH**2d0 - 4d0*GC_128*GC_129*   &
              GC_MHL + GC_2429*GC_91*GC_I*rMHH**2d0*rMHL**2d0 + GC_2429*GC_91* &
              GC_MHL*rMHL**2d0 - 2d0*GC_2429*GC_955*GC_I*rMHH**2d0*rMHL**2d0 - &
              2d0*GC_2429*GC_955*GC_MHL*rMHL**2d0 - GC_91*GC_94*GC_I*rMHH**2d0*&
              rMHL**2d0 - GC_91*GC_94*GC_MHL*rMHL**2d0 + 2d0*GC_93*GC_95*GC_I* &
              rMHH**2d0 + 2d0*GC_93*GC_95*GC_MHL + GC_94*GC_955*GC_I*rMHH**2d0*&
              rMHL**2d0 + GC_94*GC_955*GC_MHL*rMHL**2d0) + 3d0*cima*(GC_109*   &
              GC_117*GC_I*rMHL**2d0 + GC_109*GC_117*GC_MHL + 4d0*GC_128*GC_129*&
              GC_I*rMHL**2d0 + 4d0*GC_128*GC_129*GC_MHL - GC_2429*GC_91*GC_I*  &
              rMHH**2d0*rMHL**2d0 - GC_2429*GC_91*GC_MHL*rMHH**2d0 + 2d0*      &
              GC_2429*GC_955*GC_I*rMHH**2d0*rMHL**2d0 + 2d0*GC_2429*GC_955*    &
              GC_MHL*rMHH**2d0 + GC_91*GC_94*GC_I*rMHH**2d0*rMHL**2d0 + GC_91* &
              GC_94*GC_MHL*rMHH**2d0 - 2d0*GC_93*GC_95*GC_I*rMHL**2d0 - 2d0*   &
              GC_93*GC_95*GC_MHL - GC_94*GC_955*GC_I*rMHH**2d0*rMHL**2d0 -     &
              GC_94*GC_955*GC_MHL*rMHH**2d0) + 6d0*cima*(-GC_1055*GC_1505*GC_I*&
              rMHH**2d0*rMHL**2d0 - GC_1055*GC_1505*GC_MHL*rMHL**2d0 + GC_1055*&
              GC_63*GC_I*rMHH**2d0*rMHL**2d0 + GC_1055*GC_63*GC_MHL*rMHL**2d0  &
               - 2d0*GC_111*GC_119*GC_I*rMHH**2d0 - 2d0*GC_111*GC_119*GC_MHL + &
              GC_1321*GC_64*GC_I*rMHH**2d0*rMHL**2d0 + GC_1321*GC_64*GC_MHL*   &
              rMHL**2d0 - GC_1321*GC_851*GC_I*rMHH**2d0*rMHL**2d0 - GC_1321*   &
              GC_851*GC_MHL*rMHL**2d0 + GC_1505*GC_68*GC_I*rMHH**2d0*rMHL**2d0 &
               + GC_1505*GC_68*GC_MHL*rMHL**2d0 - GC_63*GC_68*GC_I*rMHH**2d0*  &
              rMHL**2d0 - GC_63*GC_68*GC_MHL*rMHL**2d0 - GC_64*GC_69*GC_I*rMHH &
              **2d0*rMHL**2d0 - GC_64*GC_69*GC_MHL*rMHL**2d0 + GC_69*GC_851*   &
              GC_I*rMHH**2d0*rMHL**2d0 + GC_69*GC_851*GC_MHL*rMHL**2d0) + 6d0* &
              cima*(GC_1055*GC_1505*GC_I*rMHH**2d0*rMHL**2d0 + GC_1055*GC_1505*&
              GC_MHL*rMHH**2d0 - GC_1055*GC_63*GC_I*rMHH**2d0*rMHL**2d0 -      &
              GC_1055*GC_63*GC_MHL*rMHH**2d0 + 2d0*GC_111*GC_119*GC_I*rMHL**2d0&
               + 2d0*GC_111*GC_119*GC_MHL - GC_1321*GC_64*GC_I*rMHH**2d0*rMHL**&
              2d0 - GC_1321*GC_64*GC_MHL*rMHH**2d0 + GC_1321*GC_851*GC_I*rMHH**&
              2d0*rMHL**2d0 + GC_1321*GC_851*GC_MHL*rMHH**2d0 - GC_1505*GC_68* &
              GC_I*rMHH**2d0*rMHL**2d0 - GC_1505*GC_68*GC_MHL*rMHH**2d0 + GC_63&
              *GC_68*GC_I*rMHH**2d0*rMHL**2d0 + GC_63*GC_68*GC_MHL*rMHH**2d0 + &
              GC_64*GC_69*GC_I*rMHH**2d0*rMHL**2d0 + GC_64*GC_69*GC_MHL*rMHH** &
              2d0 - GC_69*GC_851*GC_I*rMHH**2d0*rMHL**2d0 - GC_69*GC_851*GC_MHL&
              *rMHH**2d0) + 3d0*cima*(-GC_1055*GC_64*GC_I*rMHH**2d0*rMHL**2d0  &
               - GC_1055*GC_64*GC_MHL*rMHH**2d0 + 2d0*GC_1055*GC_851*GC_I*rMHH &
              **2d0*rMHL**2d0 + 2d0*GC_1055*GC_851*GC_MHL*rMHH**2d0 + 2d0*     &
              GC_108*GC_116*GC_I*rMHL**2d0 + 2d0*GC_108*GC_116*GC_MHL + 8d0*   &
              GC_124*GC_125*GC_I*rMHL**2d0 + 8d0*GC_124*GC_125*GC_MHL + 2d0*   &
              GC_1321*GC_1505*GC_I*rMHH**2d0*rMHL**2d0 + 2d0*GC_1321*GC_1505*  &
              GC_MHL*rMHH**2d0 - GC_1321*GC_63*GC_I*rMHH**2d0*rMHL**2d0 -      &
              GC_1321*GC_63*GC_MHL*rMHH**2d0 - GC_1505*GC_69*GC_I*rMHH**2d0*   &
              rMHL**2d0 - GC_1505*GC_69*GC_MHL*rMHH**2d0 + GC_63*GC_69*GC_I*   &
              rMHH**2d0*rMHL**2d0 + GC_63*GC_69*GC_MHL*rMHH**2d0 + GC_64*GC_68*&
              GC_I*rMHH**2d0*rMHL**2d0 + GC_64*GC_68*GC_MHL*rMHH**2d0 - 4d0*   &
              GC_67*GC_71*GC_I*rMHL**2d0 - 4d0*GC_67*GC_71*GC_MHL - GC_68*     &
              GC_851*GC_I*rMHH**2d0*rMHL**2d0 - GC_68*GC_851*GC_MHL*rMHH**2d0  &
              ) + 3d0*cima*(GC_1055*GC_64*GC_I*rMHH**2d0*rMHL**2d0 + GC_1055*  &
              GC_64*GC_MHL*rMHL**2d0 - 2d0*GC_1055*GC_851*GC_I*rMHH**2d0*rMHL**&
              2d0 - 2d0*GC_1055*GC_851*GC_MHL*rMHL**2d0 - 2d0*GC_108*GC_116*   &
              GC_I*rMHH**2d0 - 2d0*GC_108*GC_116*GC_MHL - 8d0*GC_124*GC_125*   &
              GC_I*rMHH**2d0 - 8d0*GC_124*GC_125*GC_MHL - 2d0*GC_1321*GC_1505* &
              GC_I*rMHH**2d0*rMHL**2d0 - 2d0*GC_1321*GC_1505*GC_MHL*rMHL**2d0  &
               + GC_1321*GC_63*GC_I*rMHH**2d0*rMHL**2d0 + GC_1321*GC_63*GC_MHL*&
              rMHL**2d0 + GC_1505*GC_69*GC_I*rMHH**2d0*rMHL**2d0 + GC_1505*    &
              GC_69*GC_MHL*rMHL**2d0 - GC_63*GC_69*GC_I*rMHH**2d0*rMHL**2d0 -  &
              GC_63*GC_69*GC_MHL*rMHL**2d0 - GC_64*GC_68*GC_I*rMHH**2d0*rMHL** &
              2d0 - GC_64*GC_68*GC_MHL*rMHL**2d0 + 4d0*GC_67*GC_71*GC_I*rMHH** &
              2d0 + 4d0*GC_67*GC_71*GC_MHL + GC_68*GC_851*GC_I*rMHH**2d0*rMHL**&
              2d0 + GC_68*GC_851*GC_MHL*rMHL**2d0))/(48d0*pi**2d0*GC_I*(-GC_MHH&
              *rMHH**2d0 + GC_MHH*rMHL**2d0 + GC_MHL*rMHH**2d0 - GC_MHL*rMHL** &
              2d0)) + dtHh_MS*(-GC_103*GC_I*rMHH**2d0/(-GC_I*GC_MHH*cMHH**2d0* &
              rMHH**2d0/2d0 + GC_I*GC_MHH*cMHH**2d0*rMHL**2d0/2d0 + GC_I*GC_MHL&
              *cMHH**2d0*rMHH**2d0/2d0 - GC_I*GC_MHL*cMHH**2d0*rMHL**2d0/2d0   &
              ) + GC_103*GC_I*rMHL**2d0/(-GC_I*GC_MHH*cMHH**2d0*rMHH**2d0/2d0  &
               + GC_I*GC_MHH*cMHH**2d0*rMHL**2d0/2d0 + GC_I*GC_MHL*cMHH**2d0*  &
              rMHH**2d0/2d0 - GC_I*GC_MHL*cMHH**2d0*rMHL**2d0/2d0)) + dtHl_MS  &
              *(-GC_106*GC_I*rMHH**2d0/(-GC_I*GC_MHH*cMHL**2d0*rMHH**2d0/2d0 + &
              GC_I*GC_MHH*cMHL**2d0*rMHL**2d0/2d0 + GC_I*GC_MHL*cMHL**2d0*rMHH &
              **2d0/2d0 - GC_I*GC_MHL*cMHL**2d0*rMHL**2d0/2d0) + GC_106*GC_I*  &
              rMHL**2d0/(-GC_I*GC_MHH*cMHL**2d0*rMHH**2d0/2d0 + GC_I*GC_MHH*   &
              cMHL**2d0*rMHL**2d0/2d0 + GC_I*GC_MHL*cMHL**2d0*rMHH**2d0/2d0 -  &
              GC_I*GC_MHL*cMHL**2d0*rMHL**2d0/2d0))
  dZGMinusHMinus_MS = DeltaUV*(24d0*cima*GC_102*GC_107*GC_MHC + 24d0*cima*     &
                      GC_102*GC_107*(-GC_I*cMHC**2d0 - GC_MHC) + 2d0*cima*     &
                      GC_1055*GC_64*GC_MHC*cMHC**2d0 + 2d0*cima*GC_1055*GC_64* &
                      GC_MHC*(-cMHC**2d0 + 3d0*cMHH**2d0 + 3d0*cMW**2d0) + 6d0*&
                      cima*GC_108*GC_119*(-GC_I*cMHC**2d0 - GC_MHC) + 6d0*cima*&
                      GC_110*GC_119*GC_MHC + 6d0*cima*GC_110*GC_119*(-GC_I*cMHC&
                      **2d0 - GC_MHC) + 6d0*cima*GC_111*GC_116*(-GC_I*cMHC**2d0&
                       - GC_MHC) + 6d0*cima*GC_111*GC_118*GC_MHC + 6d0*cima*   &
                      GC_111*GC_118*(-GC_I*cMHC**2d0 - GC_MHC) + 24d0*cima*    &
                      GC_126*GC_127*GC_MHC + 24d0*cima*GC_126*GC_127*(-GC_I*   &
                      cMHC**2d0 - GC_MHC) + 6d0*cima*GC_1321*GC_63*(cMHH**2d0  &
                       + cMW**2d0)*(-GC_I*cMHC**2d0 - GC_MHC) + 2d0*cima*      &
                      GC_1505*GC_68*GC_MHC*cMHC**2d0 + 2d0*cima*GC_1505*GC_68* &
                      GC_MHC*(-cMHC**2d0 + 3d0*cMHL**2d0 + 3d0*cMW**2d0) + 2d0*&
                      cima*GC_154*GC_158*GC_MHC*cMHC**2d0 - 4d0*cima*GC_154*   &
                      GC_158*GC_MHC*(3d0*cME**2d0 - cMHC**2d0) + 12d0*cima*    &
                      GC_154*GC_158*cME**2d0*(GC_I*cMHC**2d0 + GC_MHC) + 2d0*  &
                      cima*GC_162*GC_166*GC_MHC*cMHC**2d0 - 4d0*cima*GC_162*   &
                      GC_166*GC_MHC*(-cMHC**2d0 + 3d0*cMM**2d0) + 12d0*cima*   &
                      GC_162*GC_166*cMM**2d0*(GC_I*cMHC**2d0 + GC_MHC) + 2d0*  &
                      cima*GC_185*GC_189*GC_MHC*cMHC**2d0 - 4d0*cima*GC_185*   &
                      GC_189*GC_MHC*(-cMHC**2d0 + 3d0*cMTA**2d0) + 12d0*cima*  &
                      GC_185*GC_189*cMTA**2d0*(GC_I*cMHC**2d0 + GC_MHC) - 3d0* &
                      GC_24*GC_I*cMHC**2d0*cMHL**2d0 - 3d0*GC_27*GC_I*cMHC**2d0&
                      *cMHH**2d0 - 3d0*GC_42*GC_I*cMHA**2d0*cMHC**2d0 - 3d0*   &
                      GC_43*GC_I*cMHC**2d0*cMZ**2d0 - 6d0*GC_44*GC_I*cMHC**4d0 &
                       - 6d0*GC_45*GC_I*cMHC**2d0*cMW**2d0 + 6d0*cima*GC_69*   &
                      GC_851*(cMHL**2d0 + cMW**2d0)*(-GC_I*cMHC**2d0 - GC_MHC  &
                      ) + 12d0*cima*GC_MHC*Nc*cMB*cMT*(-GC_138*GC_178 - GC_142*&
                      GC_181) + 12d0*cima*GC_MHC*Nc*cMC*cMS*(-GC_131*GC_174 -  &
                      GC_134*GC_170) + 12d0*cima*GC_MHC*Nc*cMD*cMU*(-GC_146*   &
                      GC_196 - GC_150*GC_193) - 2d0*cima*GC_MHC*Nc*cMHC**2d0*(-&
                      GC_131*GC_134 - GC_170*GC_174) - 2d0*cima*GC_MHC*Nc*cMHC &
                      **2d0*(-GC_138*GC_142 - GC_178*GC_181) - 2d0*cima*GC_MHC*&
                      Nc*cMHC**2d0*(-GC_146*GC_150 - GC_193*GC_196) + 4d0*cima*&
                      GC_MHC*Nc*(-GC_131*GC_134 - GC_170*GC_174)*(3d0*cMC**2d0 &
                       - cMHC**2d0 + 3d0*cMS**2d0) + 4d0*cima*GC_MHC*Nc*(-     &
                      GC_138*GC_142 - GC_178*GC_181)*(3d0*cMB**2d0 - cMHC**2d0 &
                       + 3d0*cMT**2d0) + 4d0*cima*GC_MHC*Nc*(-GC_146*GC_150 -  &
                      GC_193*GC_196)*(3d0*cMD**2d0 - cMHC**2d0 + 3d0*cMU**2d0  &
                      ) - 3d0*cima*GC_MHC*cMHC**2d0*(-GC_1055*GC_1505 + 2d0*   &
                      GC_1505*GC_68 - GC_63*GC_68) - 3d0*cima*GC_MHC*cMHC**2d0 &
                      *(2d0*GC_1055*GC_64 - GC_1055*GC_851 - GC_64*GC_68) + 6d0&
                      *cima*GC_MHC*(-GC_1055*GC_1505*cMHC**2d0 + GC_1055*GC_63*&
                      cMHC**2d0 + GC_108*GC_119 + GC_1505*GC_68*cMHC**2d0 -    &
                      GC_63*GC_68*cMHC**2d0) + 6d0*cima*GC_MHC*(GC_1055*GC_64* &
                      cMHC**2d0 - GC_1055*GC_851*cMHC**2d0 + GC_111*GC_116 -   &
                      GC_64*GC_68*cMHC**2d0 + GC_68*GC_851*cMHC**2d0) + 12d0*  &
                      cima*Nc*cMB*cMT*(GC_138*GC_178*GC_I*cMHC**2d0 + GC_138*  &
                      GC_178*GC_MHC + GC_142*GC_181*GC_I*cMHC**2d0 + GC_142*   &
                      GC_181*GC_MHC) + 12d0*cima*Nc*cMC*cMS*(GC_131*GC_174*GC_I&
                      *cMHC**2d0 + GC_131*GC_174*GC_MHC + GC_134*GC_170*GC_I*  &
                      cMHC**2d0 + GC_134*GC_170*GC_MHC) + 12d0*cima*Nc*cMD*cMU &
                      *(GC_146*GC_196*GC_I*cMHC**2d0 + GC_146*GC_196*GC_MHC +  &
                      GC_150*GC_193*GC_I*cMHC**2d0 + GC_150*GC_193*GC_MHC) +   &
                      12d0*cima*Nc*(cMB**2d0 + cMT**2d0)*(GC_138*GC_142*GC_I*  &
                      cMHC**2d0 + GC_138*GC_142*GC_MHC + GC_178*GC_181*GC_I*   &
                      cMHC**2d0 + GC_178*GC_181*GC_MHC) + 12d0*cima*Nc*(cMC**  &
                      2d0 + cMS**2d0)*(GC_131*GC_134*GC_I*cMHC**2d0 + GC_131*  &
                      GC_134*GC_MHC + GC_170*GC_174*GC_I*cMHC**2d0 + GC_170*   &
                      GC_174*GC_MHC) + 12d0*cima*Nc*(cMD**2d0 + cMU**2d0)*(    &
                      GC_146*GC_150*GC_I*cMHC**2d0 + GC_146*GC_150*GC_MHC +    &
                      GC_193*GC_196*GC_I*cMHC**2d0 + GC_193*GC_196*GC_MHC))/(  &
                      48d0*pi**2d0*GC_I*GC_MHC*cMHC**2d0) - 2d0*GC_111*dtHh_MS &
                      /(GC_MHC*cMHH**2d0) - 2d0*GC_119*dtHl_MS/(GC_MHC*cMHL**  &
                      2d0)
  da_MS = dZHhHl_MS/4d0 - dZHlHh_MS/4d0
  dl5_MS = -(-cima*DeltaUV*GC_100*GC_129/(8d0*pi**2d0) - cima*DeltaUV*GC_102*  &
           GC_15/(2d0*pi**2d0) - DeltaUV*GC_102*GC_1505*GC_1779/(16d0*pi**2d0  &
           ) - DeltaUV*GC_102*GC_72*GC_92/(8d0*pi**2d0) - DeltaUV*GC_102*GC_851&
           *GC_96/(16d0*pi**2d0) - cima*DeltaUV*GC_103*GC_22/(16d0*pi**2d0) +  &
           DeltaUV*GC_103*GC_63*GC_68/(16d0*pi**2d0) + DeltaUV*GC_103*GC_64*   &
           GC_69/(16d0*pi**2d0) - cima*DeltaUV*GC_105*GC_34/(32d0*pi**2d0) +   &
           DeltaUV*GC_105*GC_63*GC_64/(16d0*pi**2d0) - cima*DeltaUV*GC_106*    &
           GC_30/(32d0*pi**2d0) + DeltaUV*GC_106*GC_68*GC_69/(16d0*pi**2d0) +  &
           DeltaUV*GC_110*GC_1505*GC_68/(16d0*pi**2d0) - cima*DeltaUV*GC_110*  &
           GC_22/(8d0*pi**2d0) + DeltaUV*GC_110*GC_69*GC_851/(16d0*pi**2d0) -  &
           cima*DeltaUV*GC_111*GC_27/(8d0*pi**2d0) - cima*DeltaUV*GC_111*GC_44 &
           /(8d0*pi**2d0) + DeltaUV*GC_111*GC_63*GC_69/(16d0*pi**2d0) + DeltaUV&
           *GC_111*GC_64*GC_68/(16d0*pi**2d0) - cima*DeltaUV*GC_112*GC_42/(16d0&
           *pi**2d0) - cima*DeltaUV*GC_114*GC_40/(16d0*pi**2d0) - cima*DeltaUV*&
           GC_115*GC_41/(16d0*pi**2d0) - cima*DeltaUV*GC_116*GC_57/(16d0*pi**  &
           2d0) - cima*DeltaUV*GC_117*GC_56/(32d0*pi**2d0) + DeltaUV*GC_118*   &
           GC_1399*GC_17/(16d0*pi**2d0) + DeltaUV*GC_118*GC_1505*GC_64/(16d0*pi&
           **2d0) + DeltaUV*GC_118*GC_1779*GC_96/(16d0*pi**2d0) - cima*DeltaUV*&
           GC_118*GC_34/(8d0*pi**2d0) - cima*DeltaUV*GC_118*GC_51/(16d0*pi**2d0&
           ) + DeltaUV*GC_118*GC_63*GC_851/(16d0*pi**2d0) - cima*DeltaUV*GC_119&
           *GC_36/(8d0*pi**2d0) + DeltaUV*GC_119*GC_68**2d0/(16d0*pi**2d0) +   &
           DeltaUV*GC_119*GC_69**2d0/(16d0*pi**2d0) - cima*DeltaUV*GC_121*GC_50&
           /(32d0*pi**2d0) + DeltaUV*GC_121*GC_72**2d0/(16d0*pi**2d0) - cima*  &
           DeltaUV*GC_122*GC_49/(16d0*pi**2d0) + DeltaUV*GC_122*GC_69*GC_72/(  &
           16d0*pi**2d0) - cima*DeltaUV*GC_123*GC_48/(16d0*pi**2d0) + DeltaUV* &
           GC_123*GC_68*GC_72/(16d0*pi**2d0) - cima*DeltaUV*GC_125*GC_62/(4d0* &
           pi**2d0) - DeltaUV*GC_125*GC_63*GC_64/(16d0*pi**2d0) - DeltaUV*     &
           GC_125*GC_68*GC_69/(16d0*pi**2d0) - DeltaUV*GC_125*GC_72**2d0/(16d0*&
           pi**2d0) - DeltaUV*GC_126*GC_1399*GC_1505/(16d0*pi**2d0) - DeltaUV* &
           GC_126*GC_17*GC_851/(16d0*pi**2d0) - cima*DeltaUV*GC_126*GC_66/(2d0*&
           pi**2d0) - DeltaUV*GC_129*GC_1779*GC_96/(16d0*pi**2d0) - DeltaUV*   &
           GC_131**2d0*GC_133*Nc*cMC/(4d0*pi**2d0) - DeltaUV*GC_131**2d0*GC_173&
           *Nc*cMS/(4d0*pi**2d0) - DeltaUV*GC_131*GC_133*GC_170*Nc*cMS/(4d0*pi &
           **2d0) - DeltaUV*GC_131*GC_170*GC_173*Nc*cMC/(4d0*pi**2d0) - DeltaUV&
           *GC_133*GC_170**2d0*Nc*cMC/(4d0*pi**2d0) - DeltaUV*GC_137*GC_142**  &
           2d0*Nc*cMB/(4d0*pi**2d0) - DeltaUV*GC_137*GC_142*GC_178*Nc*cMT/(4d0*&
           pi**2d0) - DeltaUV*GC_137*GC_178**2d0*Nc*cMB/(4d0*pi**2d0) - DeltaUV&
           *GC_142**2d0*GC_180*Nc*cMT/(4d0*pi**2d0) - DeltaUV*GC_142*GC_178*   &
           GC_180*Nc*cMB/(4d0*pi**2d0) - DeltaUV*GC_146**2d0*GC_149*Nc*cMD/(4d0&
           *pi**2d0) - DeltaUV*GC_146**2d0*GC_195*Nc*cMU/(4d0*pi**2d0) -       &
           DeltaUV*GC_146*GC_149*GC_193*Nc*cMU/(4d0*pi**2d0) - DeltaUV*GC_146* &
           GC_193*GC_195*Nc*cMD/(4d0*pi**2d0) - DeltaUV*GC_149*GC_193**2d0*Nc* &
           cMD/(4d0*pi**2d0) - DeltaUV*GC_154**2d0*GC_157*cME/(4d0*pi**2d0) -  &
           DeltaUV*GC_162**2d0*GC_165*cMM/(4d0*pi**2d0) - DeltaUV*GC_170**2d0* &
           GC_173*Nc*cMS/(4d0*pi**2d0) - DeltaUV*GC_178**2d0*GC_180*Nc*cMT/(4d0&
           *pi**2d0) - DeltaUV*GC_185**2d0*GC_188*cMTA/(4d0*pi**2d0) - DeltaUV*&
           GC_193**2d0*GC_195*Nc*cMU/(4d0*pi**2d0) + GC_110*dZHlHh_MS/2d0 +    &
           GC_111*dZGMinusHMinus_MS + GC_118*dZHMinus_MS + GC_118*dZHh_MS/2d0  &
            - GC_22*dtHl_MS/cMHL**2d0 + GC_323*db_MS - GC_325*cMHA**2d0*cb**2d0&
           *dZee_MS*gw**2d0/(2d0*cMW**2d0*sb**2d0) + GC_325*cMHA**2d0*cb*db_MS*&
           gw**2d0/(2d0*cMW**2d0*sb**3d0) + GC_325*cMHA**2d0*cb**2d0*dMW2_MS*gw&
           **2d0/(2d0*cMW**4d0*sb**2d0) - GC_325*cMHA**2d0*cb**2d0*dMW2_MS*gw**&
           2d0/(4d0*cMW**4d0*sb**2d0*sw**2d0) + GC_325*cMHA**2d0*cb**2d0*      &
           dMZ2_MS*gw**2d0*sw**2d0/(4d0*cMW**4d0*sb**2d0) - GC_325*cMHA**2d0*cb&
           **2d0*dMZ2_MS*gw**2d0/(2d0*cMW**4d0*sb**2d0) + GC_325*cMHA**2d0*cb**&
           2d0*dMZ2_MS*gw**2d0/(4d0*cMW**4d0*sb**2d0*sw**2d0) + GC_325*cMHH**  &
           2d0*ca*da_MS*gw**2d0*sa/(2d0*cMW**2d0*sb**2d0) - GC_325*cMHH**2d0*cb&
           *db_MS*gw**2d0*sa**2d0/(2d0*cMW**2d0*sb**3d0) + GC_325*cMHH**2d0*   &
           dZee_MS*gw**2d0*sa**2d0/(2d0*cMW**2d0*sb**2d0) - GC_325*cMHH**2d0*  &
           dMW2_MS*gw**2d0*sa**2d0/(2d0*cMW**4d0*sb**2d0) + GC_325*cMHH**2d0*  &
           dMW2_MS*gw**2d0*sa**2d0/(4d0*cMW**4d0*sb**2d0*sw**2d0) - GC_325*cMHH&
           **2d0*dMZ2_MS*gw**2d0*sa**2d0*sw**2d0/(4d0*cMW**4d0*sb**2d0) +      &
           GC_325*cMHH**2d0*dMZ2_MS*gw**2d0*sa**2d0/(2d0*cMW**4d0*sb**2d0) -   &
           GC_325*cMHH**2d0*dMZ2_MS*gw**2d0*sa**2d0/(4d0*cMW**4d0*sb**2d0*sw** &
           2d0) - GC_325*cMHL**2d0*ca*da_MS*gw**2d0*sa/(2d0*cMW**2d0*sb**2d0   &
           ) + GC_325*cMHL**2d0*cb*db_MS*gw**2d0*sa**2d0/(2d0*cMW**2d0*sb**3d0 &
           ) - GC_325*cMHL**2d0*cb*db_MS*gw**2d0/(2d0*cMW**2d0*sb**3d0) -      &
           GC_325*cMHL**2d0*dZee_MS*gw**2d0*sa**2d0/(2d0*cMW**2d0*sb**2d0) +   &
           GC_325*cMHL**2d0*dZee_MS*gw**2d0/(2d0*cMW**2d0*sb**2d0) + GC_325*   &
           cMHL**2d0*dMW2_MS*gw**2d0*sa**2d0/(2d0*cMW**4d0*sb**2d0) - GC_325*  &
           cMHL**2d0*dMW2_MS*gw**2d0*sa**2d0/(4d0*cMW**4d0*sb**2d0*sw**2d0) -  &
           GC_325*cMHL**2d0*dMW2_MS*gw**2d0/(2d0*cMW**4d0*sb**2d0) + GC_325*   &
           cMHL**2d0*dMW2_MS*gw**2d0/(4d0*cMW**4d0*sb**2d0*sw**2d0) + GC_325*  &
           cMHL**2d0*dMZ2_MS*gw**2d0*sa**2d0*sw**2d0/(4d0*cMW**4d0*sb**2d0) -  &
           GC_325*cMHL**2d0*dMZ2_MS*gw**2d0*sa**2d0/(2d0*cMW**4d0*sb**2d0) +   &
           GC_325*cMHL**2d0*dMZ2_MS*gw**2d0*sa**2d0/(4d0*cMW**4d0*sb**2d0*sw** &
           2d0) - GC_325*cMHL**2d0*dMZ2_MS*gw**2d0*sw**2d0/(4d0*cMW**4d0*sb**  &
           2d0) + GC_325*cMHL**2d0*dMZ2_MS*gw**2d0/(2d0*cMW**4d0*sb**2d0) -    &
           GC_325*cMHL**2d0*dMZ2_MS*gw**2d0/(4d0*cMW**4d0*sb**2d0*sw**2d0) +   &
           2d0*GC_325*cb*db_MS*l5/sb**3d0 - GC_325*cb**2d0*dMHA2_MS*gw**2d0/(  &
           4d0*cMW**2d0*sb**2d0) + GC_325*dMHH2_MS*gw**2d0*sa**2d0/(4d0*cMW**  &
           2d0*sb**2d0) - GC_325*dMHL2_MS*gw**2d0*sa**2d0/(4d0*cMW**2d0*sb**2d0&
           ) + GC_325*dMHL2_MS*gw**2d0/(4d0*cMW**2d0*sb**2d0) + GC_327*cMHA**  &
           2d0*cb**2d0*dZee_MS*gw**2d0/(2d0*cMW**2d0*sb**2d0) - GC_327*cMHA**  &
           2d0*dZee_MS*gw**2d0/(2d0*cMW**2d0*sb**2d0) - GC_327*cMHA**2d0*cb**  &
           2d0*dMW2_MS*gw**2d0/(2d0*cMW**4d0*sb**2d0) + GC_327*cMHA**2d0*cb**  &
           2d0*dMW2_MS*gw**2d0/(4d0*cMW**4d0*sb**2d0*sw**2d0) - GC_327*cMHA**  &
           2d0*cb**2d0*dMZ2_MS*gw**2d0*sw**2d0/(4d0*cMW**4d0*sb**2d0) + GC_327*&
           cMHA**2d0*cb**2d0*dMZ2_MS*gw**2d0/(2d0*cMW**4d0*sb**2d0) - GC_327*  &
           cMHA**2d0*cb**2d0*dMZ2_MS*gw**2d0/(4d0*cMW**4d0*sb**2d0*sw**2d0) +  &
           GC_327*cMHA**2d0*dMW2_MS*gw**2d0/(2d0*cMW**4d0*sb**2d0) - GC_327*   &
           cMHA**2d0*dMW2_MS*gw**2d0/(4d0*cMW**4d0*sb**2d0*sw**2d0) + GC_327*  &
           cMHA**2d0*dMZ2_MS*gw**2d0*sw**2d0/(4d0*cMW**4d0*sb**2d0) - GC_327*  &
           cMHA**2d0*dMZ2_MS*gw**2d0/(2d0*cMW**4d0*sb**2d0) + GC_327*cMHA**2d0*&
           dMZ2_MS*gw**2d0/(4d0*cMW**4d0*sb**2d0*sw**2d0) - GC_327*cMHC**2d0*cb&
           **2d0*dZee_MS*gw**2d0/(cMW**2d0*sb**2d0) + GC_327*cMHC**2d0*dZee_MS*&
           gw**2d0/(cMW**2d0*sb**2d0) + GC_327*cMHC**2d0*cb**2d0*dMW2_MS*gw**  &
           2d0/(cMW**4d0*sb**2d0) - GC_327*cMHC**2d0*cb**2d0*dMW2_MS*gw**2d0/( &
           2d0*cMW**4d0*sb**2d0*sw**2d0) + GC_327*cMHC**2d0*cb**2d0*dMZ2_MS*gw &
           **2d0*sw**2d0/(2d0*cMW**4d0*sb**2d0) - GC_327*cMHC**2d0*cb**2d0*    &
           dMZ2_MS*gw**2d0/(cMW**4d0*sb**2d0) + GC_327*cMHC**2d0*cb**2d0*      &
           dMZ2_MS*gw**2d0/(2d0*cMW**4d0*sb**2d0*sw**2d0) - GC_327*cMHC**2d0*  &
           dMW2_MS*gw**2d0/(cMW**4d0*sb**2d0) + GC_327*cMHC**2d0*dMW2_MS*gw**  &
           2d0/(2d0*cMW**4d0*sb**2d0*sw**2d0) - GC_327*cMHC**2d0*dMZ2_MS*gw**  &
           2d0*sw**2d0/(2d0*cMW**4d0*sb**2d0) + GC_327*cMHC**2d0*dMZ2_MS*gw**  &
           2d0/(cMW**4d0*sb**2d0) - GC_327*cMHC**2d0*dMZ2_MS*gw**2d0/(2d0*cMW**&
           4d0*sb**2d0*sw**2d0) - GC_327*cMHH**2d0*ca*db_MS*gw**2d0*sa/(2d0*cMW&
           **2d0*sb**2d0) + GC_327*cMHH**2d0*ca*dZee_MS*gw**2d0*sa/(2d0*cMW**  &
           2d0*cb*sb) + GC_327*cMHH**2d0*ca*db_MS*gw**2d0*sa/(4d0*cMW**2d0*cb**&
           2d0*sb**2d0) - GC_327*cMHH**2d0*da_MS*gw**2d0*sa**2d0/(2d0*cMW**2d0*&
           cb*sb) + GC_327*cMHH**2d0*da_MS*gw**2d0/(4d0*cMW**2d0*cb*sb) -      &
           GC_327*cMHH**2d0*ca*dMW2_MS*gw**2d0*sa/(2d0*cMW**4d0*cb*sb) + GC_327&
           *cMHH**2d0*ca*dMW2_MS*gw**2d0*sa/(4d0*cMW**4d0*cb*sb*sw**2d0) -     &
           GC_327*cMHH**2d0*ca*dMZ2_MS*gw**2d0*sa*sw**2d0/(4d0*cMW**4d0*cb*sb  &
           ) + GC_327*cMHH**2d0*ca*dMZ2_MS*gw**2d0*sa/(2d0*cMW**4d0*cb*sb) -   &
           GC_327*cMHH**2d0*ca*dMZ2_MS*gw**2d0*sa/(4d0*cMW**4d0*cb*sb*sw**2d0  &
           ) + GC_327*cMHL**2d0*ca*db_MS*gw**2d0*sa/(2d0*cMW**2d0*sb**2d0) -   &
           GC_327*cMHL**2d0*ca*dZee_MS*gw**2d0*sa/(2d0*cMW**2d0*cb*sb) - GC_327&
           *cMHL**2d0*ca*db_MS*gw**2d0*sa/(4d0*cMW**2d0*cb**2d0*sb**2d0) +     &
           GC_327*cMHL**2d0*da_MS*gw**2d0*sa**2d0/(2d0*cMW**2d0*cb*sb) - GC_327&
           *cMHL**2d0*da_MS*gw**2d0/(4d0*cMW**2d0*cb*sb) + GC_327*cMHL**2d0*ca*&
           dMW2_MS*gw**2d0*sa/(2d0*cMW**4d0*cb*sb) - GC_327*cMHL**2d0*ca*      &
           dMW2_MS*gw**2d0*sa/(4d0*cMW**4d0*cb*sb*sw**2d0) + GC_327*cMHL**2d0* &
           ca*dMZ2_MS*gw**2d0*sa*sw**2d0/(4d0*cMW**4d0*cb*sb) - GC_327*cMHL**  &
           2d0*ca*dMZ2_MS*gw**2d0*sa/(2d0*cMW**4d0*cb*sb) + GC_327*cMHL**2d0*ca&
           *dMZ2_MS*gw**2d0*sa/(4d0*cMW**4d0*cb*sb*sw**2d0) + GC_327*ca*       &
           dMHH2_MS*gw**2d0*sa/(4d0*cMW**2d0*cb*sb) - GC_327*ca*dMHL2_MS*gw**  &
           2d0*sa/(4d0*cMW**2d0*cb*sb) + GC_327*cb**2d0*dMHA2_MS*gw**2d0/(4d0* &
           cMW**2d0*sb**2d0) - GC_327*cb**2d0*dMHC2_MS*gw**2d0/(2d0*cMW**2d0*sb&
           **2d0) - GC_327*dMHA2_MS*gw**2d0/(4d0*cMW**2d0*sb**2d0) + GC_327*   &
           dMHC2_MS*gw**2d0/(2d0*cMW**2d0*sb**2d0) + GC_331*cMHA**2d0*dZee_MS* &
           gw**2d0/cMW**2d0 - GC_331*cMHA**2d0*dMW2_MS*gw**2d0/cMW**4d0 +      &
           GC_331*cMHA**2d0*dMW2_MS*gw**2d0/(2d0*cMW**4d0*sw**2d0) - GC_331*   &
           cMHA**2d0*dMZ2_MS*gw**2d0*sw**2d0/(2d0*cMW**4d0) + GC_331*cMHA**2d0*&
           dMZ2_MS*gw**2d0/cMW**4d0 - GC_331*cMHA**2d0*dMZ2_MS*gw**2d0/(2d0*cMW&
           **4d0*sw**2d0) - GC_331*cMHC**2d0*dZee_MS*gw**2d0/cMW**2d0 + GC_331*&
           cMHC**2d0*dMW2_MS*gw**2d0/cMW**4d0 - GC_331*cMHC**2d0*dMW2_MS*gw**  &
           2d0/(2d0*cMW**4d0*sw**2d0) + GC_331*cMHC**2d0*dMZ2_MS*gw**2d0*sw**  &
           2d0/(2d0*cMW**4d0) - GC_331*cMHC**2d0*dMZ2_MS*gw**2d0/cMW**4d0 +    &
           GC_331*cMHC**2d0*dMZ2_MS*gw**2d0/(2d0*cMW**4d0*sw**2d0) + GC_331*   &
           dMHA2_MS*gw**2d0/(2d0*cMW**2d0) - GC_331*dMHC2_MS*gw**2d0/(2d0*cMW**&
           2d0) + GC_333*cMHA**2d0*dZee_MS*gw**2d0/(2d0*cMW**2d0) - GC_333*cMHA&
           **2d0*dZee_MS*gw**2d0/(2d0*cMW**2d0*cb**2d0) - GC_333*cMHA**2d0*    &
           db_MS*gw**2d0*sb/(2d0*cMW**2d0*cb**3d0) - GC_333*cMHA**2d0*dMW2_MS* &
           gw**2d0/(2d0*cMW**4d0) + GC_333*cMHA**2d0*dMW2_MS*gw**2d0/(4d0*cMW**&
           4d0*sw**2d0) - GC_333*cMHA**2d0*dMZ2_MS*gw**2d0*sw**2d0/(4d0*cMW**  &
           4d0) + GC_333*cMHA**2d0*dMZ2_MS*gw**2d0/(2d0*cMW**4d0) - GC_333*cMHA&
           **2d0*dMZ2_MS*gw**2d0/(4d0*cMW**4d0*sw**2d0) + GC_333*cMHA**2d0*    &
           dMW2_MS*gw**2d0/(2d0*cMW**4d0*cb**2d0) - GC_333*cMHA**2d0*dMW2_MS*gw&
           **2d0/(4d0*cMW**4d0*cb**2d0*sw**2d0) + GC_333*cMHA**2d0*dMZ2_MS*gw**&
           2d0*sw**2d0/(4d0*cMW**4d0*cb**2d0) - GC_333*cMHA**2d0*dMZ2_MS*gw**  &
           2d0/(2d0*cMW**4d0*cb**2d0) + GC_333*cMHA**2d0*dMZ2_MS*gw**2d0/(4d0* &
           cMW**4d0*cb**2d0*sw**2d0) - GC_333*cMHH**2d0*ca*da_MS*gw**2d0*sa/(  &
           2d0*cMW**2d0*cb**2d0) - GC_333*cMHH**2d0*dZee_MS*gw**2d0*sa**2d0/(  &
           2d0*cMW**2d0*cb**2d0) + GC_333*cMHH**2d0*dZee_MS*gw**2d0/(2d0*cMW** &
           2d0*cb**2d0) - GC_333*cMHH**2d0*db_MS*gw**2d0*sa**2d0*sb/(2d0*cMW** &
           2d0*cb**3d0) + GC_333*cMHH**2d0*db_MS*gw**2d0*sb/(2d0*cMW**2d0*cb** &
           3d0) + GC_333*cMHH**2d0*dMW2_MS*gw**2d0*sa**2d0/(2d0*cMW**4d0*cb**  &
           2d0) - GC_333*cMHH**2d0*dMW2_MS*gw**2d0*sa**2d0/(4d0*cMW**4d0*cb**  &
           2d0*sw**2d0) - GC_333*cMHH**2d0*dMW2_MS*gw**2d0/(2d0*cMW**4d0*cb**  &
           2d0) + GC_333*cMHH**2d0*dMW2_MS*gw**2d0/(4d0*cMW**4d0*cb**2d0*sw**  &
           2d0) + GC_333*cMHH**2d0*dMZ2_MS*gw**2d0*sa**2d0*sw**2d0/(4d0*cMW**  &
           4d0*cb**2d0) - GC_333*cMHH**2d0*dMZ2_MS*gw**2d0*sa**2d0/(2d0*cMW**  &
           4d0*cb**2d0) + GC_333*cMHH**2d0*dMZ2_MS*gw**2d0*sa**2d0/(4d0*cMW**  &
           4d0*cb**2d0*sw**2d0) - GC_333*cMHH**2d0*dMZ2_MS*gw**2d0*sw**2d0/(4d0&
           *cMW**4d0*cb**2d0) + GC_333*cMHH**2d0*dMZ2_MS*gw**2d0/(2d0*cMW**4d0*&
           cb**2d0) - GC_333*cMHH**2d0*dMZ2_MS*gw**2d0/(4d0*cMW**4d0*cb**2d0*sw&
           **2d0) + GC_333*cMHL**2d0*ca*da_MS*gw**2d0*sa/(2d0*cMW**2d0*cb**2d0 &
           ) + GC_333*cMHL**2d0*dZee_MS*gw**2d0*sa**2d0/(2d0*cMW**2d0*cb**2d0  &
           ) + GC_333*cMHL**2d0*db_MS*gw**2d0*sa**2d0*sb/(2d0*cMW**2d0*cb**3d0 &
           ) - GC_333*cMHL**2d0*dMW2_MS*gw**2d0*sa**2d0/(2d0*cMW**4d0*cb**2d0  &
           ) + GC_333*cMHL**2d0*dMW2_MS*gw**2d0*sa**2d0/(4d0*cMW**4d0*cb**2d0* &
           sw**2d0) - GC_333*cMHL**2d0*dMZ2_MS*gw**2d0*sa**2d0*sw**2d0/(4d0*cMW&
           **4d0*cb**2d0) + GC_333*cMHL**2d0*dMZ2_MS*gw**2d0*sa**2d0/(2d0*cMW**&
           4d0*cb**2d0) - GC_333*cMHL**2d0*dMZ2_MS*gw**2d0*sa**2d0/(4d0*cMW**  &
           4d0*cb**2d0*sw**2d0) - 2d0*GC_333*db_MS*l5*sb/cb**3d0 + GC_333*     &
           dMHA2_MS*gw**2d0/(4d0*cMW**2d0) - GC_333*dMHA2_MS*gw**2d0/(4d0*cMW**&
           2d0*cb**2d0) - GC_333*dMHH2_MS*gw**2d0*sa**2d0/(4d0*cMW**2d0*cb**2d0&
           ) + GC_333*dMHH2_MS*gw**2d0/(4d0*cMW**2d0*cb**2d0) + GC_333*dMHL2_MS&
           *gw**2d0*sa**2d0/(4d0*cMW**2d0*cb**2d0) - 2d0*GC_335*cMW*cb*dZee_MS/&
           gw - 2d0*GC_335*cMW*db_MS*sb/gw + GC_335*cb*cw**4d0*dMZ2_MS/(cMW*gw*&
           sw**2d0) - GC_335*cb*cw**2d0*dMW2_MS/(cMW*gw*sw**2d0) + GC_335*cb*  &
           dMW2_MS/(cMW*gw) + 2d0*GC_337*cMW*cb*db_MS/gw - 2d0*GC_337*cMW*     &
           dZee_MS*sb/gw + GC_337*cw**4d0*dMZ2_MS*sb/(cMW*gw*sw**2d0) - GC_337*&
           cw**2d0*dMW2_MS*sb/(cMW*gw*sw**2d0) + GC_337*dMW2_MS*sb/(cMW*gw) +  &
           GC_339*da_MS - GC_34*dtHh_MS/cMHH**2d0)/(-GC_325*cb**2d0/sb**2d0 +  &
           GC_327*cb**2d0/sb**2d0 - GC_327/sb**2d0 + GC_329 + GC_331 + GC_333  &
            - GC_333/cb**2d0)

  da_FJTS = cone*real(da_MS)
  da_PRTS = cone*real(da_MS + dtHhHl_PRTS_fin/(MHH**2d0 - MHL**2d0))

  db_FJTS = cone*real(db_MS)
  db_PRTS = cone*real(cb*sb*(dZHh_MS - dZHl_MS)/(-2d0*ca**2d0 + 2d0*sa**2d0    &
            ) + (dtHl*(ca*cb + sa*sb)/cMHL**2d0 + dtHh*(-ca*sb + cb*sa)/cMHH** &
            2d0)/vev)
  dl5_FJTS = cone*real(dl5_MS)
end subroutine initct
end module thdm_ct
